The Mini-Edit Users Guide

The Mini-Edit Tool Suite Users Guide

The Mini-Edit Users Guide
A users guide for both ITS standards author-creators (data stewards) and standard users (local deployment users). This guide documents how to usefully manipulate the data found in various files of the Mini-Edit tools to support deployment need and to create better standards and data dictionaries.

This document is available both in a printed format and as an on-line CHM help file. Press F1 from within the Mini-Edit tool to be taken to it.

Additional information about Mini-Edit and some of the the data files available from each SDO can also be found in the ITS standards support forum, a multi-SDO meeting place for exchanging information about the standards; see www.ITSstandards.org A sub-section of the forum deals specifically with the use of Mini-Edit tool and can be found here.

Acknowledgements
The development of the Mini-Edit tool has become a community effort spanning the course of many years, many organizations, and many individual persons' efforts. A few of these individuals and organizations are mentioned here.

The structure of the The Mini-Edit Users Guide

Each tool in the overall product has its own section in the guide. The major sections are below. If you press F1 from with a tool, this guide will open to the relevant page inside the revelant section. If you send a comment (link in the above right corner) back to the Mini-Edit support staff, the email subject will link to the page you were viewing when you sent your help query.

Getting Started
Installation Issues
Mini Edit Tool Guide
Processing Rules Reference
Registry Parser
1st Word Users Guide
Multi_Linker
Support Annexes

For Mini-Edit Release 2.1.444 and above.

Lasted updated on January 20th 2007

© SubCarrier Systems Corp. All Rights Reserved.


Getting Started

Glossary Item Box

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes

See Also MEdit Send comments on this topic.

Getting Started

Getting Started

Welcome to the Mini-Edit tool suite. This collection of tools, all referred to as Mini-Edit, is used by both standards authors (commonly called data stewards although anyone working on a standard may use the tool in this way) and standard deployers (commonly called users or local deployments).

This section deals with how to obtain the tool, where to go for help and support, and where to get the various databases that it reads. It also provides a bit of background about how the tool came to exist and what others are doing with it.

The structure of the Getting Started Section

Where to get it
Why it is here?
How is it used?
Credits
Legal Stuff

TOP NEXT->

See Also

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes


Where to get it

Where to get it

Where to get it

The Mini-Edit tools are provided free of charge to all who wish to use them. Of course there is the normal disclaimer of liability, which you should read here .

The most current copy of the Mini-Edit can always be obtained here.

If you would prefer the most stable major release, that can always be obtained here.

If this is the first time you have installed the tool on a machine, use the installer script to be sure you get all the parts you need. If you are simply upgrading (improved copies of the tool are released frequently)., then simply download the zip file and copy it over your current installation. If you want a specific older release for some reason, go here. Installation is covered in greater detail here.

The tool operates on access style data files which are in turn provided, and owned, by the standards developing organizations (SDOs), IEEE, ITE, ASTM, NEMA, ASHHTO, SAE etc. You can obtain the databases for their standards from them directly.

An additional tool, called 1st Word, is provided only to the standard developing organizations and is used to render out the complex printed standard that they develop, following the style needs of each. The users guide for 1st Word is provided as part of the the same over all CHM file here . If you feel you need this tool but do not have it, contact the Mini-Edit support team by email, and please state which standard and SDO you are working with. You can also contract the support staff by clicking on the send comments button found in the upper right of this screen from any page.

The user community forum for Mini-Edit can be found as a part of the the ITS standards forum. Or at <http://www.ITSstds.net/bb/viewforum.php?f=15> Membership in the forum community is free and many technical solutions to using the ITS standards can be found there as well as many of the training guides outlining different standards producing using the records of Mini-Edit. Have a problem using the tool that this help manual does not cover? This is the best place to seek answers.

<-LAST TOP NEXT->

See Also

Getting Started


Why it is here?

Why it is here?

Why it is here?

The development of Mini-Edit began in the late 90s as an in-house effort of SubCarrier Systems Corp (SCSC), which was at that time a contractor to the SAE and IEEE, (for the ATIS and Incident Management standards efforts). Its usefulness became apparent to other SDOs who requested that FHWA provide the funding to continue its development. At this point in time almost all of the ITS standards use Mini-Edit in the management of the data records and in the production of the final printed document and collateral materials (ASN, XML, WSDL). The continued support from FHWA, as well as the volunteer efforts of many ITS developers have brought the tool to its current state of development; see .

<-LAST TOP NEXT->

See Also

Getting Started


How is it used?

How is it used?

How is it used?

The typical standard committee has one database that is created to reflect each standard they develop. Normally, this database is divided into both simple and complex data concepts (data elements, data frames, messages and dialogs). Often one of the Tables in the database contains records which are re-used from other developed standards to provide data sharing and harmonization. The Mini-Edit tool handles the technical process of this data sharing, and it was originally created to promote more uniform data exchanges. These databases are routinely shared between the standards developers to coordinate work. A large set of both formal and ad hoc processing rules exist (taken from IEEE 1488/89, a standard on how data registries are to work) between the standards groups now, most of which are handled by Mini-Edit. Today, this sharing is a manual process; it is expected to become more automated in the future.

While the Mini-Edit tool was originally created for use in standards creation, it is increasingly being used by local deployment developers as a useful way to manipulate and extract data from multiple standards. Such users either create their own data records as needed, or add records to the local table of a database they have gathered from other standards. The typical application in this context is to merge multiple standards which are being used on a project, then use the tool to extract subsets, explore relationships, and create a set of ASN and XML for further use. The resulting locally created database can be documented as a reference baseline. Commonly available commercial tools can then be used to create code stubs and other artifacts of programming. Often this consists of removing details from the schemas of the standards (optional elements etc.) that are not required in the local deployment. Frankly, there is still a lot of profiling work to use an ITS standard at the local level. It is expected that Mini-Edit will continue to add features in support of this task.

<-LAST TOP NEXT->

See Also

Getting Started


Credits

Credits

This product exists today because of the tireless efforts invested by many persons associated with the development of ITS standards. Many of us have made the transition over the years from committee volunteers into the position of being paid consultants to the committees or organizations that we support. Still, there has always been a strong volunteer spirit to "do it the right way" and a willingness to expend the time and effort needed to address the needs of real practitioners in crafting the data dictionaries and message sets. No one, in any of this, has ever had a funded task to "work out how the data registry process should evolve" although this has often been the net result. The principal authors of the various standards (the data stewards in most cases) have given of their own time and developed a sense of reciprocal trust with each other that has improved the standards considerately over the span of years.

That being said, four organizations should be expressly mentioned here.

The SAE provided the initial formal contract oversight and funding channel to improve Mini-Edit from an in-house tool to something for community use and to move it to becoming a necessary part of the standards production and sharing process.

The IEEE took over the role of the SAE when conditions changed there and remains today the formal contract oversight and funding channel for this tool support. Under this oversight, all the SDOs were polled and a list of the then most critical required features were outlined, funded, and built into the tool. This is expected to be the method used and any further formal tool advances.

The FHWA-JPO saw the need for this tool and was willing to fund its on-going development. While FHWA monies for this task are slight when compared to other efforts, all concerned are most grateful for the project funding and see it as a very cost effective data sharing investment. FHWA, of course, sees the critical need for consistent quality in the ITS standards which is a product of this.

Finally, while each and every committee and data steward that has used these tools has contributed value to the development process, one organization stands above the rest for their ceaseless support, technical assistance, and vision of ITS standards meeting a level of uniform quality. That would be the staff of Mitretek Systems who have worked with the Mini-Edit development team for over five years now to address new challenges to the standards and the deployments as they occur. For example, today all of the XML found in ITS follows consistent formats and styles (rather then being different towers of babble) due in large part to the technical leadership of this group.

No man is an island (John Donne 1573-1631 Meditation XVII, Devotions Upon Emergent Occasions)

And neither is any useful tool.
This edition of the tool, and these help pages,
are dedicated to all those that have brought it so far along.

<-LAST TOP NEXT->

See Also

Getting Started


Legal Stuff

Legal Stuff

The legal terms of use for Mini-Edit can be found here and are reprinted below for your convenience .

Disclaimer for use of the Mini-Edit tools

This program was developed by SubCarrier Systems Corporation (SCSC) for the benefit of persons working with and developing ITS standards and entries for the community data registry programs being developed as part of the cooperative agreement between Dept of Transportation Joint Program Office (DOT-JPO), Federal Highway Administration (FHWA), and multiple standards setting organizations including:

The American Society for Testing and Materials, International ( ASTM ),

The American Public Transportation Association (APTA), and others.

The Institute of Electrical and Electronics Engineers (IEEE),

The Institute of Transportation Engineers (ITE),

The National Electrical Manufacturers Association (NEMA),

The National Transportation Communications for ITS Protocol ( NTCIP ) (a Joint effort of ASSHTO , ITE and NEMA)

The Society of Automotive Engineers (SAE),

And of course, the FHWA JPO Standards Program itself.

Its purpose is to assist data authors and stewards engaged in preparing standards to develop their own committee work. By exchanging properly structured and formatted entries between ITS systems, coordination between all affected users is made easier. Technical support for users of the Mini-Edit program can be obtained here as part of the overall multi-SDO support forums.

Copyright (c) 2002~2006 SubCarrier Systems Corporation (SCSC)

Terms of use: This is a utility program and no guarantee regarding its fitness for any purpose is made by SCSC, its agents, any agent of the US government, any standards organization, its committee members or consultants. Use of this program and/or the accompanying source code or work products is entirely at your own risk. By using this program you are agreeing to these terms.

Grant of use: Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to use the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell any work product produced by the Software, and to permit the use of such work products by persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.

IN NO EVENT SHALL THE AUTHORS, THE DISTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Have a nice day anyway,
SCSC Management

<-LAST TOP

See Also

Getting Started


Installation Issues

Glossary Item Box

Getting Started: Getting Started

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes

See Also MEdit Send comments on this topic.

Installation Issues

Installation Issues

This section deals with various information you may need when installing Mini-Edit or integrating it with other tools in your system.

The structure of the Installation Issues

Installing the Mini-Edit tools for the first time
Upgrading the Tools
System Requirements
Organizing your files
Required Files
Registering Support Tools

NEXT->

See Also

Getting Started: Getting Started

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes


Installing the Mini-Edit tools for the first time

Installing the Mini-Edit tools for the first time

Installing the Mini-Edit tools for the first time

Installing the program is done by way of a common installer script which will place the program (and various associated supporting files) into your program files and install any needed DLLs, Active-X, or other components.

A note for users with registry or internet protection: The program does not access the Internet at this time, therefore it does not need permission to do so. It does write to the registry (registering itself as the application which reads *.ITS files and providing the icons needed). During operation, if you save sets of macro strings for use in the Spelling editor, these are also saved by way of the registry. As a rule, you may want to disable your protection during the installation process.

There is no need for other programs to be installed, however this is most helpful for the actual use of Mini-Edit; see the section on Registering Support Tools for further details.

The most current copy of Mini-Edit can always be obtained at the ITS standards forum in the Mini-Edit sub forum here.

<-LAST TOP NEXT->


Upgrading the Tools

Upgrading the Tools

Upgrading the Tools

There are frequent updates to the Mini-Edit tools, and you may want to upgrade as these come out to take advantage of new features. Typically the upgrades come in one of two ways; both can be obtained here.

A zip file Method

The most common upgrade is simply a zip file (named Medit_Rxxx where xxx is the build number of that release). To install, simply drop the provided files on top of your existing Mini-Edit installation folder, overwriting the files. Typically these upgrades contain the Mini-Edit application file and the Medit setting file (MEdit_Settings.mdb), which are always issued in pairs. If any other files have changed, they are included in the package as well. A file called Release_Notes.doc is also provided and lists the highlights of recent changes.

An Installer Method

When more extensive changes have occurred, an installer script is provided. This script will handle the details of any ActiveX of DLLs which need to be provided, install them and register them. If the user has a more current release, the script will not overwrite it (normal Windows behavior).

It should be noted that as of release 2.1 (Release Number 410 and beyond) when the new integrated spelling editor was added, we have been using installer scripts to ensure all users will have a properly registered copy of the spell checker installed.

Major stable releases always have an installer script provided with them. If you prefer NOT to have the most current beta release, stick with the installer script releases.

The Help Files

In, addition you can always find the most current help files in their on-line web form here.

The CHM file used by the Mini-Edit tools can be downloaded directly from here - place it in the same directory as Mini Edit.

The installer script bundles the CHM file, so you need not download it separately.

A tip for users of older Mini-Edit tools. Prior to the revision 2.x.x edition, the tool was installed in a folder called "../Mini-Edit" which will still be present once you install the current revision, which is placed in "../MiniEdit" (note the prior folder used a "-"). If you wish to remove this older version, simply drag the folder to the trash after removing any data files you may wish to keep (move these to the new folder). While it is possible to keep and run multiple copies of the current Mini-Edit tool, this is not advised because when each copy of the tool is run it will register itself as the de facto application and this can result in unexpected folder and data choices.


System Requirements

System Requirements

The Mini-Edit system will operate on any Microsoft Windows environment from the final service pack release of Win95 to today's WinNT and WinXP systems.

It works on personal, professional, and server releases of all of these.

It runs on WinNT- 2003 servers, but has not been tested on 64 bit systems.

Although Win95 is supported, it is not recommended. Windows 2000 and Windows XP are the preferred environments.

It is not essential to have the following common software in your machine, but it is rather helpful. See the page on Registering Support Tools for further information.

  • Microsoft Word -- To produce reports from the database
  • Microsoft Access -- To edit the ITS table files directly
  • Microsoft NotePad -- As a poor man's code and text editor

<-LAST TOP NEXT->

See Also

Registering Support Tools


Organizing your files

Organizing your files

Organizing your files

The typical and preferred way to use Mini-Edit is to keep the ITS database files (the *.ITS or *.MDB files) you need in the same directory as the application. The other provided application tools and support files also reside in this directory. If these are found to be missing when the tool is started, various warnings are produced. If this folder ordering is followed, then many times default file names and paths will be filled in for you in dialogs.

Aside: This is somewhat different from the method used by older copies of the tool, when it was possible to have a unique copy of the tool placed into each different folder. Because the tool registers itself with the system now, such multiple copies can cause problems and should be avoided.

The exception to this rule is the use of 1st Word. This application can be placed anywhere you desire. The most common style of use is to create a separate folder with the major components of your final document in it. Place into it a copy of 1st Word and a copy of the Mini-Edit settings file. Place into it all the component parts needed to build your final document (the template file you use, any included files, any included images or figures). When ready to run off a document, transfer a current copy of the database file to this folder, click on 1st Word, click on your default preferences, and go. Regardless of the folder organization you choose, your document will have a complete set of timestamps and file paths of all documents used in its creation listed on the final page.

A word about file naming: Most SDOs choose to use a file naming format that is a combination of the standard and its revision or release so that they can tell at a glance what edition of data it is. For example, the file ATIS_3_0_r74.its is the SAE Advanced Traveler Information (ATIS) standard, officially called SAE J2354, and this file would be revision 74 of that file. Its major and minor revisions would be 3 and 0 respectively. If you will be creating your own database files, a similar naming may be useful to you.


Required Files

Required Files

The following key files are installed with Mini-Edit. The database files are required to be present in order to run the tool. The XML ASN and TXT files are not needed to run the tool, but may be needed in order for some features to work. You will need these files to create various reports, and can modify the style of the report by changing the styles in these files. Some of the files (such as the included code files) will be used in the production of XML or ASN if present and if not will simply be skipped. This allows you to control how some code files are built and what content they will contain apart from data concepts found in the database tables.

Required Database Files

ATIS_EXAMPLES.mdb -- An older file which is used as a placeholder for the tool when no other database is selected. It is a file from the early days of the tool and none of the information found in this file is currently valid in any standard.

blank.ITS -- An empty file which is used as a starting point when a new table is to be created.

MEDIT_Settings.mdb -- The file which contains all the information regarding control word lists, the structure of the tables, patterns used in ASN and XML, common misspellings and corrections, the names of source standards, and other information needed to make Mini-Edit run.

USER_Settings.mdb -- The file which contains all the information regarding the individual local user, his name and other basic rights information. This is a relatively new table and is expected to grow in content over time.

Required and Created Text Files
(all of these files can be edited with a simple text editor)

ASNstubs.txt -- The name of a file which, if found, will be merged into the bottom of the Source.ASN file produced by the tool. This allows a global include to occur. Note that this include occurs outside the scope of any other module name.

errorLog.xml -- During the process of converting XML, this file may be created if there are any errors found. It is used to hold the error messages when you fire off a browser view. If you have a favorite editor, register it (associate it) to open XML type files, otherwise register your browser to do this (if it is not already registered).

FADD-Draft-XX-XX-XX.xsd -- The file is produced by an XML schema export function, where FADD is replaced by the proper FADD name and XX-XX-XX is replaced by the release version string. This file is typically placed into the ../ITSschemas/ folder unless the user indicates otherwise.

FADD-Draft-XX-XX-XXimports.xml -- The name of a file which, if found, will be merged into the bottom of the XML schema file produced by the tool for that FADD namespace. This allows a FADD specific include to occur.

FADD-Local-Draft-XX-XX-XX.xsd -- The file produced by an XML schema export function of a local table, where FADD is replaced by the proper FADD name and XX-XX-XX is replaced by the release version string. This file is typically placed into the ../ITSschemas/ folder unless the user indicates otherwise.

FADDstubs.txt -- The name of a file which, if found, will be merged into the bottom of FADD namespace area in the Source.ASN file produced by the tool, if the FADD namespace is included. Note that this include occurs inside the scope of the FADD module name. The term FADD would be replaced with the name of the module in question (ATIS, ADUS, IM, TMDD, etc.) as needed. This allows a module specific include to occur.

FILENAME_linkSet.xml -- The name of a file which is produced as an artifact of the linking process by 1st Word. The data present in the file is used by other tools to merge links across different files when needed. It contains the complete set of links to be found in that document (the bookmarks). The name of the file is the name of the created document with _linkSet.xml added to it.

Scrap.asn -- During the process of editing, this file is used to hold the data when you fire off an ASN text editor. If you have a favorite editor, register it (associate it) to open ASN type files, otherwise register Notepad to do this.

Scrap.xml -- During the process of viewing XML, this file is used to hold the data when you fire off a browser view of it. If you have a favorite editor, register it (associate it) to open XML type files, otherwise register your browser to do this (if it is not already registered). Typically your browser will also apply colored highlighting and indenting, making it easier to read.

Source.ASN -- The default name of ASN source files written out by the tool.

XML_OUT.xml -- A file produced by a bulk XML style which exports one or more tables from the tool. Every field in the table is represented by XML tags and content. This is to allow importing the record into other tools which read XML.

Required and Created MS Word Files
(all of these files can be edited with Microsoft Word)

Bulk_Template.doc -- A document used as the starting place for user created reports (the final report is normally called ShortReport.doc if it represents a single record and BulkReport if it represents a table).

BulkReport.doc -- During the process of creating a report from a table (from the bulk template) this file is created and displayed. You should re-name it if you do not want it overwritten when the next report is created.

Generic_Template.doc -- A document used as the starting place for reports and standards created with the 1st Word tool.

Legal.doc -- A document which states the usage term of the tool and disclaims liability resulting from its use by all parties.

Release_notes.doc -- A document which summarizes the changes and improvements present in each release of the tool.

scrap.doc -- A document created to hold a fragment of word style text for further editing.

scrap.rtf -- During the process of translating from rich text format (RTF) entries (which is kept in the access tables) into the format used by MS Word, small bits of translated text are saved into this file. This file is also used to hold the data when you fire off word to edit an entry such as the description text of a record.

ShortReport.doc -- During the process of creating a report from a record (from the bulk template) this file is created and displayed. You should re-name it if you do not want it overwritten when the next report is created.

Web_Template.doc -- During the process of creating a web page from a record, this file is used to hold the styles used in the rendering. You may change in various ways and may want to put an HTML link to the top of you overall web page system in the header or footer sections.


Registering Support Tools

Registering Support Tools

Registering Support Tools

One of the major design goals of the Mini-Edit team was not to replicate features that could be done better in other existing tools. Examples of this include using Microsoft Word and/or Notepad, a much better text editor than simple text; using a real ASN compiler and not just the primitive one found in the tool; using commercially available XML tools to validate the schemas, using a browser to view it, etc.

As a rule, you can do anything you need to do inside the confines of Mini-Edit, but you can do it better, faster and with less pain if you make use of other tools. Because different users will prefer different tools, the Mini-Edit approach is to fire off whatever tool the user has registered for that specific type of content. This is typically initiated with a small E (for Edit) button or by pressing a button labeled View.

Returning content to the Mini-Edit tool is by way of the clip board and the Mini-Edit tool will accept text, rich text, XML, ASN and any number of other formats, translating things as needed.

A brief summary of how to register (associate) a file type with a program to run it.
Right-click on the file to be opened, and select Open with... select program. After a short pause you will be shown a list of known programs; choose the one with which you want to open this file and file type. Select the check box so that this association is remembered.

The following document types are used by Mini-Edit. The programs suggested here are simply typical, and not intended to be an endorsement of any vendor or product.

*.TXT Text Files, can be opened by Notepad or WordPad or your favorite text editor (programmers often prefer a certain editor, such as the C++ editor provided with Microsoft Visual Studio). No registration action required by most users.

*.DOC Microsoft Documents, can be opened by MS Word. Those without word can use WordPad as a less featured substitute. Used for most reports created by the tool. No registration action required by most users.

*.RTF Rich Text Format, can be opened by MS Word. Those without word can use WordPad as a less featured substitute. Used in interim temporary files, there is no reason to ever edit these directly. No registration action required by most users.

*.MDB Microsoft Access files, can be opened by Access as well as many third party tools. The older data files were kept in this format; now they are kept in the *.ITS formats (which is the same underlying file type). You do not need to have MS Access on your machine to use Mini-Edit (which uses the underlying Jet engine to manipulate the actual file), but it is very helpful if you want to examine the tables directly. The two settings files (MEdit_Settings.mdb and USER_Settings.mdb) are in this format. No registration action required by most users.

*.ITS File type used by the Mini-Edit tool and registered to open with that tool. The files themselves are simply *.MDB types and you may want to also register MS Access to open this type of file. There is also an obscure internet bundle file with this extension. Do not attempt to change older style *.MDB file to be *.ITS files, the tool will automatically give you the option to convert such files on open (and will deal with structural changes in the tables) if a similar file with the extension *.ITS does not exist. No registration action required by most users.

*.ASN Files with ASN.1 type content encoded as plain text files. This extension is used to connect to an ASN complier and validate the code listing. It is suggested that you also register your favorite text editor to open this type. If you do not have a favorite, it is suggested that you register notepad. An excellent (free) ASN syntax validating complier can be obtained for free from OSS; please see this thread at the ITS standards forums for further directions. Registration action required by most users.

*.XML Files with xml content or xml fragment or bits of schemas or WSDL content. Any number of tools exist to read and display this content, but frankly this author has always found using a common browser like Internet Explorer to be sufficient. Such browsers have color highlighting that increases readability. Typically such tools display only the content; they do not validate it against various schema rules. Registration action may or may not be required by individual users; it depends on your system.

*.XSD XML schema file content. Any number of tools exist to read, display and validate this content. For example the tool XML Spy enjoys a large market share. Pick one; many are cheap or free. If you do not acquire such a tool, at least register the file type with your browser so that you can view it there or drag such files into it. Registration action may be required by individual users; it depends on your system.

*.WSD Web service description files, encoded as XML in plan text. Handled as per XML or XSD files unless you have a tool you specifically prefer for WSDL files.

*.HTM Common HTML files. There is no need to have an HTML editor on your system in order to view, or edit, these files - but of course it is helpful if you plan to do it often. Your current browser is already registered to handled them. Any number of tools exist to read and display this content; pick one if you expect to be editing such files. Registration action may be required by individual users; it depends on your system.

<-LAST TOP


Mini Edit Tool Guide

Glossary Item Box

Getting Started: Getting Started

Installation Issues: Installation Issues

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes

See Also MEdit Send comments on this topic.

Mini Edit Tool Guide

Mini Edit Tool Guide

The Mini-Edit tool is the heart of the Mini-Edit tool suite. It is the primary tool used to edit and view the data records. It also launches several other tools such as the 1st Word rendering tool, which provides other enhancements (1st Word takes the data records and renders them into complex printed documents). If you prefer to view the tool suite as an integrated design environment, then the Mini-Edit tool is the framework, launching whatever other tools you have registered on your machine to perform various tasks.

See the section in Installation Issues for additional data on how to configure your computer so that other tools work with Mini-Edit.

This section provides a screen-by-screen summary of the tool and all its various controls. You can also reach the relevant page of this section at any time from the tool itself by pressing F1 from within the window or Dialog you wish to learn about.

The structure of the Mini Edit Tool Guide

Startup Screen
About Mini-Edit
System Information
Mini-Edit Main Screen
Main Screen, Primary Controls
Main Screen, Record Controls
Table to View
File Open
Link table set
Mild Error Messages
Export Formating (Old Style)
Export (New XML Style) before run
XML Export Post-Run
Table Manager
Quick-Edit Text Table Entries...
Link Cross-Link report..
Editing record, terse view
Editing record, verbose view
XML Editor Basics
XML Editor Controls
XML Editor Advanced Controls
Rule Selection
Record Entry Error Report
Creating new entries...
Name the new entry...
Delete Record...
Create web page documentation...
About to launch Dialog
Not installed here..
Rich Text Editing and Spelling
Find and Replace Rich Text
Spelling Error Dialog
AutoType Manager
Missing ATIS DB alert
File dates conflict warning
User file missing alert

NEXT->

See Also

Getting Started: Getting Started

Installation Issues: Installation Issues

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes


Startup Screen

Startup Screen

This is the basic flash-screen which appears when Mini-Edit is first run. It shows the revision of the tool you are using. In the upper right corner are the "days remaining" which provides a gross indicator of how old this copy of the tool is. When this number falls below 30 days you are presented with some nag text suggesting that you upgrade to a more current version (see Upgrading for details of this process). The tool will continue to work indefinitely after the time period expires, but it is often in your best interest to use the most current tool to have access to the latest features.

1 OK button

OK button Press this button to accept the usage statement and proceed.
[Top]

2 Decline button

Decline button Press this button to decline the usage statement and exit the tool.
[Top]

3 Read it... button

Read it... button Press this button to read the usage statement; the About Mini-Edit screen is then displayed which basically disclaims the DOT-FHWA, all the Standards Organizations and their agents, and SCSC of any liability arising from your use of this tool. The same text can be reviewed here.
[Top]

4 Release

Release The release of the program is shown here. It is also shown in the upper left hand coner of the main window.
[Top]

5 Command Line Arguments

Command Line Arguments Any command line arguments passed to the program by another program (such as command to open a file) will be shown here if the program is initially launching.
Running the tool from the command line is expected to be an area of future growth.
[Top]


About Mini-Edit

About Mini-Edit

A basic summary of the terms of use. This screen repeats the release version and time data of the startup screen. It also provides direct access to the help manual which you are now reading, as well as the various support functions for Mini-Edit found on the www.ITSstandards.org forum. The Systems Information button is useful in diagnosing complex compatibility issues.

1 Link Button

Link Button Clicking on this icon will open a browser window and take you to the the Mini-Edit download page.
[Top]

2 Help System

Help System Clicking on this button will open this help file in a CHM format in its own window.
The initial display will be at the top of the table of contents.
You can also press the F1 key throughout the program to open a more contextually sensitive and relevant section of the help system.
[Top]

3 Usage Terms

Usage Terms Clicking on this button will open a browser window and display the complete usage text; this document page is saved in your application folder and contains various links to each of the SDOs that use this tool in standards production for ITS. See also here.
[Top]

4 System Info

System Info Clicking on this button will open the System Information Dialog window, which displays various settings and information about your computer which can be useful in trouble shooting applications.
[Top]

5 ITSstds.com

Clicking on this icon will open a browser window and take you to the top page of the www.ITSstandards.org web site. You can then search the site for your questions or post an inquiry for additional help. Note that most of the standards that use Mini-Edit have a sub-forum here which is moderated by some person closely connected with that standard, hence posting inquiries here is often the fastest way to find the relevant expert in that area.

[Top]

6 Tech Support

Tech Support Clicking on this icon will open a browser window and take you to the Mini-Edit support forum area of the www.ITSstandards.org web site. You can then search the site for your questions or post an inquiry for additional help.
[Top]

7 OK

OK Clicking on this button will dismiss this Dialog and return the underlying screen.
[Top]


System Information

System Information

The System Information View provides a simple tool to explore various settings of the user's machine. This screen is used in the rare event of problems with a Mini-Edit installation, although many users have come to use it to learn about their machine.

None of this information is kept by Mini-Edit, nor is it stored in any of the databases produced by the tool.


Mini-Edit Main Screen

Mini-Edit Main Screen

Mini-Edit Main Screen

This is the Main Window of Mini-Edit and is shown with a typical display after the tool has started but before any files has been selected to be opened. The next several pages describe the major sections of this window and the function of each control.

This window is complex, so its controls are covered in three pages. The next two sections describe the Primary Control group (used to manipulate entire tables) and the Record Control group (used to manipulate individual records in the current table). These page in turn delve into the practical use of the tool and it abilities.

Most of the operations of the tool deal with first selecting a single database file to operate on, which is then loaded and then one of its tables is displayed in a summary fashion. Most operations deal with selecting a single record from the list and then operating on it further as needed using the indivdual record controls (see above link). Various bulk exporting functions as well as transfer operations on entire tables (sets of records) are also provided (see the primary control group above).

The first time you run Mini-Edit the tool will ask you for a short set of information about yourself such as what user name you want to use. This can be repeated and the values changed at any time by pressing the User button above. If the values saved are the initial default values, the machine will prompt you for real values every time it is first run.

1 Open File

Open File The file open button. The tool defaults to active state but with no file open when started (unless you double-click an ITS file, in which case that file is opened). Various controls are dimmed until a file is opened to operate on. The tool prompted the user to select a file to open.
[Top]

2 Log-Status Display

Log-Status Dislpay The running log and status is displayed in this area. The log is always available for review at any time by pressing the Log button on the main screen. The size of the log area will expand to present a view which obscures the data grid area when longer operations are being performed (such as opening a file or extensive conversion operations). A progress bar appears at the bottom of the log during longer operations.

The log also provides insight into operations of the tool when firing off other programs, or if some needed file can not be found. Which user identity was loaded and any checks performed for more current data are reported (at this time no internet checking for updates occurs).

When examining an entry in the data grid, the log view provides a snapshot summary view of the text or codes associated with that entry; see the Snapshot View control in the Main Window section for control of this.
[Top]

3 Exit button

Exit button The exit button provides a way to close the tool and close all open database files (any pending un-saved changes would be lost). Any connections to other tools launched under automation will be lost, although those tools will typically remain active until closed in their own environment. Exit can also occur by clicking the top right button in the window frame.
[Top]

<-LAST TOP NEXT->

See Also

Main Screen, Primary Controls | Main Screen, Record Controls


Main Screen, Primary Controls

Main Screen, Primary Controls

Main Screen, Primary Controls

This page deals with the primary controls of Mini-Edit, arranged along the right hand side of the window. A short summary of the other controls, such as those dealing with table selection is given, but these are explained in greater detail in the next few pages.

The controls listed on the right hand side of the window deal mostly with the entire active file or with the entire active table in that file. A few deal with the tool settings. None deal with individual records of a table (this is mostly handled in the edit-view Dialog). The controls dealing with the individual records are covered on the next page.

1 Current File

Current File The current selected file name is reflected in the application window title as well as its read-write state (the file is shown in a read-only mode, indicating that the Read-Only check box is checked).
[Top]

2 Table to View

Table to View This control allows the selection of which table is currently loaded into the data grid in the center of the window.

Key concept: Most operations (editing, saving, translating, rule checking, etc.) of the tool operate on the current record of the current table in the currently loaded file.
Additional information about these tables, their names and what they normally contain, can be found here.
[Top]

3 Data Grid

Data Grid The data grid displays the first few columns of all the records in the currently selected table. A data grid is the Microsoft term used for the collection of excel-like cells shown at right. When no table is selected this grid is blank. When no file is loaded the grid is hidden. You can slide the relative sizes of the cell in the grid to a limited degree if needed. You can select-pause-select to copy data from a field in the displayed grid. You can not edit the content of the grid; use the Edit Window to do that. You can control the alphabetic order in which the records are displayed with the Sort-By control (below). Above the data grid some additional information about the FADD and registration status of the current record are displayed.

Hint: A good way to quickly launch the Edit-View window for a record is to double click along the left hand side of the data grid for that entry (not in the textual area).

[Top]

4 Sort-By control

Sort-By control This controls the alphanumeric ordering of the records displayed for the current table. When no check boxes are checked, the native ordering of the records will be used (this varies by each SDO convention). The first check box causes the alphanumeric order to be based on the Descriptive Name field. The second check box causes the alphanumeric ordering to be based on the ASN Name field. If both boxes are checked, than the SQL call orders the returned data by the descriptive name followed by the ASN name.
Keep in mind the system uses the SQL ordering and sorting methods as well as your local windows sorting preferences, so that values like "11" appear after "1" and before "2", which can at time cause confusion. You may want to number things with a leading zero ("01") if this annoys you.

[Top]

5 Snapshot View

Snapshot View This controls the snapshot view of the data which is placed in the log areas when a record is selected. Often this is enough information to answer a question and avoid opening the edit view where all the data of the record is displayed. The control selects one of three possible modes. You can toggle between the modes when a record is selected. Depending on the mode selected, the first few lines of text for relevant entries are displayed. The choices are:

Description Text | Natural language parts of the record, descriptive Name text, remarks.
ASN.1 Code | A view of the ASN code segments of the record.
XML Schema | A view of the The XML code segments of the record.

[Top]

6 Select Source File (Open)

Select Source File The Open... button (formally called source) allows the user to select a database file to examine and open; see here for additional details.

[Top]

7 Display Log

Dsiplay Log This displays the current accumulated log for the application while the tool is active. The log is cleared each time the tool is first opened, or when it becomes very large (in which case only the older part of removed). The log contains a collection of recorded events and actions over the life of the application. It typically also contains error messages that you may want to go over after processing a batch of records.

[Top]

8 About

About The About button displays the About Mini-Edit Dialog window, which has some basic information about the tool as well as some buttons which will take you to both on-line help and to this manual.

[Top]

9 Read-Only

Read-Write This check box controls the overall file read-only flag setting for the currently loaded file setting. When the box is checked NO user changes to the records of the file will be made (certain automatic structure updating will always occur to keep the file up to date if it is opened). Some control buttons are disabled when in the read-only mode.
[Top]

10 Table Manager

Table Manager This control brings up the Table Manager Dialog, used to manage and merge records between tables.
[Top]

11 Bulk Report

Bulk Report This control starts the Bulk Report utility for the currently selected table. It uses the bulk_template.doc file (and its style sheets) to render a simple summary report for each record using MS Word automation. This is a less featured alternative to the additional abilities provided in the 1st Word tool.
[Top]

12 1st Word Publish

1st Word Publish This control starts the 1st Word utility, a tool used by standards developing organizations (SDOs) to render final standards documents from the database meeting their own styles and formatting needs. The 1st Word tool is only provided to SDOs at this time.
[Top]

13 Exit button

Exit button The Exit button closes the tool and exits the program.

[Top]

14 Link Tables

Link Tables The Link Table Set allows you to control which other tables are searched for linkage relationships in your data. Pressing the Links button will give a Link Cross-Link report for the current record using the selected tables.

[Top]

15 Raw DB

Raw DB The Raw DB button will launch a copy of Microsoft Access and display the current database in it for your use. This is handy when you want to circumvent Mini-Edit and edit the table directly. If you have a different tool registered to open access files (*.mdb), that will be used.

[Top]

16 Export1 (ASN)

Export1 (ASN) The Export1 button brings up the Export Formatting Dialog for ASN and for exporting the database into a raw XML style.

[Top]

17 Export2 (XML)

Export2 (XML) The Export2 button brings up the Export Formatting Dialog for revision controlled XML schema sets, and for creating partial schema of other FADD from your external data concepts tables.

[Top]

18 Import

Import The Import button allows running the Registry Parser, a tool for importing from the old style flat text register style files. It can also extract the ASN concepts from such files.

[Top]

19 html Docs

html Docs The html Docs button will run the Create Web Pages utility for the current table, rendering each data concept into a web page.

[Top]

20 Misc. Text Edit

Misc. Text Edit The Misc.Txt button brings up the Quick Edit Dialog to allow editing of the text associated with text entries in several of the tables.

[Top]

Several other buttons which are grayed at this time contain features that have not yet been released at this time.

<-LAST TOP NEXT->

See Also

Mini-Edit Main Screen | Main Screen, Record Controls


Main Screen, Record Controls

Main Screen, Record Controls

Main Screen, Record Controls

The records controls are found on the main window under the data display grid area. These controls generally deal with adding or removing individual records from the currently active table as well as viewing and editing the contents of existing records. The Links button allows exploring relationships between the current selected record and other records. The Lock-All button allows locking (assigning checksums) to the records.

The other controls found on the Main window display are described here, and here.

1 Edit/View Record

Edit/View Record Used to open an Edit or View window for the currently selected record. You can also double-click on the left hand side of the data grid view for that record (a single click will populate the summary information for that record). The text displayed in the button changes between Edit or View depending on the setting of the Read-Only checkbox.
[Top]

2 Add Record

Add Record Used to add one or more records to the current table. This button is enabled only when in the read-write mode. A set of Screens will be presented asking how many records to create and what to name them, then the new records will be displayed.

[Top]

3 Delete

Delete Used to delete the currently selected record. This button is enabled only when in the read-write mode. A yes-no confirmation Screens will be displayed and if YES is selected the current record will be moved into the deleted records table.
[Top]

4 XML button

XML button Used to enter the XML translation mode for the current record (although when entered from this mode all the records in the current table can also be processed and updated with one button press). See the XML Editor for additional usage notes.
[Top]

5 Links button

Links button Used to display a detailed Links Report of all the links found in other records' ASN to this record's ASN. The links are calculated using only those tables marked in the Links Table for linking. The small text above the button displays the current number of links for this entry from all tables. This is calculated as a background task and may take a moment to appear with large tables. Keep in mind that you will not see links to usage in other standards that you do not have loaded.
[Top]

6 Lock All

Lock All Used to lock the records in the current table. This action calculates a CRC checksum for various parts of the record and then adds that, as well as the current user name, to the record. These value are re-computed when a record is viewed to determine if it has been changed since it was locked.
In order to lock most tables you MUST be a data steward, as this is used to create authoritative records for the SDOs to exchange. Data users (non stewards) can lock only entries in the local data table. The sections locked are as follows:

Descriptive Text Natural language parts of the record
ASN Code All ASN code segments of the record
XML Code All XML code segments of the record
Meta-Data Most meta data items include date stamps

Any editing in the Edit window to the file covered by these values (as well as any editing by other tools or directly in access) will void the checksum and that part of the record will no longer be shown as locked.
[Top]

<-LAST TOP NEXT->

See Also

Mini-Edit Main Screen | Main Screen, Primary Controls


Table to View

Table to View

Table to View

The table select view is used to select which table will be the current table and be displayed in the data grid and can be edited.

You may select one table at a time. Tables that exist in the current file will have an active button or appear in the drop down list. If a button is grayed then that table does not exist in the current file. All of the standard tables have a button here. User defined tables (those with non-standard names) can be selected in a drop down and you must also select the button. Only tables that contain ITS registry data will be shown; other tables in the file will not.

The rule used for deciding if a table is ITS compliant, and any converting that may occur if you open it, is to compare the fields found in the table with those found in the ASN_Fields table (found in the MEdit_Settings.mdb file) and if these fields exist, to presume the table is a valid one for Mini-Edit use. When such a table is opened, any missing fields (determined by the Registry_Name_Mappings table), are also added to its structure.

The outdated two-table system of DEs and MSGs is supported as well as the newer system of five named tables. Automatic process rules in the file open section will give the user the opportunity to convert to the newer table section. However, because the older tables still remain, they often provide a handy reference to compare older entries.

Aside: The current practice is to create all the standard named tables in every file as a working convention, even if these tables are empty, so as a rule only older files will have missing tables. Mini-Edit will add such tables when they are found missing as part of the overall open process.

A brief description of the tables and their typical content is provided below.

Keep in mind that regardless of the name of the table, every table can contain every type of record.

1 Local Entries button

Local Entries button Used to hold local table entries, typically local stub extensions in a standard and local work for a deployment.
[Top]

2 Data Elements button

Data Elements button Used to hold data element entries, typically the atomic entries of a standard.

[Top]

3 Data Frames button

Data Frames button Used to hold data frame entries, typically of a standard. A data frame is a structured collection of other data frames or data elements.
[Top]

4 Messages button

Messages button Used to hold message entries, typically of a standard. A message is a structured collection of other data frames or data elements which represents the top level of some application and which can be exchanged as a stand alone entity (typically in a Dialog of some sort).
[Top]

5 Dialogs (WSDL) button

Dialogues (WSDL) button Used to hold Dialog s entries, typically of a standard or for a local deployment. A Dialog is a structured exchange of one or more messages which perform a function in some application.
[Top]

6 Foreign Elements button

Foreign Elements button Used to hold table entries from other standards, data elements, data frames, and messages. In most standards this table is used to point to the data concepts developed in other standards upon which the subject standard depends for data concepts. A current and authoritative record from the database of that standard is typically copied to this table. Practices vary regarding including all other related data concepts that this record may point to. Most standards import the first level of such linkages but not all the subsequent underlying ones. This may leave some work to be done by the end deployment in order to construct a full and complete schema system.

[Top]

7 Depreciated button

Deprecated button Used to hold data concepts which have been retired from active use. This is different from deleted where a record has been removed. Most standards provide some form of depreciated entries as a graceful way to remove outdated concepts from future editions of the work. [Aside: The deleted table, a table which holds any data concepts you delete, can be selected from the items listed in the table-select drop down.]
[Top]

8 Select a Table button

Select a Table button The select a table button allow you to pick from the tables shown on the drop down list. All valid tables without a button of their own are displayed here. Any user created table will be listed here.
[Top]

9 DEs (old style) button

DEs (old style) button Used to hold data element entries in the old table style; typically the atomic entries of a standard.

[Top]

10 MSGs (old style) button

MSGs (old style) button Used to hold messages and data frame entries in the old style of tables, typically of a standard.
[Top]

11 Temporary Table button

Temporary Table button The temporary table is not yet released for use. It will be used as a working scratch pad to gather sets of entries from the other tables resulting from searches and representing a collected sub-set of data for a user.
[Top]

12 Sort By Controls

Sort By Controls The sort-by control allow you to select the order in which the table is displayed in the grid and in the view-edit window. You can check one or both of the buttons. The first button sorts by alpha order on the descriptive name field. The second uses the ASN name field. If both are checked the sorting order is descriptive name followed by ASN name.
[Top]


File Open

File Open

The Find File, File Open Dialog works in the normal windows way, allowing you to find and open a file for Mini-Edit to operate on. A few minor points on proper use are made below.

1 Current Path

Current Path The current path shows where in the file system you are looking. As a rule it is best to keep your database files in the same directory as the Mini-Edit application.
[Top]

2 File Type

File Type The file type works in the normal way and defaults to displaying *.ITS files. Keep in mind that older database files may be of the *.MDB type (the drop down box allows you to select *.MDB files, along with any file type).

Aside: If you open an older *.MDB file and the tool does not see a similar file with the *.ITS extension, it will offer to upgrade the file you have opened to the current file style and will automatically create the missing table and sort the existing data entries into the new tables. The older tables (DEs, MSGs) will not be disturbed. This can be useful if you will be dealing with the subject file for any length of time.

[Top]

3 Open button

Open button The open button works in the normal way, and Mini-Edit begins the process of opening the selected file.

Background Data: This process involves an examination of the file to detect what tables it has which are of interest to Mini-Edit, followed by a basic examination of each table to confirm it has certain minimal required fields. The act of opening an older file more or less brings it up-to-date with any structural changes needed by the database, any new terms in the supporting fields, and other minor changes. During the open process, the fields listed in the ASN_Fields table of the MEdit_Settings.mdb file are used to determine if the table being examined is to be treated as an ITS table.

When you open each individual table this process is continued for that table and additional fields may be added. Thus, if you want to make an older file current (which is often required to use it in some of the tools), simply open that file, then open every table of interest to you. The tool makes you do this manually for each file you need because often (particularly for data stewards) a user may have a need to keep old copies of files.

The tool takes an optimistic approach to the tables themselves and does not mind additional fields it does not understand being associated with each table. It ignores these fields in it own operations. This allows legacy meta data from other tools to co-exist in the records of the tables. Tables which are not one of the standard named tables, or do not have the minimum data fields to be detected as a Mini-Edit table, can also co-exist in the file without problems.

[Top]

4 Cancel button

Cancel button The cancel button is used to dismiss the Dialog without selecting a file. The former file and table (if one was selected) will remain the active table and file. Like most actions that are aborted, the minor error message is displayed and this event is entered into the log.
[Top]


Link table set

Link table set

Link table set

The Link Table Set Dialog determines which of the tables will be used in the process of resolving links between the current record (in the current table) and the other tables in the file. The standardized tables are displayed first, followed by any valid user created tables in the file.

Most users will want to check for linkages in the first six tables listed. Users working on older tables and files may want to select only those tables (DEs, MSGs, ExternalDEs). Keep in mind that if you have an entry in an outdated table (such as DEs) and that same entry in the new tables (such as Data Elements) and you set the check boxes to link to both, then you will see both entries listed in the linking reports.

Also keep in mind that if you link to extra tables (causing duplicate entries with the same name to appear) this may cause you to receive warnings when rendering XML. The XML translator will seek out all matching records for the data types which you use in the complex ASN records (data frame and messages), and if multiple records are found a warning will be issued. As a rule, you can re-use a data concept all day long, but you must define it only once.

This Dialog is also displayed when an older file (*.mdb) is being converted to the current style (*.ITS). In that context the user is asked what tables should be examined and converted to the new tables. The typical default (DEs and MSGs tables) is correct most of the time, but this Dialog allows selecting other tables should the need arise.

Finally, it is also used when gathering Local Stubs from the tables to create entries in the Local Entries table. In this context the user is asked what other records should be examined for such stub points.

1 Restore button

Restore button The restore button resets the check box selections to the default pattern for the tables that are displayed (typically the first five for modern tables and the DEs-MSGs for older tables. It is useful as a starting place for additional selections by the user.
[Top]

2 List view

List view The list box shows the tables to be selected from.
The standard tables are listed first, followed by any other tables found to have ITS type content in them.
[Top]

3 Save button

Save button The save button confirms the currently selected check boxes.
[Top]

4 Close button

Close button The Close button dismisses the Dialog window. Press the Save button before closing to confirm your choices.
[Top]

<-LAST TOP NEXT->

See Also

Link Cross-Link report..


Mild Error Messages

Mild Error Messages

Mild Error Messages

The Mild Error Dialog is used to display a variety of casual and non-critical events that can occur when running the program. The term error here is a misnomer; perhaps unexpected event would be a better term. This dialog may be displayed when the user does unexpected but completely valid things (for example, canceling a file open operation).

Often the cause of these events is ANOTHER program, such as the MS Word automation of Active X controls (the source field will tell you where the error originated). Mini-Edit has no control over these programs and is simply reporting back what data they provide.

The dialog always displays the numeric event code returned to Mini-Edit so that advanced users can further detect the reason for the event. [The error codes and their meanings are not set by Mini-Edit; consult the documentation of whatever application created the error event.] For common events, a suggested course of action is given. The message text above, caused by the user canceling the file open dialog, is typical of this.

If possible, the program will continue normally after displaying such a dialog. In other cases (such as when the user disables or closes MS Word or some open file the tool is using in the middle of a rendering), the program is unable to continue and will abort. In no event will any data be lost or the database files damaged.


Export Formatting (Old Style)

Export Formatting (Old Style)

Export Formating (Old Style)

The Export1 button brings up the older Export Dialog box, used for generating ASN source code and bulk XML exported from the database. [In the past, it was also used to create the XML schema files and the export script for uploading to the IEEE central registry, no longer used.] The XML Schema exporting process is covered in the next Dialog.

The most common use of this dialog is to create a complete set of ASN which can then be validated by a complier to confirm it is syntactically correct, or the export can be used to generate programming stubs in common languages such as C++.

You can also produce a complete rendering of all the meta-data information in a table into a simple XML instance which you can then process and use on other programming environments as you see fit. This is used to import the data into the SQL or ORACLE or other database styles by some deployments. This form (bulk XML) is useful if you want to export all the meta-data of a database into a common and simple XML format for import to another tool. This is NOT the same as a proper XML schema, which the other export screen (see link above) supports.

The basic process of using this dialog is the following four steps.

A) Select the type of output you wish to create (ASN source or XML meta data).

B) Select what table you wish to output from.

C) Set any options such as the default module names.

D) Press go and wait a moment.

Further details of each step are provided below.

1 Select Format

Select Format Select the type of output which you seek to create, either an ASN listing or an XML bulk export (the other two options are no longer used).

The check box Match Registry ID has no use at present. It was formerly used to match up the record number used in the central registry with those used in the access tables and your data concepts.

The check box Append ASN.1 stubs is used to control the inclusion of any named ASN stubs to the module level build. If selected, it will seek for well named ASN text files to include in the build. If they are found they will be included. If they are not found, the position in the source file where they would be included will have a comment. The files will be the name of each FADD with "stubs" append, as in: IMstubs.txt Such files can be useful when developing ASN where portions of the code are included from outside sources rather than in the database.

The check box Append XML stubs is used in a similar fashion to control the XML import process, but is now overcome by the controls present in the Export XML dialog.
[Top]

2 Select Tables

Select Tables A collection of check boxes to select the set of tables which will be used in the output process. The default setting represents the tables that would normally be output by an SDO check of a standard.
You can learn more about these tables here.
[Top]

3 XML Import Source

XML Import Source A primitive means to specify the relative path of the schema set, used in naming the schemas import table to point to each other. Now overcome the controls present in the Export XML Dialog.
[Top]

4 XML Stub Folders

XML Stub Folders A primitive means to specify the relative path of where the schema set will be written to the user PC. Now overcome the controls present in the Export XML Dialog.
[Top]

5 Output File

Output File The name of the file to be output by the routines.
[Top]

6 View Result button

View Result button When pressed, whatever viewer the user has registered for this file type (ASN or XSD) is fired off to view the result of the run.
[Top]

7 Cancel button

Cancel button A close button for this dialog.
[Top]

8 Do It button

Do It button The go button for this dialog. When pressed, the selected tables will be output in the selected way, producing the named file(s).
[Top]

9 Namespace to use

Namespace to use The ASN module and XML namespace that this exported code will be defaulted into when created.
[Top]

10 Draft Text Name

Draft Text Name The name to be appended to the Descriptive name or the XML name, if the appending checkboxes are checked.
[Top]

11 Append Draft_ to XML Tag

Append Draft_ to XML Tag Appends the word draft_ to the XML type name field value so that record entries can be easily grouped or told apart from other values. Used with the registry data to test drive a set of new records.
[Top]

12 Append Draft_ to Descriptive Name

Append Draft_ to Descriptive Name Appends the word draft_ to the Descriptive name field value so that record entries can be easily grouped or told apart from other values. Often used with the registry data to test drive a set of new records being uploaded.
[Top]


Export (New XML Style) before run

Export (New XML Style) before run

Export (New XML Style) before run

The Export2 button brings up the (newer) XML Schema Export Dialog box, used for generating XML Schema sets from the database. The ASN source code exporting process is covered in the previous Dialog; see Export Formatting (old).

This section presumes the reader is generally familiar with the process of XML schema creation and the design issues involved.

Exporting a useful XML schema is slightly harder than exporting an ASN file. You have to plan what you want to end up with, define how it will be named, and then resolve the linkages to other schema from other standards that you depend on.

In ASN source file creation, these items are all done for you and the tool produces a single file with multiple modules inside it for each FADD used. Things are more complex in XML. For one, in the XML world of ITS each FADD namespace has it own file (as well as its own supporting local codes file) and you will either use this complete file (typically obtained from the SDO that issued it) or will construct a partial sub-set of it with only the entries you require from the records in the ExternalDEs table.

Background: Schema files in the ITS world have their revision value as part of the file name. Typically this is also carried over in the import string used in the header sections of the schema to point to other supporting schema files. The name pattern is several keywords separated by dashes, as follows:

[FADD] - [Draft] - [MajRev] - [MinRev] - [IncRev].xsd

The FADD is of course defined by the standard. The term Draft is used for most working standards but the term Adopted is used for the final issued standard. This term is typically changed by hand by the data steward.
One additional pattern is the name of the file which contains the local codes (extensions) to each FADD; these are called: [FADD] - [Local] - [Draft] - [MajRev] - [MinRev] - [IncRev].xsd

The Mini-Edit tool automates much, but not all, of this process. It will produce a working schema for your data files from the standard tables, but can not usually produce a complete working schema for other imported standards in the External DEs tables due to not having ALL the relevant data concepts and not knowing what other revision releases in the other standards it needs to link to when it builds the foreign schema file. This is reflected in revision strings of 00-00-00 which can be interpreted to mean an unknown revision. Users can manually change these when a revision is known, or can make the 00-00-00 work as well.

Another ITS convention to mention is that related schema files are presumed to be locally found alongside each other. Hence local relative addressing is used for files, not absolute addressing.

This method of naming is used in the three critical places in the files. The XML schema standard allows different names for each location, but this has not proved to be useful to ITS and as a convention we avoid it.

Consider an illustrative example of the TMDD data dictionary at revision 02-01-00 rendered into an XML schema.
  • This schema file would be called: TMDD-Draft-02-01-00.xsd
  • Inside, its target namespace would be: http://www.tmdd-Draft-02-01-00
    (the word Partial would replace the word Draft if this was rendered from the ExternalDEs Table in another database such as ATIS)
  • When other schema files point to this data dictionary rendered as a schema they would use the namespace TMDD mapped to the string: http://www.tmdd-Draft-02-01-00 which would be imported from the locally defined file named: TMDD-Draft-02-01-00.xsd
    (although you will also find uses of the file name: tmdd.xsd when no revision baseline of the TMDD data is known).

Keep in mind in these examples that http://www.... is a common industry convention used to provide a unique string; it is not intended to be a linkable URL.

Resolving your external data so that it comes from the right schema release (Draft, Adopted or Partial) as well as what the revision value is between each of the related files is typically a manual effort after the schemas are created. This is expected to be made much easier when a user can simply drop an entire adopted schema into the mix. Note that this system also allows for the annoying reality that each standard may in fact point to different versions of other standards.

This tool, and this Dialog, allows you to create your own FADD and render that into a well formed schema.

1 User URL base

User URL base The URL base is used to insert the starting URL location for web service endpoints. It is used in WSDL and SOAP mappings.

Aside: Unlike an XML schema, a WSDL file is customized for each user because it contains the URL where the service endpoint can be found.
[Top]

2 User local folder

User local folder The folder (local to the Mini-Edit application path) where the schema set will be built. The schema will be placed inside a folder under this folder which reflects the name and revision of the primary schema which is being built. This location is also used to place the web page documents, if any are produced.
[Top]

3 Local or Custom Table Select

Local or Custom Table Select This is section 1 of the four output sections. It allows selecting whatever single table you wish as the output, although it defaults to the local table. If the box is checked, the selected table will be output. Note that the file name, derived from the FADD as well as the table name and the current database revision, is shown.
[Top]

4 Key Table Select

Key Table Select This is section 2 of the four output sections, used to output the primary table contents of the standard. You may check or un-check each of the three boxes to control the output of Data Elements, Data Frames, and Messages tables respectively. Normally all three are checked. All of these records will be placed into the one file shown. Note that the file name, derived from the FADD as well as the table name and the current database revision, is shown.
[Top]

5 Dialogs Table Select

Dialogues Table Select This is section 3 of the four output sections, used to output the WSDL for any defined Dialog s in the standard. You may check or un-check the box to control the output. A WSDL file is basically created the same way as an XSD file; the XML in each relevant record is gathered and placed in the WSDL file. Note that the file name, derived from the FADD as well as WSDL and the current database revision, is shown.

[Top]

6 External Entries Table Select

External Entries Table Select This is section 4 of the four output sections, used to output partial XML schema files for the External data concepts in the standard. You may check or un-check the box to control the output. Normally it is un-checked and ideally you would obtain the adopted edition of the schema from the issuing SDO rather then render them out here. When rendering from the External DEs table, each record is mapped to its module/FADD home and a separate file is created for each FADD. Note that the file naming used, derived from the mapped FADD and using the known database revision (00-00-00), is shown.

[Top]

7 Status Display

Status Display This area provides a working status as the export occurs. A progress bar also appears during the rendering. See the post-run screen shot for an example.

[Top]

8 Revision Release

Revision Release The revision values for the database are displayed here and you may set and advance them as you see fit. This information can also be found in the Misc Text table if you wish to edit it there. Typically the last number is an ever-increasing revision value while the other two follow the numbering conventions of each SDO.
[Top]

9 Namespace Select

Namespace Select The FADD namespace is specified here. This information can also be found in the Misc Text table if you wish to edit it there. Each SDO and each standard has been assigned an FADD value at this time (kept in the Module-Names table of the MEdit_Settings.mdb file). It is expected that local deployments may need to establish a FADD value of their own as well.
[Top]

10 Export Counters

Export Counters The number of records exported during the run is shown here. Also, an icon appears if any records were created which the user can click on to see the created files. This will launch the application the user has registered for viewing *.XSD files, (refer to how to register file types here).
[Top]

11 Run button

Run button The run button is the do it command for this Dialog.
[Top]

12 Cancel button

Cancel button This closes the export XML Dialog, returning you to the main window.
[Top]


XML Export Post-Run

XML Export Post-Run

XML Export Post-Run

This view shows the XML Schema Export Dialog window after a schema has been exported. Several informational messages are discussion below. Each produced file can be viewed with the users preferred XML schema tool by clicking on the red XML logo to the right of the screen, or with most browsers if the user does not have any such tool. [Refer to Registering Support Tools for details of how to do this if needed]

1 Status Lines

Status Lines Here we see a summary of the records exported.

Abbreviations like DE/DF (data element, data frame) are used. The total number of different files created is reported.
[Top]

2 Output Summaries

Output Summaries The number of record exported from each individual table is listed in this small status line area.
[Top]

3 Click to View

Click to View This icon appears after the run and, if clicked, will launch an application to view the created files, if the system has an application that can view XSD files. Otherwise the file can also be viewed by most browsers.
[Top]


Table Manager

Table Manager

This dialog is displayed by selecting the "Tables" button on the Main Window Screen. Note that the Tables button is only enabled when the Read-Only check box is unchecked (allowing you to change records).

The Table Manager Dialog is used to exchange and move record entries from one table to another. The tables can be in the current file or another file the user selected. This utility is the preferred way to merge and move records between files (rather than opening up MS Access and doing it by hand) because it also transparently enforces certain basic quality rules and can easily deal with the minor differences in the tables found between each SDO (which will prevent direct manual copies from Access).

Hint: When using the table manager to transfer records from an older database, first open the source database and display each of its tables in turn. This allows the Mini-Edit tool to update the table structures to the current level of revision. Then open the database that will receive the transferred records, open the target table, and then proceed to use the table manager. This process will ensure that all tables are at the same level of revision. Failure to follow this may result in trying to copy data between tables which do not match or align. In such an event, the tool will exit with a fatal error, but neither table or database will be harmed.

1 File and Table Select

File and Table Select This section of the Dialog is used when you want to load another database file and copy from that file. If you are copying between tables in the same file you do not need to use this section.

When the Open.. button is pressed the normal File Open Dialog window is displayed. The user may select a file to open and the valid ITS table will be loaded into the drop down control for selection.

If no file is selected, the drop down list is populated with the table from the currently loaded database file. If you want to copy a record from within the same table (make a duplicate), see the Dupe Entry button below. Select the table to copy FROM.
[Top]

2 Display Order

Display Order This controls which field in the FROM table is used to order the display in the data grid.

[Top]

3 Copy From Records

Copy From Records The data grid view of the records in the selected FROM table. Be sure to select the record you want by clicking the edge of the control (where the black arrow appears) and not the fields of the control. When you click on a record, a short summary is displayed in the snapshot view below.
[Top]

4 Snapshot View

Snapshot View The snapshot view displays a fragment of additional data about the currently selected record.
[Top]

5 Target Table Select

Target Table Select Selects which table in the currently loaded database file will be the TARGET and receive any copied (or duplicated) table records.
[Top]

6 Display Order

Display Order This controls which field in the target TO table is used to order the display in the data grid.

[Top]

7 Copy TO Records

Copy TO Records The data grid view of the records in the selected TARGET (TO) table. Be sure to select the record you want by clicking the edge of the control (where the black arrow appears) and not the fields of the control. When you click on a record, a short summary is displayed in the snapshot view below.
[Top]

8 Snapshot View

Snapshot View The snapshot view displays a fragment of additional data about the currently selected record.
[Top]

9 Rename Table button

Rename Table button Used to rename an existing table.

Hint: Do not use spaces in table names, and do not create names that differ only by capitalization case. While this is legal in MS Access, it will cause you later problems with SQL calls, especially if you ever try to integrate with other third party tools.
[Top]

10 New Table button

New Table button Used to create a new (empty) table.

Hint: Do not use spaces in table names, and do not create names that differ only by capitalization case. While this is legal in MS Access, it will cause you later problems with SQL calls, especially if you ever try to integrate with other third party tools. Capitalization counts! Even if some Microsoft tools ignore it at times.
[Top]

11 Dupe Entry

Dupe Entry This button creates a copy of the currently selected record in the TO table. (The FROM table selection is ignored.) The new record will have the word DUPE added to its descriptive name.
[Top]

12 Copy Entry

Copy Entry This button will copy the currently selected record in the FROM table into the TO table. This is used to copy a single record.
[Top]

13 Copy All

Copy All This button will copy the ENTIRE contents (all records) in the FROM table into the TO table. This is used to merge tables together wholesale.
[Top]

14 OK

OK The OK button closes the Dialog and returns to the Main Window view.
[Top]


Quick-Edit Text Table Entries...

Quick-Edit Text Table Entries...

Quick-Edit Text Table Entries...

This dialog is displayed by selecting the "Misc. Text" button on the Main Window Screen. Note that the Misc Text button is only enabled when the Read-Only check box is unchecked (allowing you to change records).

The Quick Text Editor provides a rudimentary way to edit the various textual tables found in the ITS database and used to support the standards production process. The Dialog presents a simple list of entries and the text associated with each, where the user can edit the entry as needed.

The labels volume-map figure title and figure path appears when the selected table has this content. You may edit these simple string when needed. Another label and text (Used In) displays an outdated form of volume mapping and is shown for information only. If is up to you to ensure that the path and file you enter resolves to a valid file. If non is found by 1st Word an error note will be issued where the figure would be displayed.

Remember that each volume map string consists of a sequence of two digit number for the volumes, separated by commas and NOT the name of the volumes. The value "00" means present in all volumes.

This editor is only active when you are in the read-write mode; its button is disabled when in read-only mode. Generally Data Users would not need to use this editor, only Data Stewards.

1 Drop down

Drop down The table to edit. You may select from four tables at this point as follows. Note that the first three are part of the current database table, while the last table is part of the USER_Settings.mdb file.

The Acronyms Table Each database files has a list of Acronyms which are used in the production of the standard. Typically 1st Word listed these in a separate clause in the document, and may hyperlink to them.

The Terms Table Each database files has a list of terms and definitions which are used in the production of the standard. Typically 1st Word listed these in a separate clause in the document, and may hyperlink to them.

The MiscText Table Each database files has a collection of miscellaneous text terms which are used to hold section headings, titles, boilerplate text, and other various things about the final document. This table is also use to hold meta-data which is common to the entire database, such as the default FADD value and the revision values.

The User Settings Table This file is unique to each user and there is only one. It is fairly new in terms of its deployment and over time is expected to hold preferences and privileges for each user. The only useful value in this table at this time, which you may want to edit, is the UserName which holds the name the user entered (when records are changed, to track who changed it).

[Top]

2 List view

List view An enumerated list of the records in the currently selected table.
[Top]

3 Edit field

Edit field The name of the record currently selected (the Term or tag field in the SQL structure).

[Top]

4 Edit field

Edit field The text of the record currently selected (the Def or Definition or text field in the SQL structure).
[Top]

5 Edit field

Edit field Some records have an ID field value (although this is not used in Mini-Edit). It is displayed here if present.
[Top]

6 Drop down Style

Drop down Some records have a word type Style value associated with them. This is mostly found in the Misc text table where text for 1st Word rendering is kept. It is displayed here, if present.
[Top]

7 Revert button

Revert button The revert button will restore the last saved record data, destroying any changes that were made.

[Top]

8 Save button

Save button The save button becomes active if any changes are made to the text. Pressing this button will save the changes to the current record and table.
[Top]

9 Close button

Close button The close button closes the Dialog and returns the user to the Main Window.
[Top]


Link Cross-Link report..

Link Cross-Link report..

Link Cross-Link report..

The Cross-Linking Report displays a list of other records (and the table they appear in) which are using the current ASN.1 in a valid way inside their own record data. Simple occurrences of the string or use of the string in a non valid ASN way (such as a comment statement) are not reported. In other words, this provides a tree of relationships in the nomenclature of ISO 14817, listing those records that use the item being linked.

The tables currently checked on the Linking List are the only ones checked in this process, and checking is limited to the currently loaded file. Other possible linkages in other files or standards may exist and will not be reported here (a central registry of some type would be needed to determine that data).

Typically the information reported here is generated when a standards document is created and is listed along with various hyper-links to the other places in the document where this entry is used.

1 Data Name Display

Data Name Display The name of the data concept for which links are being sought. The Descriptive Name as well as the ASN name are shown for the record.
[Top]

2 To Clipboard button

To Clipboard button This button will place the textual result on the clipboard.
[Top]

3 Results Display

Results Display The results window displays all the places where the record was found to be properly used in the ASN of other records.

This is limited to searching in the tables currently checked in the Link Set Dialog. The searching process is a two-step process. First, all simple string matches are detected with pattern matching and SQL calls. Then, every matching record is examined with the ASN parser to confirm that the string match occurred in a valid ASN context (and not in a comment or a sub-string, or in another module name). Records which meet this criteria are displayed.

Each table with any matching records is listed by name, in order, followed by the record entries where a match was found. The descriptive name of the record is given first, followed by the ASN name in brackets. You can see in this example that the ASN entry AxelCount is used in three data frames having to do with vehicle types.
[Top]

4 OK-Close button

OK-Close button The close button closes this Dialog and returns the user to the underlying window, either the Main Window or the Edit-View window.
[Top]

<-LAST TOP NEXT->

See Also

Link table set


Editing record, terse view

Editing record, terse view

Editing record, terse view

The Edit-Viewing Window is the primary Dialog used in the tool. Here the data record content can be examined or changed as needed. Data stewards and standards creators spend most of their time here refining the data concepts for each record in the standard. Data Users and Deployments use this page to quickly determine relevant information about the entry.

This Dialog is rather complex, and here it is broken up into two major sections. The first deals with the controls that are displayed in the terse mode - often this data is sufficient for many needs. The second deals with the verbose mode where some additional controls are also presented.

Beginning with the controls displayed in the TERSE mode...

1 Record Title

Record Title The title of the window displays the mode (Edit or View) as well as the relative position of the current record in the current table (here the 4th record of 114 total).

[Top]

2 Move <- Last

Move <- Last This button moves to the previous record in the table. When the first record is reached, it moves to the last record in the table.

[Top]

3 Move Next ->

Move Next -> This button moves to the next record in the table. When the last record is reached, it moves to the first record in the table.

[Top]

4 Verbose Mode

Verbose Mode The button toggles between the Terse and Verbose modes of display. In the terse mode, fewer controls are displayed than in the verbose mode. The verbose mode displays more controls and is described on the next page.

[Top]

5 Raw DB

Raw DB This button will launch MS Access and open the current database file to allow direct editing and viewing of the tables in the file. Any changes made in this mode are not automatically seen by the Mini-Edit tools, so avoid changing records or tables that the tool is currently working on. If you do so, allow Mini-Edit to re-load the record, table, or file when done so that it can re-establish current data.

[Top]

6 Status Text

Status Text The status text area displays a large number of meta-data items about the data record. These are all values required by IEEE 1488/89 and have similar names and uses in ISO 14817. Several other items felt to be of no value (such as a steward's phone number) are not displayed.

Perhaps the only one of these of value to most users is the Changed date which shows when the record was last edited.

Note that each time you edit the record this is updated. Your user name is stripped in below it as the last user who changed the data (you can see your user name above this section of text). The data steward name (which may be you or may be someone else) is stripped in when the record is locked.

The Published area provides data regarding records published in multiple volumes, displaying a comma separated list of the volumes the record will appear in. The small E button next to this allows editing these volumes. This is how a record is assigned to one or more volumes. Databases which do not publish in volumes can ignore this feature (their vol-map meta-data content is either blank or set to 00).
[Top]

7 Record Name

Record Name The Descriptive Name of the record is displayed here

[Top]

8 Description

Description The Definition field of the record is displayed here. The textual entry area of the control is a rich text control; when it is active, a rich text editor is displayed.

[Top]

9 ASN Code

ASN Code The ASN code section of the control consists of several fields into which the ASN is placed in accordance with the rules of IEEE 1488/89.

The ASN.1 Name field contains the proper type definition name of the ASN entry.

The Data Type contains the primitive ASN type which is used in data elements (it is not used, nor displayed in data frames, messages or Dialogs).

The Valid-Value-Rule area (also called the message body) is used to hold the rest of the ASN production. For simple types this means all restrictions, comments and enumerations. For complex types, this means the complete rest of the ASN listing after the name.

The small drop down box provides some basic primitive types which can be selected as a pattern starting point when creating new entries. They will, for example, fill-in the data type and valid value rule with a well structured enumeration listing which the user can further modify. The templates are loaded from the table ASN_Templates in the MEdit_Settings.mdb file and can be extended by the user if desired.

The check box Move-To (typically left enabled) instructs the tool to move any extraneous content found in the data type field into the valid value field. Early ITS data dictionaries from some SDOs had such content.

Like the other editing areas, the small E command will start an external Edit window using whatever tool you have registered. Return the final text using the clipboard and cut and paste.

[Top]

10 Remarks

Remarks The Remarks field of the record is displayed here. The textual entry area of the control is a rich text control; when it is active, a rich text editor is displayed.

[Top]

11 Rule Check

Rule Check This command invokes rule checking on the current record. If a rule check has not yet been run, the Rule Selection Dialog is displayed to establish what rules will be used. The Record Entry Error Report will then be displayed.

[Top]

12 Report

Report This command creates (renders) the current record into a word report format. If MS Word is not open and active, it is opened. If it is open, the report is appended to the end of the current document.
[Top]

13 Build XML

Build XML This command invokes the XML Editor, used to create or update the XML portions of the record.
[Top]

14 Link Report

Link Report This command invokes and displays a Link Cross Link report which will show every other record that uses this record in its ASN listings. The small textual label above the button shows how many such linkages were found (this is checked when the record is first loaded).
[Top]

15 Revert

Revert This command will discard all edits made to the record by the user and restore it to the last saved version. It becomes active only when the record has been changed and not yet saved.
[Top]

16 Re-Lock

Re-Lock This command calculates the locking CRC values for the current record and updates those values (locking the record so that any further changes would be evident). It is only displayed when in a R-W mode and can only be invoked based on the users rights for that table. [Basically only a steward can lock the main tables, while all users can lock the local tables and no user can lock the External DEs tables]

The textual display above the button displays what categories of the table are still locked.
Hint: If you are a deployment using this tool with a DB provided by a standards group, you would typically want to be provided with a set of locked (and hence authoritative) records. You would then avoid damaging these records in your own re-use of them.
[Top]

17 Save

Save This command will save the record to the table with all changes made at that time.

[Top]

18 Cancel

Cancel This command will cancel the Edit-View Dialog and return the user to the Main Window.
[Top]

<-LAST TOP NEXT->

See Also

Editing record, verbose view


Editing record, verbose view

Editing record, verbose view

Editing record, verbose view

The Edit-Viewing Window is the primary dialog used in the tool. Here the data record content can be examined or changed as needed. Data stewards and standards creators spend most of their time here refining the data concepts for each record in the standard. Data Users and Deployments use this page to quickly determine relevant information about the entry.

This dialog is rather complex, and here it is broken up into two major sections. The previous section dealt with the controls that are displayed in the terse mode. This section deals with the verbose mode as some additional controls are also presented.

Continuing with the controls displayed in the VERBOSE mode...

The descriptions of these fields are brief due in part to different usage interpretations. Very little discussion regarding their proper use is provided, unlike other pages of this document where we have gone to great lengths to teach the proper conventions of ITS practice. That is simply because people can not agree on what many of these items are for, or how to properly fill them out. This author is reluctant to use the opportunity of the Mini-Edit help manual as a bully pulpit to express his own views in this area. It is perhaps sufficient to state that you can build a complete and correct ITS deployment without many of the items displayed on this page.

1 Terse button

Terse button The button toggles between the Terse and Verbose modes of display. In the terse mode, fewer controls are displayed than in the verbose mode. The verbose mode displays more controls and they are described here.
[Top]

2 Record Type

Record Type The fundamental type of record is displayed here in a drop-down list.

Background: All records are internally structured the same, but different business rules are applied as needed. Some additional record types defined in the IEEE 1488/89 are supported here but have never found widespread use in ITS, nor is there any real agreement on what they are for or how they are filled in.

The following basic record types are well developed and in use in ITS, and the SDO FADDs are made up almost entirely of these four types:

Data Element A simple structure made up of a single primitive element (integer, string, etc.) which forms part of a data dictionary and which may be used in (inside) data frames and other structures consisting of valid ASN and XML (as a type, not as an element).

Data Frame A complex structure made up of a combination of primitive elements (int, string, etc.) and/or other complex structures which forms part of a data dictionary and which may be used in data frame and other structures. Consisting of valid ASN and XML (as a type, not as an element).

Message A complex structure made up of a combination of primitive elements (int, string, etc.) and/or other complex structures which forms part of a data dictionary and which may be used in data frame and other structures. This complex structure can be exchanged between parties to effect a functional requirement. Consisting of valid ASN and XML (both an element and a type).

Dialog A mapping to one or more messages in a service endpoint performing some form of operation, typically expressed in WSDL.

Key concept: Any single record (found in a table, which is in a file) can be any one of these types. This has nothing to do with the ASN or XML found in that record. Ideally they should match (i.e. one would expect to find simple definitions of data elements in a record marked as a data element type rather than complex messages) but they do not have to be so. Ill formed records, particularly when a standard is being developed and changed, can be common.
[Top]

3 Alt Name

Alt Name The Alterative Name contains the synonymous descriptive name for the entry. Some SDOs have used this field to keep older descriptive names when they are changed as a nod to backwards capability.
[Top]

4 Source

Source The Source is the full and complete official name and revision of the standard from which the record comes. The table Source in the MEdit_Settings.mdb file contains a list of all known files, which is used to populate this field.
This table also contains the mappings of these strings to the Module-Fadd mapping for that standard. To determine what FADD a record belongs to, its source string is matched to this table and the FADD value found is used. If a string is used which does not appear in this table, it will be mapped to the UNKNOWN FADD when it is exported or other records will not be able to link to it when they re-use it in their ASN.
[Top]

5 Keywords

Keywords The Keyword is a list of possible search keywords that people have used from different value domains over the years.

[Top]

6 Units

Units The Units is a list of possible units that people have used from different value domains over the years. Interpretation of IEEE 1488/89 and ISO 14817 is a bit vague here. The table Units in the MEdit_Settings.mdb file contains a list of all known valid units which are used to populate this field. This file is generally applied only to data element records, but there is no firm rule on this.

[Top]

7 Ref Value Domain

Ref Value Domain The Ref Value Domain is a list of possible referencing systems that people have used over the years. Interpretation of IEEE 1488/89 is a bit vague here. The table RefValueDomain in the MEdit_Settings.mdb file contains a list of all known valid units which is used to populate this field.
[Top]

8 Formula

Formula The Formula field of the record is displayed here. The textual entry area of the control is a rich text control; when it is active, a rich text editor is displayed.

[Top]

9 Harmonization Notes

Hamonization Notes The Harmonization Notes field of the record is displayed here. The textual entry area of the control is a rich text control; when it is active, a rich text editor is displayed. This is an area we were developing when SAE funding support for the tool was cut off. Its intended purpose was to allow the automatic collection of feedback from other people commenting on your data record (very useful for data stewards and for committee balloting comment use). It is maintained today because some people still use it as a handy scratch pad file in the record.

[Top]

10 Desc Name Context

Desc Name Context The Descriptive Name Context is a list of possible categories for names that people have used from different value domains over the years. Interpretation of IEEE 1488/89 is a bit vague here. The table Descriptive_Name_Context in the MEdit_Settings.mdb file contains a list of all known valid values which is used to populate this field. The entry Traffic Management is often chosen as the most general term.

[Top]

11 Class Name

Class Name The Class Name is a list of possible categories for names that people have used from different value domains over the years. Interpretation of IEEE 1488/89 is a bit vague here. The table Classification_Scheme_Items in the MEdit_Settings.mdb file contains a list of all known valid values which is used to populate this field. The entry Traffic Management is often chosen as the most general term.

[Top]

12 Configuration System

Configuration System The Configuration Systems allows picking from a list of registry systems that are being used as the baseline for this record. There are only four possible categories for names here (1488 or 14817 choices). The table Config_Baseline in the MEdit_Settings.mdb file contains a list of all known valid values which is used to populate this field.

[Top]

13 Object ID

Object ID The Object ID (OID) field of the record is displayed here. This is an open string because different groups have different formatting they use when creating this value. In general you will see this used in the NTCIP standard when MIBs matter, and not in the message (ASN or XML based) efforts. However, IEEE 1488/89 states that it must be filled out, so a value of 0000 is often used to mean none in practice.
[Top]

14 User

User The User field is an open field not used by any SDOs at this time. See the remarks for the View field.

[Top]

15 View

View The View field is an open field not used by any SDOs at this time. Both the View and the User fields are an ill-conceived attempt in IEEE 1488/89 to register what deployment or end users of a registry system might have interest in a certain record. There was also some failed attempts at managing MIB content relationships using this field
This blunder is repeated in the ISO 14817 as well. The fundamental design need is real: that of knowing which users care about what records. But its attempt to solve this by adding burdensome meta-data to the authoritative record (rather than binding it in the register design, typically in an associated table generated on demand) is the problem. Use the Linking Report function to achieve this ability.

[Top]

<-LAST TOP NEXT->

See Also

Editing record, terse view


XML Editor Basics

XML Editor Basics

XML Editor Basics

The XML Editor window allows the creation (or display) of an XML schema fragment from the current records ASN listing. The XML Editor controls are discussed further in the next two sections, XML Editor Controls (used to control the XML production), and XML Editor Advanced Controls (controls population details and used in the translation process).

This window converts from ASN to XML. You may not edit the ASN in this window because it is presumed that the ASN is correct when called. If the ASN of the records is locked, then creating or updating the XML does not change that. It is expected that other similar translation windows for other formats (such as an NTCIP MIB or CORBA IDL) may be developed as deployment needs continue to evolve.

If the ASN is well formed (syntactically correct) the tool will automatically parse it to produce an equivalent XML rendering following the conventions of ITS (these are documented in the SAE standard Jxxx, Rules for converting from ASN to XML). It should be pointed out that ASN is a very wide ranging language with many odd special cases and clutter in its development life (now disused), including some radical changes in language syntax over the years. While this XML converter is very robust, it only handles the style of ASN used in ITS and should not be considered a general purpose tool.

The controls on the right hand side are not manually set in practice; this information is entirely derived form the ASN source code. The controls in the middle section of the dialog control how the XML is rendered and documented, and what quality checking with other records in the file is performed.

The tool is built on a common recursive descent parser and uses the templates found in the table XML_Templates of the MEdit_Settings.mdb file to build up coherent pieces of the final XML production. As you will see in the templates, various facet restrictions are parsed out of the ASN and placed into their appropriate place in the rendered XML. A variety of keywords are also placed into the ASN source code to control the conversion process to a better degree. Consult the section ASN Control KeyWords for a summary of these and their use.

If you are viewing a record's data in the read-only mode than the XML listing (if it exists) is also displayed in this window, but you can not change or edit it.

1 Next -> button

Next -> button This button moves to the next record in the table. When the last record is reached, it moves to the first record in the table.

[Top]

2 <- Last button

<- Last button This button moves to the prior record in the table. When the first record is reached, it moves to the last record in the table.

[Top]

3 Shrink-Grow button

Shrink-Grow button This button controls (toggles) the display of the details panel to the right of the dialog. It has been removed in recent editions of the tool as it is not longer needed.
[Top]

4 ASN Display

ASN Display The complete ASN of the current record is displayed here. You can not edit it from this window; you must use the Edit-View window to make any change before calling this window.

[Top]

5 Restore Name button

Restore Name button This button restores the default XML name to the entry (the name is the same as the ASN name).
Use this button if you have changed the ASN name since the XML was created in order to put them back in sync. [Aside: If the ASN and XML names are different the tool presumes you changed them on purpose and will not change this when it auto-updates.]

[Top]

6 XML Display-Edit

XML Display-Edit The resulting final XML is displayed here.

You may edit and change this window as you see fit. If you edit it, the Allow Update... button will become UN-checked and the tool will no longer automatically update the XML (thus preserving any ASN changes you make). Save the XML when you are done.

[Top]

7 Browser

Browser This button launches the user's XML browser to display the created XML schema fragment.
[Top]

8 Create XML

Create XML This button causes the ASN to be parsed and then translated into its equivalent XML form. Any errors in the translation will be displayed in a browser window.
[Top]

9 Update All

Update All This button causes ALL the ASN in all the records of the current table to be parsed and then translated into its equivalent XML. Any errors in the translation will be displayed in a browser window. This button is only enabled when you enter the XML dialog from the Main Window, and not from the Edit-View Window.
[Top]

10 Revert

Revert This button reverts the XML to the last saved version.

[Top]

11 Save

Save This button saves the current XML to the file, and updates the record.

This button saves the current XML to the file, and updates the record. If the check box is checked, the record is always saved without asking the user. If un-checked the user will be prompted to save the record before moving to another.

[Top]

12 Cancel

Cancel This button closes the dialog and sends the user back to either the Main-Window or the Edit-View window (whichever the dialog was originally called from).

[Top]

13 Error Button

Error Button This button launches the user's XML browser to display any ERRORS that were reported when the XML schema fragment was created. Such errors relate to problems in the ASN formulations (bad code syntax) or in the related supporting records (suspicious link resolution issues). If no errors are generated, then the button will remain hidden.
[Top]

<-LAST TOP NEXT->

See Also

XML Editor Controls | XML Editor Advanced Controls


XML Editor Controls

XML Editor Controls

XML Editor Controls

Even though the rendering of the ASN into XML is automatic, the user will want to control some aspects of how the documentation is created, as well as how thoroughly the tool checks for supporting records in the rest of the file. This section supports those needs. Users can leave the default settings as found, or change items as required to control precise differences in the final XML schema.

This selection of controls is part of the XML Editor Window Dialog.

1 Allow Auto-Updates

Allow Auto-Updates When checked, the record will automatically be updated when the XML Dialog is run. If you will be changing your ASN, leave this checked so your XML will be updated with the changes. If unchecked, the tool presumes you want to manually control the XML process and will not change the fields. The only reason you would do this is if you have hand edited the XML, which almost no one does.

[Top]

2 Make an Element

Make an Element This is normally checked only for message record types. In ITS all XML is expressed as abstract types (so no element tag is in fact created), and only messages have element tags. If your record is set to be of the type Message this check box will be automatically set for you.

[Top]

3 Show Debug

Show Debug When checked, the tool inserts many additional comments on the conversion process which can be useful in debugging what is going on and tracking down minor ASN syntax errors that may be giving you unintended results.

[Top]

4 Adjust ASN

Adjust ASN When checked, a number of minor and annoying ASN syntax errors in keywords are caught and corrected before the parsing process begins.

[Top]

5 Skip Long Name Warning

Skip Long Name Warning When checked, the screen warning about ASN-XML names being longer than 25 characters is suppressed. In general, you want to use short ASN name to produce short XML tags.
[Top]

6 Skip Link Resolution

Skip Link Resolution When checked, the extra processing step of seeking for one (and only one) matching record in the tables for each type-def used, and then using the XML tag name that it has, is suppressed. This is a major quality control function, and disabling it will probably hide errors and warning messages relating to other data records, which you really need to correct. You will still see errors relating to any ill-formed parts of this record.

[Top]

7 Skip ITIS Link Resolution

Skip ITIS Link Resolution When checked (the default), a slightly different process is used to check out and resolve names in the ITIS space. This was originally developed to allow standards to point to the ITIS phrases without having to import the entire ITIS list of entries. Now overcome by events, most standards that need to, simply import the ITIS phrase set directly.
[Top]

8 Convert dashes to spaces in string constants

Convert dashes to spaces in string constants When checked (the default), any dash character "-" found in enumeration strings will be converted to spaces in the XML string. The language ASN requires that enumerations be a single token, but there is no such restriction in XML and this produces a more readable string in many instances.
[Top]

9 Remove all comment lines (terse output)

Remove all comment lines (terse output) When checked, all intermediate comments found in the ASN production will be stripped out in the XML schema. This produces a very tight XML only listing but can lead to misunderstanding because the comments are often usage remarks a builder needs to follow.

[Top]

10 Add text of Description/Use to XML App Info

Add text of Description/Use to XML App Info When checked, the Description field is converted to plain text (from rich text) and included in the <xs:annotation> section of the schema. In effect, this fattens the schema by placing useful deployment data into this section.

[Top]

11 Add text of Remarks to XML App Info

Add text of Remarks to XML App Info When checked, the Remarks field is converted to plain text (from rich text) and included in the <xs:annotation> section of the schema. In effect, this fattens the schema by placing useful deployment data into this section.

[Top]

12 Add text of Formula to XML App Info

Add text of Formula to XML App Info When checked, the Formula field is converted to plain text (from rich text) and included in the <xs:annotation> section of the schema. In effect, this will fatten the schema by placing useful deployment data into this section.

[Top]

13 Delimit above text with type tags

Delimit above text with type tags When checked, and if any of the above three items are checked, then the content for the above items is preceded by a tag value to delimit it. For example, the description text is preceded by the tag <description> and so on. This allows the ability to parse out each section of text if needed.

[Top]

14 Add HTML bolding to text

Add HTML bolding to text This is a feature that is not yet implemented, pending the outcome of debate in the W3C-XML schema committee regarding allowing of formatted text in the App-Info section of the XML production. At present, only plain text is supported (in fact, formatting is "allowed" but any formatting found is ignored). When (if) the ablity to use HTML type styles is allowed here, this check box will control its application.
[Top]

<-LAST TOP NEXT->

See Also

XML Editor Basics | XML Editor Advanced Controls


XML Editor Advanced Controls

XML Editor Advanced Controls

XML Editor Advanced Controls

The rendering of the ASN into XML is automatic, resulting in most of the controls in this section being automatically filled in by the tool in a fraction of a second. Given good ASN, there is no need for the user to ever edit these controls. Its primary purpose at this stage is more educational in nature. Users can examine how the ASN is broken down into leaves (a Mini-Edit term for one ASN production, which is part of a larger tree of such productions) and how the two languages map between each other. These controls can toggle along the tree displaying the data of each leaf in turn. The control buttons allow the tool to run first as a parser (putting the resulting tree on the clipboard) and then as a translator (building the equivalent XML from the parsed tree).

This selection of controls is part of the XML Editor Window Dialog.

1 Leaf Count

Leaf Count The total number of leaves found in the ASN and which one is currently being shown in the controls. This control, and the next two, are only used (and therefore visible) with complex XML made up of multiple elements.

[Top]

2 Scroll Leaves

Scroll Leaves The scroll buttons, used to move back and forth between the leaves of the entire tree of this ASN. A simple data element will only have one leaf in its tree.
[Top]

3 R button

R button Resets the controls to the root (first) leaf in the tree.
[Top]

4 XML Name

XML Name The XML name (derived from the ASN name) of the item.
[Top]

5 Comments

Comments Any comments collected for the current leaf node.
[Top]

6 Preserve Space

Preserve Space When checked, the white space in comments is not collapsed.
[Top]

7 Number Ranges

Number Ranges The minimum and maximum value ranges for numbers such as an integer.
[Top]

8 Size Values

Size Values The minimum and maximum character sizes (length) for types such as strings.
[Top]

9 Fixed Size Box

Fixed Size Box The required character sizes (length) for types such as strings. Note that an entry might have a min-max or a fixed size but never both.
[Top]

10 Basic Type

Basic Type The basic type of XML pattern that will be used in the element.

[Top]

11 Tag Field

Tag Field The XML name (derived from the ASN name) of the item.

[Top]

12 Octet Method

Octet Method The method of encoding that will be used for an Octet data type. Only applies to Octet data types. This type of data (a binary blob) is discouraged in code development, but when used must be encoded in one of the two provided ways.
[Top]

13 Array to Clipboard

Array to Clipboard This button will take the parsed tree of data and place it on the clipboard. Useful in debugging data frames.
[Top]

14 Enums to Clipboard

Enums to Clipboard This button will take the parsed tree of enumerated item data and place it on the clipboard. Useful in debugging data elements with enumerations.
[Top]

15 Parse out ASN.1

Parse out ASN.1 This button causes the ASN parser to run and displays the results in the XML window and in the above controls. The parsing process is typically followed by the translation process which builds up the XML.
[Top]

16 Build up XML

Build up XML This button causes the XML translator to run and displays the results in the XML window. It is preceded by the parsing process which separates the ASN into translatable pieces in the data tree.
[Top]

<-LAST TOP NEXT->

See Also

XML Editor Basics | XML Editor Controls


Rule Selection

Rule Selection

The Rule Selection Dialog is used to determine which set of rules will be applied to records when the rule checking is invoked. This Dialog is displayed the first time the user invokes the rule checking. Thereafter it can be invoked and edited with the Rule Set... button from the Error Report Dialog.

Rules allow the wholesale modification of the database records and often allow a rapid correction of existing systemic error in the records. Rules will deal with much of the drudgery required for meta-data. Rules can correct common syntax and spelling errors in your code. A complete set of the rules and their use is given in the Processing Rules Reference section.

The rules chosen will be applied to the record and the result displayed in the Error Report Dialog. The user can set the database file to be read-only, in which case the rules are applied and changes are noted in the report but no modification of any record is made. This is often the preferred way to test out a sequence of rules. See the Error Report Dialog for details.

1 Default Settings button

Default Settings button This button resets the enabled controls to a generally safe starting point which you can further adjust as needed.

[Top]

2 Select All Rules button

Select All Rules button This button sets all rules to Enabled as a starting point which you can further adjust as needed.

[Top]

3 Select No Rules button

Select No Rules button This button sets all rules to Disabled as a starting point which you can further adjust as needed.

[Top]

4 Tree View of Installed Rules

Tree View of Installed Rules The rule set is enumerated here.

Hold your mouse over each rule or increase the size of the window if you need to see more information.

Remember that a rule will not run unless the container rule that it is nested within is also enabled.

The use of each rule is described in the Processing Rules Section.

[Top]

5 Ok-Close button

Ok-Close button This button closes the rule display.

[Top]

6 Status Lines

Status Lines These status lines provide feedback during the rule loading process.

[Top]


Record Entry Error Report

Record Entry Error Report

Record Entry Error Report

The Error Report Dialog displays the results of the currently selected rules applied to the currently selected record. The log displays what errors or omissions were found, what changes were made or are proposed, and may suggest some need for follow-up action to perfect the record. The current selected rules can be invoked and edited with the Rule Set... button (below).

Various buttons in this Dialog window allow the control of the rule checking process. The Correct Record and the Undo buttons provide a handy way to visually see what the effect of the current rule changes will be on the record. If the rules are run on an entire table, an XML report of the errors detected and any changes made is produced and displayed for your use as well.

1 Results Display

Results Display The results of the rule checking process are shown here. Note that a simple XML style format is used.
[Top]

2 Warning Icons

Warning Icons Depending on the types of errors found, various warning icons will be displayed here. In this example, an error icon and an information-action icon are shown. A warning icon can also appear. Note that these categories are repeated in the XML tag preceding each text statement in the display area.

[Top]

3 Toggle Verbose

Toggle Verbose This button toggles the Verbose button in the Edit-View window, providing additional or less information in the underlying Edit-View window.

[Top]

4 Rule Set

Rule Set This button displays the Rule Set so that the rules used can be selected.

[Top]

5 Check all

Check all This button checks all of the records in the current table.

[Top]

6 Next Error

Next Error This button checks the next record in the current table and repeats this process until an error is found. It stops at the first record which contains an error.

[Top]

7 Show Warnings

Show Warnings When checked, warnings found for a record are displayed. When unchecked, warning messages are suppressed.

[Top]

8 Show Each Record

Show Each Record When checked, all records are noted in the output report, even if they have no errors. This is used when checking the entire table. Some users want to see confirmation that each record was passed without finding an error.

[Top]

9 Browser View

Browser View When pressed, the errors messages are displayed in a browser as an XML file.

[Top]

10 <- Last button

<- Last button This button moves to the prior record in the table. When the first record is reached, it moves to the last record in the table.

[Top]

11 Next -> button

Next -> button This button moves to the next record in the table. When the last record is reached, it moves to the first record in the table.

[Top]

12 Undo

Undo This button reverses any changes made by the rules process, returning the record to its prior state.
[Top]

13 Correct Record

Correct Record The changes recommended by the rules are applied to the record. View the underlying record to see the results.
[Top]

14 Auto Save

Auto Save Save the record without asking each time, when this is checked.

[Top]

15 Cancel

Cancel Close the Dialog box.
[Top]


Creating new entries...

Creating new entries...

Creating new entries...

This dialog is displayed as part of the process of creating a new record entry. This process is started by pressing the Add Record button on the Main Window Screen. Note that the button is only enabled when the Read-Only check box is unchecked (allowing you to change records).

This screen is displayed when creating new record entries for the current table. Enter a numerical value to create a set of (numbered) entries. Press return to create a single entry. This screen is followed by the Name the Entry screen which then requests a basic name for the entries. The new records are then created and merged with records in the current table (using the current alphabetic ordering as well).

The value "1" shown above the data entry area is a count of the number of textual characters entered into the dialog. This is used in other dialogs that reuse this same window to allow the user to see how long the name being created will be.

1 Edit field

Edit field A numerical value for how many records to create.
[Top]

2 OK button

OK button Accept the value for the number of records entered and go to the Name the Entry dialog.
[Top]

3 Cancel button

Cancel button Cancel the screen, aborting the record creation process.
[Top]


Name the new entry...

Name the new entry...

Name the new entry...

This screen is displayed as part of the process of creating new record entry (or entries) for the current table. Enter a textual name value to create a set of (one or more) entries with that name as a base. Press return to create a single entry and accept the default value (chosen simply to make it first in the display). This screen is preceded by the Create New Entries screen which requests how many entries are to be created. The new records are then created and merged with records in the current table (using the current alphabetic ordering as well). Next, the Editing Records Dialog will be displayed to allow you to further fill-in the new record.

The value "8" shown above the data entry area is a count of the number of textual characters entered into the dialog. This is used to allow the user to see how long the name being created will be. Because the ASN and XML names often come from this same text, this provide a simple way to gently warn the user against making long-ish name choices.
If you are created a set of related entries, such as a set like MSG_Device_1, MSG_Device_2, MSG_Device_3, etc. then you would enter the root name of "MSG_Device" here and let the tool add each sequential value. If you are simply entering a set of records with distinct names, let the tool name them AAAAx so that they will appear in a logical order at the top of the table for you ease in finding them. As you change the names of these records during editing, you may want to periodically re-sort the table to keep the data record correctly numbered. This can be done by changing the active table, or by changing the sorting order.

1 Edit field

Edit field A textual value for the name of the entry.
[Top]

2 OK button

OK button Accept the value for the records name entered and proceed to create the new record (or records is more than one was requested).
[Top]

3 Cancel button

Cancel button Cancel the screen, aborting the record creation process.
[Top]


Delete Record...

Delete Record...

When deleting the currently selected record from the current table this Dialog box is displayed to confirm that the user wishes to remove the record.

The Descriptive Name and the ASN Name of the record are provided to allow the user to be sure that this is the record intended.

If the user answers YES the record is removed. If the user answers NO the action is canceled and the record remains.

Note: When a record is deleted it is not destroyed. It is in fact placed into the table called Deleted_Records and its descriptive name is modified to include the time at which it was deleted (e.g. text such as (removed on 6/20/2006 at 10:22:40) is added). If a user determines that they want such a record back, the Table Management Utility can be used to restore it.


Create web page documentation...

Create web page documentation...

Create web page documentation...

The Create Web Page Documentation Dialog is displayed when the html Doc button is pressed from the main window. It is used to inform the user where the web pages will be placed before the run commences (or is canceled). If the user presses YES the current table is rendered; if the user presses NO the action is cancelled.

The created web pages will be placed in the same folder as the default location of the XML schema document (in a sub-folder called ../docs), and will use the same release naming system. Hence the web pages of MyFadd release 1-2-3 would be placed into a folder of ../ITSSchemas/MyFadd-01-02-03/docs/ The user is given a prompt to edit this as needed. Typically you would want the documentation to match the XML to which it pertains, so the defaults are used.

When run, this command will produce one web page for every record in the currently selected table. The descriptive name of the record is used to name the html file, so the record entry DE_Year becomes DE_Year.htm etc. A final html page called TOC.htm is produced to be the table of contents page. To generate from multiple tables, select each table in turn (making it the active table) and repeat the command.

The production process used to create the web pages is to individually render them using MS Word (and hence the style sheet conventions found in the file Web_Template.doc) and then save them as html files. If you wish to add a header or footer (including whatever html you want) you would add it to the style sheet. The hyperlinks used in this process between web pages are all relative to the same folder in which the document is built. Of course, you may further edit and modify the resulting pages to meet your own final needs.


About to launch Dialog

About to launch Dialog

About to launch dialogue

The About to Launch Dialog is displayed before another (independent) program is started from the Mini-Edit tool. Typically, as in this case, the tool gives a description of what is about to occur and suggests what or how the user may need to interact with the new tool. See also the Not installed here.. Dialog.


Not installed here..

Not installed here..

Not installed here..

The Not installed here Dialog is displayed when another (independent) program is found to be missing on the users machine. Typically, as in this case, the tool gives a description of what would normally occur and suggests what or how the user may need to interact with the new tool. The most common occurrence of this is a data user trying to render out a completed standard in its normal style using the 1st Word tool (which is only provided to the data stewards of the SDOs and not the general community). See also the About to Launch Dialog.


Rich Text Editing and Spelling

Rich Text Editing and Spelling

Rich Text Editing and Spelling

This section deals with how to use the integrated Rich Text Editor of the tool (present from release x420 and beyond). This editor provides the normal single key sequence commands to perform common text formatting (i.e. a ctrl-shift-B key sequence makes the selected text bold, etc.). These commands are also present in the displayed tool bar, as well as several other commands such as spell checking, managing a dictionary, and automatic type-text replacement operations. Undo functions as well as find and replace are also fully supported. While this editor is by no means a replacement for Word or other editing environments, it sure is helpful for minor corrections and editing. The result of this editing is stored as rich text format fields in the tables.

Hint The data grid in the main window shows the raw data for each field (not its formatted result). You can see both plain text and RTF strings in the description field of this control. Older database documents are all in plan text because the RTF style has become available only recently. You can click on a record in the control (along the left hand side) and you will see a summary of the textual information shown in the log below it. The snapshot view controls what text is displayed.

The above image shows an active rich-text entry with the pop-up tool bar which is displayed when that text entry is active. While this image shows the Description (or Use) text area, the same operations are allowed for the Remarks, Formula, and Harmonization text areas of the tool.

The functionality of the control is explained below.

1 Rich Text Display

Rich Text Display The text to be edited is displayed here (as rich text with various font and format styles).

Keep in mind that Rich-text does not support all the formatting one could add with applications such as MS word, nor will this render well with 1st Word. Make sure that whatever conventions you adopt will work in your publishing process.
[Top]

2 External Edit Button

External Edit Button The External Edit button launches MS Word (or whatever application is registered to run *.doc type files) with a copy of the text. When editing is completed, use the clipboard and paste method to return it to the Mini-Edit environment.
[Top]

3 Text Formatting tools

Text Formatting tools In the formatting tool area, the most common textual formatting can be applied to the currently selected text.

B

I

U

ABC

2N

2N

BOLD (ctrl-B)

Italic (ctrl-I)

Underline (ctrl-U)

Strike through text (ctrl-S)

Sub-script text

Super-script text

The above formats can be applied in any combination need as well as in various colors.

In addition:

The sequence ctrl-shift-A will toggle the case of the selected text.

The sequence ctrl-shift-> will increase the font size of the selected text, as will ctrl-shift-+.

The sequence ctrl-shift-< will decease the font size of the selected text, as will ctrl-shift-_.

[Top]

4 Spelling control tools

Spelling control tools These six controls effect how the spelling system will operate, how the text is formatted overall, and various defaults for tools which are common to all the text editors such as the dictionary and auto-replace strings.

Spell-Check When pressed, the tool will change from passive background spell checking to a modal Dialog when each suspect word is presented to the user to be modified or affirmed. When completed or cancelled, the tool reverts to a passive spelling behavior (any suspect words are underlined with a red squiggly and alternative words are presented in a right-click pop up). See here for additional details.

Plain-Text The current text is stripped of all formatting, reverting it to plain text. This can be used to start over, or when pasting in text from some other tool which brings with it any unwanted font type.

Auto-Text This control remains TBD at this time, but its intended use will be to apply the default formatting used by each SDO (for example 10 pt Times New Roman as a font) and then to auto-recognize and format certain keywords in the text such as the proper names of data elements.

Dictionary This control brings up a Dialog to manage the contents of the user's dictionary. The dictionary is unique to each user (and not the open database file). This control is still being developed at this time.

Auto-Text This control brings up a Dialog to manage any auto-text pairs. An auto-text pair is a set of strings; when one string is typed (such as SAE) the text is replaced with whatever rich text you have assigned (such as: Society of Automotive Engineers). The collection of auto-text pairs is unique to each user (and not the open database file). See here for additional details.

Options This control brings up a Dialog to manage various default behaviors of the tool, such as if words with all capital letters should be checked, and if the acronyms found in the currently open file should be added (temporarily) to the current dictionary list.
[Top]

5 Undo-Redo

Undo-Redo These controls provide an UNDO and REDO buffer for the text of the control. The controls each become active when there is some action that can occur or be rolled back. The common key sequences ctrl-Z and ctrl-Y are also supported.
[Top]

6 Color and Bullet styles

Color and Bullet styles These controls provide a color selection and a bullet list selection.

The color control brings up a small pallet of colors for the user to select from. The selection will be applied to the currently selected text.

The bullet selection control will apply a bullet style formatting and number to the selected paragraphs. Several different styles are supported and by repeated clicking one can toggle between them (and a setting of none).
[Top]

7 Find and Print

Find and Print These controls provide a FIND & REPLACE function and a PRINT function for the text of the control.

The Find & Replace function allows the systematic searching of the text in the normal ways. The find text is covered in greater detail here .

The Print function simply formats the current text to the users default printer and renders it out. This can be useful when working in a group and there is a need to hand out the text for review.
[Top]

8 Line Spacing

Line Spacing This controls the paragraph line spacing of the text. Keep in mind that the style of the 1st Word rendering may override this when printed in a final document.
[Top]

9 Cut, Copy, Paste

Cut, Copy, Paste These control the clipboard and the cut, copy, and paste functions. The normal keyboard commands also work. The controls each become active when there is some text that could be cut, copied, or pasted.
[Top]


Find and Replace Rich Text

Find and Replace Rich Text

Find and Replace Rich Text

This is the Dialog box provided by the find and replace system for the current text entry. The user may use the text string to perform find type operations.

1 Find Text

Find Text Text to find.

[Top]

2 Replace Text

Replace Text Text to replace with (not shown for finds).

[Top]

3 Match Controls

Match Controls These controls determine how a string match will be found.
Find Whole Word Only - The string must be surrounded with white space; partial sub-strings will not be a match.
Match Case - The case of the target string must match.
Use Pattern Matching - A simple UNIX type pattern match is supported.

[Top]

4 Search Direction

Search Direction The direction for the next search to move in the text field from the currently selected text or insertion point.

[Top]

5 Find Next

Find Next The find button.

[Top]

6 Cancel

Cancel The cancel button; the Dialog is dismissed.

[Top]

7 Replace

Replace The replace button.

[Top]

8 Replace All

Replace All The replace-all button. All strings matching the find string are replaced in the text.

[Top]


Spelling Error Dialog

Spelling Error Dialog

Spelling Error Dialogue

This is the Dialog box provided by the spell check system when checking an entry in the modal style (pressing the first button on the tool bar starts this mode for the current text entry). Each suspect word is presented in turn until the text is completed. The user may do the normal spelling correction things as well as cancel out of the spelling mode (in which case the tool returns to a passive background spell checking mode).

1 Suspect Word

Suspect Word The suspect (misspelled) word.

[Top]

2 Suggested Words

Suggested Words A list of suggested possible words.
[Top]

3 Change

Change Change the suspect (misspelled) word to the selected suggested word.

[Top]

4 Change All

Change All Change all occurrences of the suspect (misspelled) word to the selected suggested word.

[Top]

5 Ignore

Ignore Ignore the suspect (misspelled) word in this text (for this spelling run, not permanently).

[Top]

6 Ignore All

Ignore All Ignore all occurrences of the suspect (misspelled) word in this text (for this spelling run, not permanently).

[Top]

7 Add to dictionary

Add to dictionary Add this word to the user's global dictionary.

[Top]

8 Cancel

Cancel Cancel the modal spelling mode; the spelling checks will now occur as a background task. [Any suspect words found will be indicated with a wiggly underline]

[Top]


AutoType Manager

AutoType Manager

This Dialog is used to manage the collection of automatic replacement strings. When one of the strings is typed, the associated replacement text will be used. This function is often used to expand rote phrases or cure dyslexic typing, such as the acronyms shown in the screen image. The list of replacement pairs is unique to each user.

1 Auto Pairs

Auto Pairs The text pairs currently known by the tool are loaded here. In this screen shot you can see the user has defined three pairs (SAE, DRSC, and J2354).
[Top]

2 Text to Type

Text to Type
The trigger text is entered here.
[Top]

3 Text to Replace

Text to Replace The replacement text is entered here. Note that this can be rich-text formatted.
[Top]

4 Add Pair

Add Pair The Add button adds the current pair to the user's list of auto-replace pairs.

[Top]

5 Close

Close The Close button closes the Dialog.
[Top]

6 Delete Pair

Delete Pair The Delete button removes the current selected pair from the user's list of auto-replace pairs.
[Top]

7 Use Clipboard

Use Clipboard This button pastes into the text areas from whatever rich text content is on the clipboard.

[Top]

8 hide help

hide help This button hides from view the informational label at the bottom of the Dialog by making the window shorter.

[Top]


Missing ATIS DB alert

Missing ATIS DB alert

Missing ATIS DB alert

The ATIS Examples file was not found by the tool when it was started.

The file ATIS_EXAMPLES.mdb is used by the tool to initially point to a valid file of tables (until the user selects another table). While the content of this file is no longer useful in any SDO-FADD sense, it must be found in the same folder as the application. This new file is required, and is provided in the installation package.

Once this Dialog is displayed, opening of other files is disabled and the tool is effectively stopped. Run the install script to repair your installation and restore the file.


File dates conflict warning

File dates conflict warning

File dates conflict warning

If you see this warning displayed it almost certainly means you have tried to update the Mini-Edit application and have forgotten to also update the MEdit_Settings.mdb file at the same time. Information on downloading the most current copy can be found here.

The program simply tests for the dates of both files when first run and presents this nag screen if the date of the MEDIT_setting.mdb file is not later than the application date. The program continues normally after presenting this warning. If this warning bothers you, simply update the MEDIT_setting.mdb file and its new time stamp will be later than that of the application. This can occur in the extremely unusual case of a user maintaining his own MEDIT_setting.mdb file for his needs.

However, 99% of the time you see this, it would be because you have failed to obtain and install the correct MEDIT_setting.mdb file which was released with the Mini-Edit application versions you are using. These are ALWAYS released in matched pairs. Failure to have a current MEDIT_setting.mdb file may result in incorrect control words or translations, because the patterns used in the tool come from that file.


User file missing alert

User file missing alert

User file missing alert

The User files were not found by the tool.

The file USER_Settings.mdb was introduced in release x410 and beyond, it is used to hold such things as the user's name, rights, and preferences. This new file is required, and is provided in the installation package. Run the install script to repair your installation and restore the file.

Aside: As of version x410 this file is expected to reside in the same folder as the ITS database you are operating on (typically both are in the same folder as the application). This was a design choice done to support those data stewards that edit multiple SDO files, so that they could have a user file for each SDO file. In future editions of the tool, this is expected to be revised to allow a single file with multiple sets of rights.

<-LAST TOP


Processing Rules Reference

Glossary Item Box

Getting Started: Getting Started

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Registry Parser: Registry Parser

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes

See Also MEdit Send comments on this topic.

Processing Rules Reference

Processing Rules Reference

This section provides a detailed description of the operation and effect of each rule. Look here and here for a summary of how to use the rules on a record or a whole table.

The process rules of Mini-Edit are used to systematically control how records are tested, modified, and changed in order to perfect them. Indiscriminate use of this section of the tool can damage your records, as not all rules are compatible with each other or harmless (as you might expect, each SDO has different needs and conventions, and as a result some rules conflict with each other). As a rule the default setting of the rules will enable only those rules which do no possible harm.

When in doubt, set the file to be read-only and then run the rule on the table or record. A summary of what is found (without changing any records) will be presented for your consideration. If this is what you wanted to do, then re-run the rule with the file in read-write mode. This is a very effective way to test the waters before making changes. When changing one record at a time, the undo button is also helpful.

Each process rule is listed in this section along with its behavior, its default setting, and where it is located in the tree of rules.

The text string listed after the position (if present) is the programmatic keyword for this rule, a unique phrase used to invoke the rule when using remote automation. [Aside: Remotely running Mini-Edit from other applications is a subject of future development at this time and will be covered in the (yet to be developed) programmers guide.]

NOTE: The rules can also be downloaded from the web is a Word document format here .

The structure of the Processing Rules Reference

Create Missing Fields in Record
Set the record type for this entry
Check ASN.1 (a container with five further containers)
Pre-Process ASN
ASN Names
ASN Types
ASN Valid Value Rule Content
ASN Message Rules
The Rules dealing with XML entries (container)
The Descriptive Name Rules (container)
The Textual Descriptive Entry Rules (container)
Rules dealing with external record reuse (container)
Meta-Data Registry Rules (container)
Stewards: Got a rule you think would be useful? Submit it and we will see. As a gross rule of thumb, it takes an hour or two or three to create a simple rule. If it saves you 2x that amount of time, it may be worth the effort to create it and let others use it as well.

NEXT->

See Also

Getting Started: Getting Started

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Registry Parser: Registry Parser

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes


Create Missing Fields in Record

Create Missing Fields in Record

Create Missing Fields in Record

Rule Name:

Create Missing Fields in Record

Position:

Root

Name:

(none)

Default:

Checked

Usage:

Used to create any missing elements in the record, works with the initial table open routines to ensure consistent basic structures are present in every record.

TOP NEXT->


Set the record type for this entry

Set the record type for this entry

Set the record type for this entry

Rule Name:

Set the record type for this entry

Position:

Root

Name:

SetRecord

Default:

Checked

Usage:

Some database records are not properly coded (or coded at all) as anything but “data element” types, even if they contain data frame data or message content. This rule examines the ASN of those records without a known record type and tries to determine what type of record it should be, fixing it if possible.


Check ASN.1 (container)

Check ASN.1 (container)

Check ASN.1 (container)

Rule Name:

Check ASN.1 (container)

Position:

Root

Name:

CheckCode

Default:

Checked

Usage:

A container class used to hold the rules which apply to aspects of the ASN portions of the record.

Note that if you wish to run one of the underlying rules, this rule must also be enabled (as is true for all rules).

This section is the most complex of the rules and directly under this rule are several other container types to further categorize the rule set. These rules are not a substitute for a good ASN.1 syntax checking tool.

This rule contains several other rules which are nested under it. A page is devoted to each of the five major nested areas.

  1. Pre-Process ASN before running rules (container)
  2. Validate ASN Name Type (container)
  3. Validate ASN Data Type (container)
  4. Validate valid value rule area (container)
  5. Validate message content rule area (container)


Window: Validate ASN Name Type (container)

Validate ASN Name Type (container)

Validate ASN Name Type (container)

Rule Name: Validate ASN Name Type (container)

Position: Under: Check ASN.1
Name: ASN_Name
Default: Checked
Usage: A container class used to hold the rules which apply to aspects of the ASN Name of the record.


Pre-Process ASN before running rules

Check ASN.1 (container)

Rule Name:

Pre-Process ASN before running rules (container)

Position:

Under: Check ASN.1

Name:

ASN_PreProc

Default:

UN-Checked

Usage:

A container class for rules dealing any pre-processing steps to be performed before other rules are invoked. Typically used to expand macro content.

Note that macro expansion may result in other rules tagging the resulting content as incorrect. When this container class rule is enabled, the global flag preExpandMacros is set to be true for the record. This flag is then used to suppress logic in a few other rules.

This rule holds several other rules beneath it as follows:
[ Click on the arrows below to expand the rule and see its detailed information ]

Show All Show All
Hide All Hide All

Show Expand common macros and correct keyword spelling errors

Rule Name:

Expand common macros and correct keyword spelling errors

Position:

Under: Pre-Process ASN before running rules

Name:

ASN_MacroFull

Default:

UN-Checked

Usage:

Uses the "built-in" table of macro and expands the data type and valid value rule fields when these are seen (surrounded by white space in many cases). This style of macro table, is outdated and the newer, table based, approach is preferred because it can be edited by the end user.

Show Expand macros using the table of macros found in MEdit_Settings.mdb

Rule Name:

Expand macros using the table of macros found in MEdit_Settings.mdb

Position:

Under: Pre-Process ASN before running rules

Name:

ASN_MacroTable

Default:

UN-Checked

Usage:

Uses the Medit table of macros "Macro_Expand_ASN" and expands the matching string when found in the data type field of the current record. This style of macro table is preferred over the older built-in one because it can be edited by the end user.

Caution should be used when editing this table not to introduce ill-formed ASN, the entries are presumed correct and not checked. Also, consider the order in which the comparisons are made and consider any sub-string problems you may create. In general, check the longest string first.


Validate ASN Name Type (container)

Check ASN.1 (container)

Rule Name:

Validate ASN Name Type (container)

Position:

Under: Check ASN.1

Name:

ASN_Name

Default:

Checked

Usage:

A container class for rules dealing with the proper ASN name of the record. Consult an ASN text book, but a proper valid names (also called a TypeDef because it defines a new type which can then be used by others) starts with a capital alphabetic letter, then may contain mixed case, and numbers, and dashes. No spaces or other symbols are allowed. Most current ITS uses a camel case style as in: MyType

This rule holds several other rules beneath it as follows:
[ Click on the arrows below to expand the rule and see its detailed information ]

Show All Show All
Hide All Hide All

Show Detect White space in around name

Rule Name:

Detect White space in around name

Position:

Under: Validate ASN Name Type

Name:

ASN_White

Default:

Checked

Usage:

Checks for, and removes, any white space before or after the records ASN name. If changes were made, a note is added to the log and displayed.

Show Make first char upper case (a proper type name)

Rule Name:

Make first char upper case (a proper type name)

Position:

Under: Validate ASN Name Type

Name:

ASN_Upper

Default:

Checked

Usage:

Checks first character of the name; if found to be lower case, the upper case version is used. If changes were made, a note is added to the log and displayed.

A fundamental rule of ASN is that EVERY type definition (this record is such an entry) MUST start with a capital letter. Instance names of the type def (such as found inside a data frame) are lower case.

Show Remove any spaces in name

Rule Name:

Remove any spaces in name

Position:

Under: Validate ASN Name Type

Name:

ASN_Spaces

Default:

Checked

Usage:

Checks for any spaces in the name; if found, they are removed. If changes were made, a note is added to the log and displayed.

A fundamental rule of ASN naming is that the name string must not have white space in it. Observe that ASN itself breaks this rule with primitive type such as “BIT STRING” - but you are not allowed to.

Show Remove any invalid chars in name

Rule Name:

Remove any invalid chars in name

Position:

Under: Validate ASN Name Type

Name:

ASN_Valid

Default:

Checked

Usage:

Checks the character set used in the name; if any invalid (non-allowed) characters are found, they are translated to something legal. If changes were made, a note is added to the log and displayed.

A fundamental rule of ASN naming is that the name string must not have characters like !@#$%^&*{}|\~`<>? in it

Show Warning on long names

Rule Name:

Warning on long names

Position:

Under: Validate ASN Name Type

Name:

ASN_Long

Default:

UN-Checked

Usage:

Check the length of the name; if found to be >25 characters, a nag note is added to the log and displayed.

Show If Name is empty, use valid value rule when well formed

Rule Name:

If Name is empty, use valid value rule when well formed

Position:

Under: Validate ASN Name Type

Name:

ASN_Blank

Default:

Checked

Usage:

If there is no name (the field is empty) then the valid value rule is examined for a possible name. In some older databases the valid value rule contains complete entries such as MyThing =::   INTEGER. If a valid looking name is found, it is stripped out (removed) and placed in the ASN name field. If changes were made, a note is added to the log and displayed along with the name and type found.

Hint: This is also a very easy way to paste in ASN from other sources and let the tool sort out where the various parts go. The typical procedure is to create a new record, paste the entire ASN into the valid value rule and paste in the usage notes (if any). At this point you can then let the rules sort it all out for you. (various rules will then name the record, sort and fix the ASN, and fill in all the meta-garbage required).


Validate ASN Data Type (container)

Check ASN.1 (container)

Rule Name:

Validate ASN Data Type (container)

Position:

Under: Check ASN.1

Name:

ASN_DataType

Default:

Checked

Usage:

A container class for rules dealing with the data type field of the record. Consult any ASN text book, but a proper valid types include such keywords as: IA5String, UTF8String, NumericString, INTEGER, BIT STRING , REAL, etc. These keyword need to be correctly spelled and capitalized, and ASN is intolerant of errors. Early editions of the standards had many such errors, now largely corrected.

This rule holds several other rules beneath it as follows:
[ Click on the arrows below to expand the rule and see its detailed information ]

Show All Show All
Hide All Hide All

Show Correct ASN Primitive Data Type Spellings

Rule Name:

Correct ASN Primitive Data Type Spellings

Position:

Under: Validate ASN Data Type

Name:

ASN_DataTypos

Default:

Checked

Usage:

Checks the data type field of the record, and corrects many common misspellings and capitalization problems if found. If found to be match to one of the known misspelling terms in the MisSpellTable, it is replaced with its proper term. Entries like “Integer” or “INT” are corrected to be INTEGER. If changes were made, a note is added to the log and displayed.

The MisSpellTable is loaded from the Mis_Spell_ASN table in the MEdit_Settings.mdb file. You can edit this table to remove or add any additional entries as you wish, or change the translation of those present. A typical entry is as follows, given “IA5 String” replace that text with “IA5String” when found.

Show If Type is empty, use valid value rule when well formed basic item

Rule Name:

If Type is empty, use valid value rule when well formed basic item

Position:

Under: Validate ASN Data Type

Name:

ASN_DataBlank

Default:

Checked

Usage:

Checks the data type field of the record, and if found to be empty, seeks for a valid data type in the valid value rule field. If one is found, it is moved to the data type field. If changes were made, a note is added to the log and displayed.

Show Expand any ASN macro terms to the underlying code

Rule Name:

Expand any ASN macro terms to the underlying code

Position:

Under: Validate ASN Data Type

Name:

ASN_DataMacro

Default:

UN-Checked

Usage:

Checks the data type field of the record, and if found to be match to one of the known macro terms in the MacroExpandTable, it is replaced with its proper expanded ASN representation term (the macro is expanded and removed). This rule is typically used to eliminate macros from the record. See also the discussion on the use of macros when converting to XML.

The MacroExpandTable is loaded from the Macro_Expan_ASN table in the MEdit_Settings.mdb file. You can edit this table to remove or add any additional macros as you wish, or change the translation of those present.

A typical entry is as follows, given “MEMSHORT23” replace that text with “OCTET STRING (SIZE (1..23))” when found.

Show Warn on duplicate ASN.1 Name entries

Rule Name:

Warn on duplicate ASN.1 Name entries

Position:

Under: Validate ASN Data Type

Name:

ASN_Dupes

Default:

UN-Checked (not released)

Usage:

Not yet defined.

With a given module name (ATIS, TMDD, IM, etc.) there can be only one definition of any defined ASN name (and that name can then be used in as many or as few instances as needed). Hence , duplicate ASN names are almost always a problem. This rule (will) check for this occurrence.


Validate valid value rule area (container)

Check ASN.1 (container)

Rule Name:

Validate valid value rule area (container)

Position:

Under: Check ASN.1

Name:

ASN_ValidRule

Default:

Checked

Usage:

A container class for a variety of rules that examine the contents of the valid-value-rule area. The contents of the valid-value-rule (a term invented by ITS) is basically everything past the data type. In other words all the content definition, or what would be called facet restrictions in XML, appear here. This also includes any comments placed into the code itself. While often very terse, this field can become quite large in enumerations with usage comments.

For historical reasons from IEEE 1488/89, all data elements use the ASN Name, the data-type, and the valid-value-rule as the fields to hold the ASN of the record. The message-body field is empty in these records.

Aside: Mini-Edit can edit up to 64k in this field, larger textual entries (such as the valid value rule of the entire ITIS code entry), can not be edited directly this way. A similar limit is present for most of the editable fields in the tool.

This rule holds several other rules beneath it as follows:
[ Click on the arrows below to expand the rule and see its detailed information ]

Show All Show All
Hide All Hide All

Show Replace any tabs in valid value rule with 3 spaces

Rule Name:

Replace any tabs in valid value rule with 3 spaces

Position:

Under: Validate valid value rule area

Name:

VVR_RemoveTabs

Default:

Checked

Usage:

The valid value rule field is parsed and any occurrences of tab characters are replaced with three spaces. Spaces are preferred over tabs so that when printed in a mono-spaced type the listing appears correct. If changes were made, a note is added to the log and displayed.

Show Replace any non-ASCII chars (values >127) with pure ASCII

Rule Name:

Replace any non-ASCII chars (values >127) with pure ASCII

Position:

Under: Validate valid value rule area

Name:

VVR_JustASCII

Default:

Checked

Usage:

The valid value rule field is parsed and any occurrences of characters with hex values above 127 are replaced. The replacement strings are taken from similar characters when possible (for example, the right hanging quote symbol is replaced with a straight quote). If changes were made, a note is added to the log and displayed.

Show Indent trailing lines of code by 3 spaces (pretty print)

Rule Name:

Indent trailing lines of code by 3 spaces (pretty print)

Position:

Under: Validate valid value rule area

Name:

VVR_IndentLines

Default:

Checked

Usage:

The valid value rule field is parsed and all lines following after the first line are indented at least three spaces to present some white space along the left edge of the listing. A rather primitive pretty print. If changes were made, a note is added to the log and displayed.

Show Make text entries into valid comments

Rule Name:

Make text entries into valid comments

Position:

Under: Validate valid value rule area

Name:

Make_Comments

Default:

Checked

Usage:

The valid value rule field is parsed and any content found after the “code” part which seems to be a possible comment is rendered into a legal ASN comment (typically by preceding it with two dashes). Many early standards did not insert proper comment marks in their work, and this rule was developed to correct this. If changes were made, a note is added to the log and displayed.

Show Correct INTEGER range limits

Rule Name:

Correct INTEGER range limits

Position:

Under: Validate valid value rule area

Name:

Scrub_INTEGERS

Default:

Checked

Usage:

The overall ASN is parsed and if it is determined to be an INTEGER type, the valid value rule “code” part is examined to detect any possible valid range limits.

Any ranges that are found are re-stated in a syntactically valid and correct way. Properly formed ASN is left unchanged Many early standards did not handle limit ranges correctly, and this rule was developed to correct this. If changes were made, a note is added to the log and displayed.

Show Correct IA5STRING size limits

Rule Name:

Correct IA5STRING size limits

Position:

Under: Validate valid value rule area

Name:

Scrub_STRINGS

Default:

Checked

Usage:

The overall ASN is parsed and if it is determined to be an IA5String type, the valid value rule “code” part is examined to detect any possible valid range limits for the string.

Any ranges that are found are re-stated in a syntactically valid and correct way. Properly formed ASN is left unchanged Many early standards did not handle limit ranges correctly, and this rule was developed to correct this. If changes were made, a note is added to the log and displayed.

Show Correct ENUMERATION lists

Rule Name:

Correct ENUMERATION lists

Position:

Under: Validate valid value rule area

Name:

Scrub_ENUMS

Default:

Checked

Usage:

The overall ASN is parsed and if it is determined to be an ENUMERATED type, the valid value rule “code” part is examined to extract any possible strings and values.

Any “sets” of data that are found are placed into an array, sorted, and re-stated in a syntactically valid and correct way, including any comment for that line. Properly formed ASN is left unchanged Many early standards did not handle enumerated lists of items correctly, and this rule was developed to correct this. If changes were made, a note is added to the log and displayed.

Show Correct BIT STRING lists

Rule Name:

Correct BIT STRING lists

Position:

Under: Validate valid value rule area

Name:

Scrub_BITSTRINGS

Default:

Checked

Usage:

The overall ASN is parsed and if it is determined to be an BIT STRING type, the valid value rule “code” part is examined to extract any possible strings and values.

Any “sets” of data that are found are placed into an array, sorted, and re-stated in a syntactically valid and correct way, including any comment for that line. Properly formed ASN is left unchanged Many early standards did not handle enumerated lists of items correctly, and this rule was developed to correct this. If changes were made, a note is added to the log and displayed.

Show Replace occurrences of 3-dot char with "..."

Rule Name:

Replace occurrences of 3-dot char with "..."

Position:

Under: Validate valid value rule area

Name:

ASN_3_Dots

Default:

Checked

Usage:

Those creating the standards using MS Word often have a problem with its autocorrect feature mucking up source code listings. One of the ways in which this occurs is that three periods in a row are translated to an (illegal in ASN) symbol. This rule detects this symbol and replace it with the three periods needed by valid ASN. If changes were made, a note is added to the log and displayed.

Aside: This, and several other annoying autocorrect changes, can be changed in MS Word as follows. In Word 2000, under Tools, in the Autocorrect command, in the AutoCorrect tab: There you will see a list box with "…" listed in it, delete this entry. Further down in this section you can also find the "itis" to "it is" rule which may also be annoying you by this time.

Show Replace occurrences of 4294967296 with 4294967295 (max unsigned value)

Rule Name:

Replace occurrences of 4294967296 with 4294967295 (max unsigned value)

Position:

Under: Validate valid value rule area

Name:

ASN_BigValues1

Default:

UN-Checked

Usage:

The valid value rule is parsed and if it is an INTEGER data type, and the upper range is set to 4294967296, then it is changed to be 4294967295 (which is the max allowed value in a 32 bit unsigned variable, recall that the range is defined as 0 to 2^N –1). If changes were made, a note is added to the log and displayed.

Show Replace occurrences of 2147483648 with 2147483647 (max signed value)

Rule Name:

Replace occurrences of 2147483648 with 2147483647 (max signed value)

Position:

Under: Validate valid value rule area

Name:

ASN_BigValues2

Default:

UN-Checked

Usage:

The valid value rule is parsed and if it is an INTEGER data type, and the upper range is set to 2147483648, then it is changed to be 2147483647 (which is the max allowed value in a 32 bit signed variable, recall that the range is defined as 0 to 2^N –1). If changes were made, a note is added to the log and displayed.

Show Remove duplicative ASN name entries when found in the valid value rule

Rule Name:

Remove duplicative ASN name entries when found in the valid value rule

Position:

Under: Validate valid value rule area

Name:

Remove_DupeNames

Default:

Checked

Usage:

If the proper name of the entry appears in both the ASN name field and the valid value rule field, it is removed from the 2nd field as well as the delimiter. If changes were made, a note is added to the log and displayed.

Show When a list is converted, keep old list as a comment

Rule Name:

When a list is converted, keep old list as a comment

Position:

Under: Validate valid value rule area

Name:

Keep_Old_Lists

Default:

UN-Checked

Usage:

If enabled, when a conversion from an older (not valid ASN) list has been made, typically from an enumeration or a bit string, then the original list is placed back at the end of the listing as a valid comment field. The user typically deletes this after confirming the automatic conversion was acceptable.


Validate message content rule area (container)

Check ASN.1 (container)

Rule Name:

Validate message content rule area (container)

Position:

Under: Check ASN.1

Name:

ASN_Messages

Default:

Checked

Usage:

A container class for a variety of rules that examines the contents of the message-body field. Like the contents of the valid-value-rule, the message body is basically everything past the name of the data frame (there is no data type in a complex data frame).

For historical reasons from IEEE 1488/89, all data frames, messages, and other complex types (such as dialogs) use the ASN Name and the message body as the fields to hold the ASN of the record. The data type and valid-value-rule fields are empty in these records.

This rule holds several other rules beneath it as follows:
[ Click on the arrows below to expand the rule and see its detailed information ]

Show All Show All
Hide All Hide All

Show Replace any tabs in message body with 3 spaces

Rule Name:

Replace any tabs in message body with 3 spaces

Position:

Under: Validate message content rule area

Name:

MSG_RemoveTabs

Default:

Checked

Usage:

The message body field is parsed and any occurrences of tab characters are replaced with three spaces. Spaces are preferred over tabs so that when printed in a mono-spaced type the listing appears correct. If changes were made, a note is added to the log and displayed.

Show Replace any non-ASCII chars (values >127) with pure ASCII

Rule Name:

Replace any non-ASCII chars (values >127) with pure ASCII

Position:

Under: Validate message content rule area

Name:

MSG_JustASCII

Default:

Checked

Usage:

The message body field is parsed and any occurrences of characters with hex values above 127 are replaced. The replacement strings are taken from similar characters when possible (for example, the right hanging quote symbol is replaced with a straight quote). If changes were made, a note is added to the log and displayed.

Show Indent trailing lines in structure by 3 spaces (pretty print)

Rule Name:

Indent trailing lines in structure by 3 spaces (pretty print)

Position:

Under: Validate message content rule area

Name:

MSG_IndentLines

Default:

Checked

Usage:

The message body field is parsed and all lines following after the first line are indented at least three spaces to present some white space along the left edge of the listing. A rather primitive pretty print. If changes were made, a note is added to the log and displayed.

Show Remove duplicative ASN name entries when found in the message body

Rule Name:

Remove duplicative ASN name entries when found in the message body

Position:

Under: Validate message content rule area

Name:

Remove_DupeNames2

Default:

Checked

Usage:

If the proper name of the entry appears in both the ASN name field and the message body field, it is removed from the 2nd field as well as the delimiter. If changes were made, a note is added to the log and displayed.

Show Error on multiple ASN entries per single record

Rule Name:

Error on multiple ASN entries per single record

Position:

Under: Validate message content rule area

Name:

MSG_MultiEntry

Default:

Checked

Usage:

It is allowed to have only one complete ASN entry per record, more than this is problematic, even if the definitions are simply the “stubs” of what is defined above. This rule checks for this occurrence by the very primitive means of detecting multiple “::=” patterns in the listing. If found, a warning is given.

Show Align start and end brackets on separate lines

Rule Name:

Align start and end brackets on separate lines

Position:

Under: Validate message content rule area

Name:

MSG_Align

Default:

UN-Checked (not released)

Usage:

Not yet defined.

This rule has not yet been completed.

Show Indent each element entry by 3 spaces

Rule Name:

Indent each element entry by 3 spaces

Position:

Under: Validate message content rule area

Name:

MSG_Indent

Default:

UN-Checked (not released)

Usage:

Not yet defined.

This rule has not yet been completed.

Show Check for (illegal) content in the DataType field and moves it, if found

Rule Name:

Check for (illegal) content in the DataType field and moves it, if found

Position:

Under: Validate message content rule area

Name:

MSG_DataType

Default:

Checked

Usage:

Looks for any content in the data type field (which should be empty in this record type) and if found nags the user about it. It may move the data type to the message body field if that seems logical based on the contents. If changes are made, a summary is given.

Show Warn on finding unlimited SEQUENCE OF streams

Rule Name:

Warn on finding unlimited SEQUENCE OF streams

Position:

Under: Validate message content rule area

Name:

MSG_SeqLimits

Default:

Checked

Usage:

Looks at the message body for any content where a SEQUENCE OF occurs without any boundary or restriction information on its allowed length. Such use is strongly frowned upon in ITS because a message with this encoding cannot be fully tested (it could be in infinite length). If found, a warning is given.

Show Require 2 part declarations [instance TypeDef form]

Rule Name:

Require 2 part declarations [instance TypeDef form]

Position:

Under: Validate message content rule area

Name:

MSG_RequireNames

Default:

UN-Checked (not released)

Usage:

Not yet defined.
This rule has not yet been completed.

Show Align each element and type def (pretty print)

Rule Name:

Align each element and type def (pretty print)

Position:

Under: Validate message content rule area

Name:

MSG_AlignContent

Default:

UN-Checked (not released)

Usage:

Not yet defined.

This rule has not yet been completed.

Show Auto add XML Local Content Keyword after each ...

Rule Name:

Auto add XML Local Content Keyword after each ...

Position:

Under: Validate message content rule area

Name:

MSG_LocalContent

Default:

UN-Checked (not released)

Usage:

Not yet defined.

This rule has not yet been completed.

Show Force element comments to next line, aligned with TypeDef

Rule Name:

Force element comments to next line, aligned with TypeDef

Position:

Under: Validate message content rule area

Name:

MSG_Comments

Default:

UN-Checked (not released)

Usage:

Not yet defined.

This rule has not yet been completed.

Show Run ASN.1 complier to validate entry (slow)

Rule Name:

Run ASN.1 complier to validate entry (slow)

Position:

Under: Validate message content rule area

Name:

MSG_Validate

Default:

UN-Checked (not released)

Usage:

Not yet defined.

This rule has not yet been completed.

Show Warn when unable to link to included elements

Rule Name:

Warn when unable to link to included elements

Position:

Under: Validate message content rule area

Name:

MSG_Links

Default:

UN-Checked (not released)

Usage:

Not yet defined.

This rule has not yet been completed.

Show Process in-line element declarations using Data Type rules (above)

Rule Name:

Process in-line element declarations using Data Type rules (above)

Position:

Under: Validate message content rule area

Name:

MSG_Locals

Default:

UN-Checked (not released)

Usage:

Not yet defined.

This rule has not yet been completed.

Show Add element names to local dictionary

Rule Name:

Add element names to local dictionary

Position:

Under: Validate message content rule area

Name:

MSG_Terms

Default:

UN-Checked (not released)

Usage:

Not yet defined.

This rule has not yet been completed.


The Rules dealing with XML entries (container)

Check ASN.1 (container)

Rule Name:

The Rules dealing with XML entries (container)

Position:

Root

Name:

XML_Checks

Default:

Checked

Usage:

A container class used to hold the rules which apply to aspects of the XML portions of the record. These rules are not a substitute for a good XML schema syntax checking tool.

This rule holds several other rules beneath it as follows:
[ Click on the arrows below to expand the rule and see its detailed information ]

Show All Show All
Hide All Hide All

Show Replace any tabs in XML with 3 spaces

Rule Name:

Replace any tabs in XML with 3 spaces

Position:

Under: The Rules dealing with XML entries

Name:

XML_RemoveTabs

Default:

Checked

Usage:

The XML schema is parsed and any occurrences of tab characters are replaced with spaces.

Spaces are preferred over tabs so that when printed in a mono-spaced type the listing appears correct. If changes were made, a note is added to the log and displayed.

Show Replace any non-ASCII chars (values >127) with pure ASCII

Rule Name:

Replace any non-ASCII chars (values >127) with pure ASCII

Position:

Under: The Rules dealing with XML entries

Name:

XML_JustASCII

Default:

Checked

Usage:

The XML schema is parsed and any occurrences of characters with hex values above 127 (which are in fact illegal in ITS-style XML which uses the UTF-8 encoding) are replaced.

The replacement strings are taken from similar characters when possible (for example, the right hanging quote symbol is replaced with a straight quote) If changes were made, a note is added to the log and displayed.

Show Warn when a message record does not produce an element entry

Rule Name:

Warn when a message record does not produce an element entry

Position:

Under: The Rules dealing with XML entries

Name:

XML_msg

Default:

Checked

Usage:

If the record type is of type “message” then normally an <element> entry is also created when the XML is created. For all other types (as well as for the message), an abstract type is created (there is no element). A type is a better choice for reasons of data reuse.

Side note: If you pick up your typical “idiot’s guide to XML” textbook you will see extensive use of elements being created in the examples, rather than types. This is reflective of the author’s lack of understanding data reuse concepts, and the ITS style does not follow it.

Show Warn when an XML name does not match the ASN name

Rule Name:

Warn when an XML name does not match the ASN name

Position:

Under: The Rules dealing with XML entries

Name:

XML_name

Default:

Checked

Usage:

The typical pattern followed by standards creators is to have the ASN and XML proper names match. The tool, when it automatically creates the XML listing by translating the ASN listing, follows this naming convention. The user may change the names to something different, and if this is the case the tool will maintain that name (even as it updates the XML listing). This rule provides a warning when such different names are found in the record. This may not be an error, but as general style guideline, it should be avoided.

Warning: If you create records with different XML names than ASN names, then you should be very careful always to leave the option “Skip Link Resolution Testing” UN-checked when creating XML. This setting ensures that the tool will convert each fragment of ASN used in another record to its XML form, then seek out the correct record for the entry and use the actual (perhaps different) XML name for the element. Various warnings are produced if no matching record is found, if no XML is found, or if multiple records are found. See the page on converting to XML here for further details of this process. Keep in mind that should you change the ASN name of the entry the XML name may also need to be changed.

Show Automatically set message records to produce elements (restore defaults)

Rule Name:

Automatically set message records to produce elements (restore defaults)

Position:

Under: The Rules dealing with XML entries

Name:

XML_AutoMsg

Default:

UN-Checked

Usage:

The typical pattern followed by standards creators is to produce XML “types” for all record entries except for messages, where a type and an element are produced. This rule, when enabled, restores the checkbox “Make an Element Entry” to its default state (checked for message record types, unchecked for others).

See also the rule Warn when a message record does not produce an element entry above this page.

Show Automatically set to auto-update XML (will lose any manual editing)

Rule Name:

Automatically set to auto-update XML (will lose any manual editing)

Position:

Under: The Rules dealing with XML entries

Name:

XML_AutoUpdate

Default:

UN-Checked

Usage:

The typical usage pattern followed by standards creators is to allow the tool to re-create the XML automatically when needed and there is almost no occasion to actually edit it by hand. Should such editing occur in a record, the Allow Updating of XML… checkbox becomes UN-checked and further automatic updating of the record is disabled. Thus, the user’s manually added editing is preserved.

If the user subsequently presses Create XML then an automatically generated set of XML is again created and the check box is again checked. This rule is used to reset the record (or all records in a table) to enable auto-updates to occur again.


The Descriptive Name Rules (container)

Check ASN.1 (container)

Rule Name:

The Descriptive Name Rules (container)

Position:

Root

Name:

Desc_Name

Default:

Checked

Usage:

A container class used to hold the rules which apply to aspects of the Descriptive Name of the record.

This rule holds several other rules beneath it as follows:
[ Click on the arrows below to expand the rule and see its detailed information ]

Show All Show All
Hide All Hide All

Show Create Descriptive Names from ASN when blank

Rule Name:

Create Descriptive Names from ASN when blank

Position:

Under: The Descriptive Name Rules

Name:

Desc_Blank

Default:

Checked

Usage:

If there is no descriptive name content in the record (which occurs in a number of older databases) then use the ASN name field to create a suitable descriptive name and make some primitive guesses about the type of entry this is (simple or complex, data element or data frame). If changes were made, a note is added to the log and displayed.

Show Prepend front of Descriptive Name based on table type

Rule Name:

Prepend front of Descriptive Name based on table type

Position:

Under: The Descriptive Name Rules

Name:

Desc_PrePend

Default:

UN-Checked

Usage:

Use the style of naming found in SAE and IEEE standards work, which is to append one of the following items (“DE_”, “DF_”, “Msg_”) to descriptive name fields that do not have such a string to make them match the styles used in those standards. If changes were made, a note is added to the log and displayed.

Show Warn on duplicate Descriptive Name entries

Rule Name:

Warn on duplicate Descriptive Name entries

Position:

Under: The Descriptive Name Rules

Name:

Desc_Dupes

Default:

UN-Checked (not released)

Usage:

As a general rule only one record in the table should have any given descriptive name, duplicates are not allowed. This can be problematic for the SQL calls in the tools, but it also violates the rules of IEEE 1488/89 for how data records are created. In some older MS access tools that were developed by others this can cause application failures as well, and may require hand removal in MS Access for the table to be usable. This rule detects the presence of such records and warns the user.

Remarkably there are very few descriptive names that conflict across all of ITS, so this rarely occurs and then only when multiple standards are merged into the same tables. In such a case, the descriptive names must uniquely resolve through the use of module names or namespaces or the ASN and XML will not compile.

Of course the user can create such names, and this most often occurs when iterating variations of a data concept in the development process. In such cases, append a letter or number to the name to differentiate them (i.e. MyEntry1, MyEntry2, etc.).


The Textual Descriptive Entry Rules (container)

Check ASN.1 (container)

Rule Name:

The Textual Descriptive Entry Rules (container)

Position:

Root

Name:

Desc_Text

Default:

Checked

Usage:

A container class used to hold the rules which apply to aspects of the Description (Use) field of the record.

This rule holds several other rules beneath it as follows:
[ Click on the arrows below to expand the rule and see its detailed information ]

Show All Show All
Hide All Hide All

Show Ensure two spaces exist between each sentence

Rule Name:

Ensure two spaces exist between each sentence

Position:

Under: The Textual Descriptive Entry Rules

Name:

Desc_Spaces

Default:

Checked

Usage:

This rule examines the descriptive text entry and makes sure that every end of sentence (a period and one or more spaces) has two spaces before the next sentence.

This convention aids Microsoft Word, Frame maker, and several other type setting programs to better lay out the spacing (letter kerning) between sentences. If changes were made, a note is added to the log and displayed.

Show Replace each tab with 3 spaces

Rule Name:

Replace each tab with 3 spaces

Position:

Under: The Textual Descriptive Entry Rules

Name:

Desc_Tab3

Default:

Checked

Usage:

This rule examines the descriptive text entry and replaces any tab characters found with three spaces. See also the rule: Replace each tab with 4 spaces If changes were made, a note is added to the log and displayed.

Show Replace each tab with 4 spaces

Rule Name:

Replace each tab with 4 spaces

Position:

Under: The Textual Descriptive Entry Rules

Name:

Desc_Tab4

Default:

UN-Checked

Usage:

This rule examines the descriptive text entry and replaces any tab characters found with four spaces. See also the rule: Replace each tab with 3 spaces If changes were made, a note is added to the log and displayed.


The Textual Remarks Entry Rules (container)

Check ASN.1 (container)

Rule Name:

The Textual Remarks Entry Rules (container)

Position:

Root

Name:

Rem_Text

Default:

UN-Checked

Usage:

A container class used to hold the rules which apply to aspects of the Remarks field of the record.

This rule holds several other rules beneath it as follows:
[ Click on the arrows below to expand the rule and see its detailed information ]

Show All Show All
Hide All Hide All

Show Ensure two spaces exist between each sentence

Rule Name:

Ensure two spaces exist between each sentence

Position:

Under: The Textual Descriptive Entry Rules

Name:

Rem_Spaces

Default:

UN-Checked

Usage:

This rule examines the remarks text entry and makes sure that every end of sentence (a period and one or more spaces) has two spaces before the next sentence.

This convention aids Microsoft Word, Frame maker, and several other type setting programs to better lay out the spacing (letter kerning) between sentences. If changes were made, a note is added to the log and displayed.

Show Replace each tab with 3 spaces

Rule Name:

Replace each tab with 3 spaces

Position:

Under: The Textual Descriptive Entry Rules

Name:

Rem _Tab3

Default:

UN-Checked

Usage:

This rule examines the remarks text entry and replaces any tab characters found with three spaces. See also the rule: Replace each tab with 4 spaces If changes were made, a note is added to the log and displayed.

Show Replace each tab with 4 spaces

Rule Name:

Replace each tab with 4 spaces

Position:

Under: The Textual Descriptive Entry Rules

Name:

Rem _Tab4

Default:

UN-Checked

Usage:

This rule examines the remarks text entry and replaces any tab characters found with four spaces. See also the rule: Replace each tab with 3 spaces If changes were made, a note is added to the log and displayed.


Rules dealing with external record reuse (container)

Check ASN.1 (container)

Rule Name:

Rules dealing with external record reuse (container)

Position:

Root

Name:

Ext_Rules

Default:

Checked

Usage:

A container class used to hold the rules which apply to aspects of the record when used in the ExternalDEs type of table. These rules deal with changing the names of such entries (pre-pending “EXT_” which is no longer in general use) and with confirming that the record has a proper source field (needed to manage references back to its code module).

This rule holds several other rules beneath it as follows:
[ Click on the arrows below to expand the rule and see its detailed information ]

Show All Show All
Hide All Hide All

Show PrePend an EXT_ on the descriptive name when linked

Rule Name:

PrePend an EXT_ on the descriptive name when linked

Position:

Under: Rules dealing with external record reuse

Name:

Ext_Name

Default:

UN-Checked

Usage:

The phrase “Ext_” is added to the beginning of the descriptive name for the record. This is used by some standards to indicate that the record comes from another standard. If changes were made, a note is added to the log and displayed.

Note that it is now considered poor form to modify the other SDOs records in any form. And using this rule would remove the locking value for that record. Current practice is to try and use the record "as is" from the originating SDO.

Show Prepend NOT_USED_ on entries with no linking found

Rule Name:

Prepend NOT_USED_ on entries with no linking found

Position:

Under: Rules dealing with external record reuse

Name:

Ext_NOTUSED

Default:

UN-Checked

Usage:

The record is checked for links used (using the current linking table settings) and if NO links to other tables are found, the phrase “NOT_USED_” is added to the beginning of the descriptive name for the record.

This is used by some standards as part of a clean up phase of effort to ensure that the entries on the ExteralDes table are in fact used by the standard (that the other tables have at least one data frame that references this entry). Note that you can also set the 1st Word tool to flag entries that have no linking to others with some warning text as well.

Show Warn when source of record is empty (unknown module)

Rule Name:

Warn when source of record is empty (unknown module)

Position:

Under: Rules dealing with external record reuse

Name:

Ext_Source

Default:

UN-Checked

Usage:

The source field of the record is checked to confirm that it has some content (text length > 0) It does attempt to match the source string to the list of known standards and their FADD.

If no content is found then the record can not be correctly mapped to an SDO and FADD family, and therefore can not be properly referenced by other records. Such entries are placed into the “Unknown” FADD. In a well formed database there would be no entries in this namespace.


Meta-Data Registry Rules (container)

Check ASN.1 (container)

Rule Name:

Meta-Data Registry Rules (container)

Position:

Root

Name:

Meta_Rules

Default:

Checked

Usage:

A container class used to hold the rules which apply to a number of different meta-data fields of the record. Frankly, there are a number of rules outlined in IEEE 1488/89 (the document which defines how the data registry is to work and what the allowed values of some fields are) that simply need to be followed. This rule area deals with many of these.

This rule holds several other rules beneath it as follows:
[ Click on the arrows below to expand the rule and see its detailed information ]

Show All Show All
Hide All Hide All

Show Correct Configuration Baseline

Rule Name:

Correct Configuration Baseline

Position:

Under: Meta-Data Registry Rules

Name:

Meta_Base

Default:

Checked

Usage:

The configuration field of the record is checked for correctness. If no content is found, the term "IEEE 1489" is added. If the term "IEEE P1489" is found, it is changed to be "IEEE 1489" (the P indicates that an IEEE document is a draft, this document is now adopted, so the P is removed). If any other text is found, it is left alone. If changes were made, a note is added to the log and displayed.

Show Correct CLASSIFICATION SCHEME use

Rule Name:

Correct CLASSIFICATION SCHEME use

Position:

Under: Meta-Data Registry Rules

Name:

Meta_Base2

Default:

Checked

Usage:

The CLASS_SCHEME field of the record is checked for correctness. If no content is found, the term "IEEE 1489" is added. If the term "IEEE P1489" is found, it is changed to be "IEEE 1489" (the P indicates that an IEEE document is a draft, this document is now adopted, so the P is removed). If the term "IEEE 1489-1999" is found, it is changed to be "IEEE 1489" instead. This last case is an example of the sort of mindless control word lists (CWLs) that the original data registry defined as being correct. If any other text is found, it is left alone. If changes were made, a note is added to the log and displayed.

Show Correct Schema Version

Rule Name:

Correct Schema Version

Position:

Under: Meta-Data Registry Rules

Name:

Meta_Schema

Default:

Checked

Usage:

The CLASS_VER field of the record is checked for correctness. If no content is found, the term "1.0" is added. This is the only defined item in the CWL for this field. If changes were made, a note is added to the log and displayed.

Show Set Class name to be ITS if blank

Rule Name:

Set Class name to be ITS if blank

Position:

Under: Meta-Data Registry Rules

Name:

Meta_Class

Default:

Checked

Usage:

The CLASS_NAME field of the record is checked for correctness. If no content is found, the term "ITS" is added. There are a large number of possible control word terms here, with categories like “System Management-Transit” or “Moving Components-Vehicle Probe Data” etc. The list has never enjoyed wide use or review, however IEEE 1488/89 specified that you must pick a term from it.

Aside: You can see the list in the edit window when in verbose mode, it is called “Class Name”] The rules also specify that when a concept is used in more than one place (as most are) that the term “ITS” is to be used. Hence, we use this as the default term here to produce an “IEEE 1488/89 conformant” record. If changes were made, a “nag” note is added to the log and displayed suggesting the user may want to pick a better name.

Show Set OID value to zero if blank

Rule Name:

Set OID value to zero if blank

Position:

Under: Meta-Data Registry Rules

Name:

Meta_OID

Default:

UN-Checked

Usage:

The OID field (object Identifier) of the record is checked for correctness. If no content is found, the term "0000" is added. In order to be “IEEE 1488/89 conformant” a record must have an OID of some value, but no specific numbering value systems is provided.

Some device type standards (such as NTCIP) make use of the OID value and employ a numbering off the NEMA part of the tree which they can relate to the MIB. Others use a mix of free text here. Most ITS message sets do not use or need an OID. If an OID is present in the record it is printed in various reports. If changes were made, a note is added to the log and displayed.

Show Set Descriptive Name Context value to Manage Traffic if blank

Rule Name:

Set Descriptive Name Context value to Manage Traffic if blank

Position:

Under: Meta-Data Registry Rules

Name:

Meta_Context

Default:

Checked

Usage:

The DESC_NAME_CONTEXT field of the record is checked for correctness. If no content is found, the term "Manage Traffic" is added. There are a large number of possible control word terms here, with categories like “Electronic Payment” or “Manage Archives” etc. The list has never enjoyed wide use or review, however IEEE 1488/89 specified that you must pick a term from it.

Aside: You can see the list in the edit window when in verbose mode, it is called [“Desc. Name Context”] The rules also allow that when a concept is used in more than one place (as most are) that the term “Manage Traffic” may be used. Hence, we use this as the default term here to produce an “IEEE 1488/89 conformant” record. If changes were made, a “nag” note is added to the log and displayed, suggesting the user may want to pick a better name.

Show Set record revision to be zero if blank

Rule Name:

Set record revision to be zero if blank

Position:

Under: Meta-Data Registry Rules

Name:

Meta_Revision

Default:

Checked

Usage:

The REG_REV field (registration revision) of the record is checked for correctness. If no content is found, the term "0" is added. Any other content is left unchanged. If this field has a numerical content, then the tool will automatically advance the value each time the data concept is edited and saved. If changes were made, a note is added to the log and displayed.

Show Set default record type to be Data Element if blank

Rule Name:

Set default record type to be Data Element if blank

Position:

Under: Meta-Data Registry Rules

Name:

Meta_RecordType

FIX with NEW CODE BASE!

Default:

Checked

Usage:

The RecordType field of the record is checked for content. If no content is found, it is set to be a “Data Element” type. Any other content is left unchanged. If changes were made, a note is added to the log and displayed.

Show Warn if SOURCE standard is blank

Rule Name:

Warn if SOURCE standard is blank

Position:

Under: Meta-Data Registry Rules

Name:

Meta_Source

Default:

UN-Checked

Usage:

The Source field of the record is checked for content. If no content is found, it is set to be a “Unknown” type. Any other content is left unchanged with the presumption it is the name of a real standard. If changes were made, a “nag” note is added to the log and displayed suggesting the user may want to pick a better name.

Show Auto Set VOLUME MAP from SOURCE field

Rule Name:

Auto Set VOLUME MAP from SOURCE field

Position:

Under: Meta-Data Registry Rules

Name:

Meta_VolMap

Default:

UN-Checked

Usage:

The Source and the Vol_Map fields of the record are examined for content. If some source content is found, AND if the volume map is set to all volumes (“00”) then the source is examined to attempt to detect what specific volume(s) the record belongs in. The source string is compared to a series of keywords to determine which standard it relates to. This provides a crude way to properly set the volumes map for a group of records. At this time, only the IEEE 1512 “Incident Management” effort (with 5 volumes at present) makes use of this feature. [Aside: It may be that NTCIP comes to use it ] Note that the volume map field can hold a sequence of volumes that a record is to appear in (i.e. 01, 02, 04, 05), although the values “00” (all volumes) or a single value is more common. If changes were made, a note is added to the log and displayed.

Show Warn if set to ALL in the VOLUME MAP

Rule Name:

Warn if set to ALL in the VOLUME MAP

Position:

Under: Meta-Data Registry Rules

Name:

Meta_TagAllVol

Default:

UN-Checked

Usage:

The Vol_Map field of the record is examined for content. If the volume map is set to use the record in all volumes (“00” or empty) then a warning is provided. For single volume documents, the value of “00” is used, and presents no problems.

If a standard is to be divided and published into separate volumes, very few or almost no records would remain in the “00” category. This rule provides an easy way to find any such records.

As a matter of good systems engineering, records should never be defined more than once, hence they do not appear in multiple volumes. By contrast, terms and acronyms (another two tables in which the records use a volume map) are often repeated in each volume.

Show Set all records in table to appear in Volume One only

Rule Name:

Set all records in table to appear in Volume One only

Position:

Under: Meta-Data Registry Rules

Name:

Meta_SetVol_1

Default:

UN-Checked

Usage:

The Vol_Map field of the record is examined for content. The value is set to “01” so that the record will appear in the first volume of the set. If changes were made, a note is added to the log and displayed.

<-LAST TOP


Registry Parser

Glossary Item Box

Getting Started: Getting Started

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes

See Also MEdit Send comments on this topic.

Registry Parser

Registry Parser

The Registry Output Converter is a self contained application used to convert textual dumps from the original on-line IEEE data registry into various useful formats, including those used by Mini-Edit. Because the on-line IEEE data registry has been decommissioned, it is no longer needed or employed by Mini-Edit users. It is included here for completeness, and because it can be launched from the Mini-Edit main screen by pressing the Import... button.

Aside: If we move to another on-line registry system, this tool will still not be needed because the file formats used will differ. In the original IEEE registry system, a unique token delimited data style was used as the exchange formats, and hence this tool was developed. It is likely that any such a system designed today will upload and download sets of records and tables transparently to the user, further eliminating the need for such a tool.

If you are interested in the outdated data concepts from this period, see the files at www.itsware.net/miniedit/RegistryDumps/

The structure of the Registry Parser

Registry Output Converter

NEXT->

See Also

Getting Started: Getting Started

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes


Registry Output Converter

Registry Output Converter

Registry Output Converter

The Registry Output Converter is a self contained application used to convert textual dumps from the original on-line IEEE data registry into various useful formats, including those used by Mini-Edit. Because the on-line IEEE data registry has been de-commissioned, it is no longer needed or employed by Mini-Edit users. It is included here for completeness, and because it can be launched from the Mini-Edit main screen by pressing the Import... button.

1 File to Process

File to Process What file and path to open and process.
[Top]

2 View Source

View Source Opens the selected file using whatever viewer the user has registered (typically a text file).
[Top]

3 Browse...

Browse... Used to select the file that will be processed, it starts a standard windows file open Dialog.
[Top]

4 Option controls

Option controls Various processing options used to control the import of the data and how it is extracted, processed, and made into records.

· Verbose [Default OFF]
Enables additional process comment in the status areas at a cost of slower through put; used to find bad lines in the input which may cause problems in processing.
· Process Commented Tags Too [Default ON]
Some sources of data have additional comment tags that need to be processed to gather all the data present in the record, which this option enables.
· Trims White Space from Tags [Default ON]
White space found in the tag names is ignored and not used when detecting tag type. The IEEE registry export format style pre-dates XML and it has some odd quirks like this that need to be overcome.
· Trim White Space from Content [Default ON]
As a rule we trim dangling white space (spaces and tabs) in the records at all times; this option enables that behavior. And as a side effect, record fields do not grow with mindless extra spaces (a latent error the IEEE registry tool had).
· Smart Trim Content [Default ON]
Remove dangling line feeds and resulting white space (LF, CR_LF etc) in the records at all times; this option enables that behavior.
· Auto View [Default ON]
When enabled, the file produced is automatically run, as if the View Output button had been pressed.
· Skip Empty XML Tags [Default OFF]
When outputting a file (especially an XML rendition of the data) it often occurs that there is no content in a particular tag set. This option, when checked, suppresses writing tags with no content, producing a smaller output file.
· Presume a format of "<tag> Data" [Default OFF]
Some sources (often those created by data stewards by hand) do not follow the leading space format found in file produced by the IEEE registry systems. This option, when checked, relaxes the rule checking used to successfully process such data.
· Presume " <end>" [Default OFF]
Some sources (often those created by data stewards by hand) do not follow the trailing space format found in files produced by the IEEE registry systems. This option, when checked, relaxes the rule checking used to successfully process such data.

The default setting are generally best unless there is a need to change them.
[Top]

5 Generate ASN1

Generate ASN1 When pressed, the current file will be processed to extract all the relevant ASN code entries found in it, and these will be gathered into a textual ASN source file for further use. The final file will be named as per the file name provided to the right. Any prior file by that name will be deleted. Typically a proper ASN header section is then added and the source file is processed by a complier. You can achieve the same results using the Export1 button in the Mini-Edit tool.
[Top]

6 Generate XML

Generate XML When pressed the current file will be processed to extract all the relevant records and fields found in it, and these will be reformatted and gathered into properly formatted XML file for further use. The final file will be named as per the file name provided to the right. Any prior file by that name will be deleted. Typically this is used to export the raw data record to another tool or application. You can achieve the same results using the Export1 button in the Mini-Edit tool.
[Top]

7 Generate Access

Generate Access When pressed, the current file will be processed to extract all the relevant records and fields found in it, and reformat them into a new table in an existing Access File. Note that the Access file needs to exist and not be in a locked state. The new table will have only those fields that the IEEE registry supported, so when it is first opened for viewing by Mini-Edit the table structures and many addition fields will then be added to it to make it current. After this completes, the table sorting utility can be used to extract records, rename the table, etc. as needed.
[Top]

8 View Output

View Output When pressed, the file produced above will be opened, using whatever application the user has registered for that file type (*.TXT, *.XML, *MDB).
[Top]

9 Status Bar

Status Bar During processing, the current status and operation is displayed here. A progress bar appears underneath for some operations.
[Top]

10 Quit button

Quit button Exit the program.
[Top]

TOP


1st Word Users Guide

Glossary Item Box

Getting Started: Getting Started

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes

See Also MEdit Send comments on this topic.

1st Word Users Guide

1st Word Users Guide

The 1st Word tool is used by the standards developing organizations to take the database maintained by the Mini-Edit tool and render it into a complex printed document for publishing and balloting in the somewhat unique processes used by each SDO. The tool was originally developed internally by SCSC when we became a contractor to several different SDOs developing ITS standards and found it in our own self interest to automate much of the process. This reduced the drudgery inherent in creating a document of many hundreds of pages from weeks to a few hours as well as dramatically reducing the number of errors in the final product. Other standards organizations desired to have access to this tool, and as this also benefited our client who wanted to re-use their entries, the tool was born. At this point in time this tool produces ALL of the active ITS data and message set standards except the NTCIP device standards work which still uses some alternative methods in order to support the MIB process.

In order to obtain this tool you need to be either an SDO or a consultant working for an SDO producing ITS standards, (i.e be one of the Data Stewards). It is not distributed to the general public. The SDO community uses this tool to produce materials which bear their copyright. As you might expect, they remain concerned that end users not be in a position to reverse-engineer these documents in a fashion that would be found harmful.

In order to actually use the tool once you have it, you will need a good database, but also a number of collateral documents specific to the standard that you are developing. This includes all the front and back matter that traditionally is found and used in the creation of a standard. This tool will not magically create that for you; you must still author it by hand in some way. What this tool will do for you is automate the collection and merging of these separate parts of the document with other parts that come from the data dictionary. You will also need a set of style sheets for the SDO, meeting the style guidelines that they use. When it is done, you will still need to do a few things by hand before the document is complete (it is named first Word, not last word, in order to reflect this).

The structure of the 1st Word Users Guide

Start Up View
Preflight Errors
Typical Post-Run View
File Setting Area
Overall Formating Style
Recipe Area
Process Step Selection
Process Steps, typical order
Options Area
File not found Dialog
Tables to link to Dialog

NEXT->

See Also

Getting Started: Getting Started

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

Multi-Linker: Multi_Linker

Support Annexes: Support Annexes


Start Up View

Start Up View

Start Up View

This view shows the tool when first run and before any SDO specific script runs have been loaded. The tool is basically a single view panel which invokes and remotely controls MS Word for most of its rendering operations. When operating, it can be placed in the background and Word placed in the foreground (although the user must not click on Word while it is running or the automation may be disturbed). Ideally the best way to render documents is on a double screen monitor system where you can observe MS Word being created as well as have full view of 1st Word. This is the normal setup used by SCSC in its work. Users with multiple processor systems may want to run 1st Word on one processor and MS Word on another processor for faster run times. Typical run-off rates are about 30 finished pages per minute (about two pages per second), excluding the final hyper linking times.

The control will be broken up and described in five groups in the following pages.

A warning for new users: This tool expects to take over and run MS Word on your machine using remote automation calls. It expects complete and exclusive access to MS Word when running, therefore you cannot edit other documents or have them open with word at the same time. You can of course run word before and after the actual run, but not during.

1 File Setting Controls

File Setting Controls The File Setting Controls deal with selecting what database file will be processed, what style sheet will be used to guide the output, and what the final output document will be called. These controls are described in further detail here.

In those standards that are broken up into multiple volumes, this section also controls which volume (and therefore what subset of content) will be processed.

A required first step of starting MS Word and establishing the inter-process automation links is also shown here, a necessary first step for all runs.
[Top]

2 Overall Style Settings

Overall Style Settings The Overall Style Setting area deals with selecting the gross style and description that will be used by the run. Most SDOs, and most document renderings, have some pretty repeatable habits. Rather then set all these buttons by hand each time, this section sets up the default settings which that SDO prefers to use. These controls are described in further detail here.
[Top]

3 Recipe Setting Controls

Recipe Setting Controls The Recipe Setting area deals with selecting the specific steps of each run and which table or external files are to be used. These controls are described in further detail here.
[Top]

4 Run and Status Controls

Run and Status Controls The Run and Status Control area deals with starting the run and viewing the results after the run completes. These controls are described in further detail below.

The button Perform Selected Steps is the go button. When this button is pressed the program attempts to pre-flight the current script list. If the preflight testing passes, the run is started with each step handled in turn until the script is completed. A discussion about the pre-flight process and its errors can found here.

A Pre-flight test involves seeking for the files, tables, and Misc text entries that are used in each processing step to confirm that they exist BEFORE the actual processing begins. Steps that pass are shown with a check box. If the pre-flight fails, an icon showing which steps failed is displayed as well as an error report. You can also click on the icon to get data relevant to that step. Correct things and repeat.

The button View Result is used to run the word document when completed.

The button Quit is used to exit the program.

Below these buttons is a status line, used to provide detailed feedback on the processing of each record in turn. A progress bar appears here for many of the processing steps as well.

[Top]

5 Processing Options

Processing Options The Processing Options area deals with selecting various details of how the document is rendered, which will be used in the run to affect the style and formatting. Like the process steps, rather then set all these buttons by hand each time, this section is set up to SDO default values by the choice of overall style. These controls are described in further detail here.
[Top]


Preflight Errors

Preflight Errors

A Pre-flight test involves seeking for the files, tables, and Misc text entries that are used in each processing step to confirm that they exist BEFORE the actual processing begins.

Steps that pass are shown with a check box. If the pre-flight fails, a question mark icon is shown at the step(s) which failed. You can also click on the icon to get data relevant to that step. A report of the errors or problems found is presented to the user. Correct things and repeat.

If all the Pre-flight tests pass, the check boxes are removed and the script begins to run for real.

1 Preflight OK

Preflight OK This step passed the pre-flight tests for its process.

[Top]

2 Preflight Problems

Preflight Problems This step did NOT pass the pre-flight tests for its process. By clicking on the icon, you can see a report of what was missing. Perhaps the file to be included in this step could not be found.

[Top]

3 Status Line

Status Line The status line will report on the progress of the pre-flight testing as it proceeds.
[Top]


Typical Post-Run View

Typical Post-Run View

Typical Post-Run View

This view shows the tool when a run has been completed and the tool is finished. This run used the SAE J2354 ATIS standard for its script, but the recipe step settings and values are typical of most runs.

As you can see, the run took just under 44 minutes (2613 seconds) from start to finish and the vast majority of this time was taken up by the hyper-linking step (78% of the time). This run would be considerably longer if the external data concepts (step Do External Elements) had been rendered out (about 500 pages more).

1 Run Times and Status

Run Times and Status The overall running time of each step is presented here. Again, if any errors or strange things need to be reported about this step, the question mark icon will be displayed and the errors shown in a browser window. You can recall these error windows by clicking on the icon.
[Top]

2 Document Summary

Document Summary Some useful stats about the entire run are collected here and shown as well as being updated during the run. In this run we can see that...

A total of 3,304 access records were in some way accessed or touched. This reflects not only the records that were printed but those records that were found in SQL queries to determine linkages for the used-in sections.

In producing the word document, about 3,927 changes in the style were made in the text. Word has a working limit of about 20,000 such changes in any one document.

A total of 249 pages were produced (a thin standard by current norms).

In this document there are 927 bookmarks (landing places for hyperlinks), and 2,714 internal hyperlinks (places that link to these bookmarks). Word documentation claims to allow about 16,000 of these in any one document, although this tool has produced Word documents with over 20,000 such links.
[Top]


File Setting Area

File Setting Area

File Setting Area

The File Setting area allows the user to select the database file that will be rendered as well as what template to use and what to call the file to be created. It also allows specifying which volume is to be rendered when a multi-volume database is used.

1 Database File to Use

Database File to Use Select the database file to render from here. The Browse... button will bring up the normal file open Dialog . You can select *.ITS or *.MDB files to open. The file you select should have all the proper tables which you expect to use in it, if not correct it first with Mini-Edit. When opened, the name of the file will be examined and if a FADD like phrase is part of the name, the overall formatting style pattern for that SDO will be selected by default as well other default values.
[Top]

2 Style File to Use

Style File to Use Select the style sheet file to render from here. The Browse... button will bring up the normal file open Dialog . You can select a *.doc file to open. If you have selected a database file, this may be filed in for you as a default.

[Top]

3 File to Write

File to Write Name the output file to here. This is the name of the file that will be produced when the rendering is completed. If this file exists already, enable the check box to overwrite it. If you have selected a database file, this may be filled in for you as a default.
[Top]

4 Volume Match setting

Volume Match setting The volume matching control is only used with multi-volume publishing databases. If you have such a database, select which single volume you want to render in this run. The volume 00 represents rendering all the volumes into a single document.

Hint: To keep it all straight, the IEEE 1512 process (which uses 5 volumes) re-names each component part of the document with the proper volume number. Thus, the style sheet for volume one is called IEEE_1512_styles_vol01.doc and the like. All the included files of this volume end with _01 to make this clearer. This is a handy way to avoid mix-ups.
[Top]

5 Begin Word (step zero)

Begin Word (step zero) Step Zero, Start MS Word. A mandatory first step, common to all renderings. The remote automation to a copy of MS word is created in this step.
[Top]


Overall Formatting Style

Overall Formatting Style

Overall Formating Style

The Overall Style Setting area deals with selecting the gross style and description that will be used by the run. It basically re-sets many of the controls and switches and establishes the basic flow of the document in keeping with the practices and habits of each SDO. From the SDO-centric starting point, any remaining switch settings needed for that specific run can then be set.

Aside: Click the different buttons to see the variety of layout styles that the SDOs use. Note that some prefer a Message first ordering, while other prefer a Data Element first order. Some number their messages and data frames etc as part of the main document, while others make them all annex sections. Also, most use some form of terms and acronyms lists and most documents include (merge) external documents from other places

Note to Data Stewards: If you would prefer to have some setting another way, simply state your need. Each SDO can determine what the default settings are that best meet their own needs. If you find that you are often adjusting a control to some other value, ask that we change it here to save you time and trouble.

1 Built In Simple Format

Built In Simple Format A rudimentary format where the common tables are all rendered out. A good starting point if you are building a new format style. In the 14 steps that this style builds, all the commonly named tables are exported in a simple style. This more or less matches the overall style that SAE uses.
[Top]

2 IEEE Formats

IEEE Formats The formatting styles of the IEEE are handled here. Two formats are provided, the P (for draft) document style currently used in the Incident Management (1512) work and other standards of IEEE, and classic used with the older two-table style of documents.
[Top]

3 APTA TCIP Formats

APTA TCIP Formats APTA (in charge of the TCIP effort) enjoys three formatting buttons, all of which reflect various needs in producing the TCIP standard. This is one of the standards where the XML is rendered in a collection at the end rather then with every record as is done in other SDOs.
[Top]

4 SAE Formats

SAE Formats The SAE uses its three button styles to produce several standards: ATIS, ITIS, LRMS and DSRC. The J button (J stands for ground standards in the SAE world) is the primary one used. The classic button provides the two table styles of rendering for backward compatibility. The ITIS button performs some unique formatting required by the ITIS codes.
[Top]

5 NTCIP Format

NTCIP Format The NTCIP button provides a set of formats to be used when NTCIP objects (MIBs) need to be converted into a FADD like standard (this occurred when other standards such as TMDD or ATIS need to use the NTCIP objects in their own work). Reserved for future growth at this time.

[Top]

6 ITE TMDD Formats

ITE TMDD Formats The ITE-TMDD button provides a set of formats which are useful in rendering the TMDD documents.
[Top]


Recipe Area

Recipe Area

The recipe area controls the actual order and flow of the script. It outlines what will occur, in what order, and using what table to external files. The application provides up to 14 processing steps any one of which can be selected to perform any of the particular tasks. It is up to the user to select these steps in some logical order. The specifics of the processing steps will be discussed next. Here, the overall controls are outlined.

1 Status Area

Status Area The status areas provide two items of information when the program is running. First, it provides a running time line showing how low the step has taken. Second, it provides a clickable icon with a status report should the step produce any errors or warnings. This icon is in the form of a round question mark. A check mark is used if the step is completed without incident.

[Top]

2 Step Enable Switch

Step Enable Switch The enable switch turns the entire step ON or OFF. Use this as a master control for each step to disable it when not needed.

[Top]

3 Step Name

Step Name This button, when pressed, causes that step to execute. Normally you would only manually press it when debugging your script (when you press the GO button at the bottom of the page, then all the active steps are executed in turn for you). The label of the button can be changed by the overall formatting style changes and it is typically used to describe the step.

[Top]

4 Process Step Selector

Proces Step Selector This drop drown menu selects which of the processing steps will be executed in this step of the recipe.

[Top]

5 Section Label

Section Label This drop drown menu selects what label will be used in the created section of the step. Many processing steps create numbered entries and this label will form the root of any such label. For example, if the menu selection is the text string "a" the entries will be created as a1, a2, a3, etc.
[Top]

6 File Name

File Name This control allows entering a file name for those process steps that require the use of an external file. The B (Browse...) button bring up the normal file open Dialog to assist the user. This control is often used for included files and is displayed only when such a file is needed.

[Top]

7 Table Name

Table Name This control allows selecting a table name for those process steps that require the use of a database table. Often the nominal table name is pre-selected. This is often used for database tables rendered into sections in the final document, and is displayed only when such a table is needed.

[Top]


Process Step Selection

Process Step Selection

Process Step Selection

The 1st Word tool provides a choice of 17 processing choices that each of the steps can be set to. This section provides a list of what each of these process choices does and provides some general comments on their use. Typically you will assemble these steps into some finite fixed order typical for your SDO's publishing habits.

The Overall Formatting Style section should default most of the settings to what you normally want or need. If this is no longer correct due to evolving need or habits - just ask, we can change the buttons to provide whatever default setup you prefer.

The process choices available at this time are as follows:

Acronyms The Acronyms found in the selected table (typically the Acronyms table) is rendered into a tabular list of Acronyms. Title and text strings found in the Misc Text table are rendered as the section title and preamble using the style settings found for each. Requires a valid table be selected.

Begin Document Setup Establishes basic style settings with the target document. Sets header, footer, watermark, and other details. Tags insertion point for later TOC entries.

Data Elements The data concepts found in the selected table (typically the Data Elements table) are rendered into a numbered section of data concepts. The initial title and text strings found in the Misc Text table for this step are rendered as the section title and preamble using the style settings found for each. Each data concept is given its own title based on its name and the type of record that it is (message, data frame, data element etc.). Each entry is rendered according to the current options settings. If the data concept is NOT in the same FADD as the current default FADD, then its mapping is listed. If the options have selected a used in list of associated data concepts, the tables enabled in the Dialog will be used to determine relationships. Typically three bookmarks are made for each entry as well (the entry itself, the ASN, and the XML). A wide variety of rendering styles can be selected; see the Options Area for further details. Requires a valid table to be selected.

Data Frames The data concepts found in the selected table (typically the Data Frames table) are rendered into a numbered section of data concepts. The initial title and text strings found in the Misc Text table for this step are rendered as the section title and preamble using the style settings found for each. Each data concept is given its own title based on its name and the type of record that it is (message, data frame, data element etc.) Each entry is rendered according to the current options settings. If the data concept is NOT in the same FADD as the current default FADD, then its mapping is listed. If the options have selected a used in list of associated data concepts, the tables enabled in the Links... Dialog will be used to determine relationships. Typically three bookmarks are made for each entry as well (the entry itself, the ASN, and the XML). A wide variety of rendering styles can be selected; see the Options Area for further details. Requires a valid table to be selected.

Deprecated Entries The data concepts found in the selected table (typically the Deprecated table) are rendered into a numbered section of data concepts. The initial title and text strings found in the Misc Text table for this step are rendered as the section title and preamble using the style settings found for each. Each data concept is given its own title based on its name and the type of record that it is (message, data frame, data element etc.) Each entry is rendered according to the current options settings. If the data concept is NOT in the same FADD as the current default FADD, then its mapping is listed. If the options have selected a used in list of associated data concepts, the tables enabled in the Links... Dialog will be used to determine relationships. Typically three bookmarks are made for each entry as well (the entry itself, the ASN, and the XML). A wide variety of rendering styles can be selected; see the Options Area for further details. Requires a valid table to be selected.

Dialogs The data concepts found in the selected table (typically the Dialog s table) are rendered into a numbered section of data concepts. The initial title and text strings found in the Misc Text table for this step are rendered as the section title and preamble using the style settings found for each. Each data concept is given its own title based on its name and the type of record that it is (message, data frame, data element etc.) Each entry is rendered according to the current options settings. If the data concept is NOT in the same FADD as the current default FADD, then its mapping is listed. If the options have selected a used in list of associated data concepts, the tables enabled in the Links... Dialog will be used to determine relationships. Note that one does not expect to see Dialog s link to other entries in this way, so this should be empty. A wide variety of rendering styles can be selected; see the Options Area for further details. Requires a valid table to be selected.

Do Nothing A void step. No changes in the document occur.

External Entries The data concepts found in the selected table (typically the EternalDEs table) are rendered into a numbered section of data concepts. The initial title and text strings found in the Misc Text table for this step are rendered as the section title and preamble using the style settings found for each. Each data concept is given its own title based on its name and the type of record that it is (message, data frame, data element etc.) Each entry is rendered according to the current options settings. If the data concept is NOT in the same FADD as the current default FADD, then its mapping is listed. Note that with External Entries this is typically the case. If the options have selected a used in list of associated data concepts, the tables enabled in the Links... Dialog will be used to determine relationships. Typically three bookmarks are made for each entry as well (the entry itself, the ASN, and the XML). A wide variety of rendering styles can be selected; see the Options Area for further details. Requires a valid table to be selected.

Include File The selected file is included in the current document at the current selection point. The styles of the included document are NOT used (the style of the master document being built takes precedence). Commonly used for adding content that is not created from the database tables. Requires a valid file and path to be selected.

ITIS Phrases A processing step used to render the sub-categories used in ITIS codes. The various natural language sentences found in this standard are actually created here in this step as well as adjusting what code values are not reserved for national use with each edition.

Link All Files Used in multiple-document rendering runs. This step uses the dynamic list of bookmarks and linkages which was built up over multiple documents and performs the hyper linking resolution using that list. Thus, each document is cross linked to others in its family in one step. Note that, unlike the Multi-linker tool, this step does not require the re-naming of the files with temporary names until the last linking step is performed.

Messages The data concepts found in the selected table (typically the Messages table) are rendered into a numbered section of data concepts. The initial title and text strings found in the Misc Text table for this step are rendered as the section title and preamble using the style settings found for each. Each data concept is given its own title based on its name and the type of record that it is (message, data frame, data element etc.) Each entry is rendered according to the current options settings. If the data concept is NOT in the same FADD as the current default FADD, then its mapping is listed. If the options have selected a used in list of associated data concepts, the tables enabled in the Links... Dialog will be used to determine relationships. Typically three bookmarks are made for each entry as well (the entry itself, the ASN, and the XML). A wide variety of rendering styles can be selected; see the Options Area for further details. Requires a valid table to be selected.

Next File Used in multiple-document rendering runs. This step closes the current document, and opens the next document (using the same template files). The dynamic list of linkages (bookmarks) continues to be built, hence spanning over multiple documents when completed.

Pause A way to stop the script to allow manual intervention of some type. A modal Dialog is displayed asking the user to continue. This Dialog may also prompt the user regarding what they are supposed to be doing during this pause.

Start Word Default first step. Used to establish the automation between the application and the MS Word instance. Confirms existence of the needed basic styles in the template document. Deletes the old copy of the target file, if it exists.

Terms The terms found in the selected table (typically the Terms table) are rendered into a numbered list of terms. Title and text strings found in the Misc Text table are rendered as the section title and preamble using the style settings found for each. Requires a valid table be selected.

TOC Finish The TOC and Finish step adds some final time stamps, appends a table of contents (TOC) at the insertion point determined during the initial phases, and then builds up all the hyperlinks for the document (if selected). The process of building the hyperlinks is typically the longest phase of the entire process, exceeding all the other phases combined. The basic algorithm being applied here is to seek for any possible place an existing bookmark could connect to and to place a hyperlink there. This involves an exhaustive search over the document for matching strings found in conjunction with the right style and in the proper code context. When completed, the TOC is updated to reflect page changes and the document rendering is then finally completed.

A few remarks about the technical details of the hyperlinking process in document creation, which is somewhat counter intuitive in nature. When an entry is created from a data concept, a hyper link "bookmark" is also created for it (in fact there are typically three of them, the top of the entry itself, the ASN and the XML each have a link entry). There are some problems to overcame with name collisions here, which can result in a number being appended to the actual bookmark used. This is all that occurs when the entry is added to the word document (the links are calculated and the the used-in linking text is added at this time as well as well formed text but no links are yet preset). The next entry is processed until the end of that table or section is reached. Note that in fact the 1st Word tool can not actually link to the other sections at this point because those other sections may not have been written out to the document yet. The actual linking is done in the clean up part of the process, typically the last step of the run. At this point each and every bookmark that was created is used to seek over the entire document for places that hyper-links could be placed. This is the visible jumping about you see at the end of the document run. The initial matching process uses a combination of the string itself and the Word text/paragraph style that the string appears in. This allows the document author to sew together not only the ASN/XML of the standard also but any document sections with code fragments or examples that he wants to (simply by controlling the style sheet that was used). When a "match" is found the tool uses the same parser logic found in Mini-Edit to extract the surrounding text and determine if the local context is a valid instance of the name (not a sub string and not inside some kind of code comment, and matching any proper name space, etc). If all this checks out, a hyper-link is placed into the document. Note that this produces links both "up" to other data concepts that use the entry and "down" to other data concepts used by and found within the listing. Note that besides the ASN/XML and records, the tool can link to terms and acronyms in this way as well; see the Options page. You can also use a Multi-linker tool to link to the standard from other external documents, the long term intent of this is to allow linking back to the relevant pages of a standard from other documents. So, in summary, the process of link creating is a bit bass-ackwards from what people might expect.


Process Steps, typical order

Process Steps, typical order

Process Steps, typical order

The overall order in which the steps occur is not critical. What is important is that you determine a collection of settings and adopt them uniformly building the document from start to end. For example the order Dialogs to Messages to Data Frames to Data Elements (big to little as shown here) or the reverse order. Interject steps to add any external files as needed.

At this point, each SDO has some established habits they tend to follow. If you have not used the tool before, ask others working for that SDO for help. It is typically easier to modify existing documents in this respect than to create new ones.

Do not render the same table content more than once. The tool allows this but it is a very bad engineering practice to specify something in more than one place, even if you are using automation such as 1st Word to ensure that they remain in sync.

Render the hyperlink step last after creating and placing into the document all of the other text which you wish to link.

If a rendering run has produced a result you do not expect or want, you need not wait for all steps to render. Simply kill the Word program and the automation will cease. This will abort the 1st Word tool but you will not damage your database or imported files and in fact it is an effective way to capture a partially rendered document for further review (the 1st Word tool saves the work in progress about every 50 records or so).


Options Area

Options Area

The Processing Options Area controls many aspects of how the database is rendered into a printed document. These check boxes deal primarily which how data concepts are rendered into sections. The settings affect all tables rendered; if you wish to use different values for each section you must run the tool one step at a time, and change the settings between each step as needed.

The overall flow and layout of the control matches the rendering order used for most entries. The description, a natural language section, is followed by the two code sections (ASN and XML) which are then followed by the remarks, any formula text, any representations class terms, alternative names and other meta data. A section of linkage relationships is built up and inserted for each entry using the Links... tables and then expressed according the settings. This provides linkage to other data concepts in the standard which make use of the current data concept. The ASN or XML provides (by inspection) a list of who is used in the data concept. Hyperlinking to these entries can be built in a variety of ways as well.

Finally, some running statistics about the document complexity are kept. These can be appended to the end of each section or step if enabled (useful in debugging).

This section provides additional information regarding the effect of setting these controls.

1 Proof Read Only

Proof Read Only Enable this switch when rendering a document for use by a proof reader who does not want to see the technical codes (ASN or XML) of the document. This switch will disable the ASN or XML for each entry; in effect you will get a document containing mostly the descriptive text and the remarks sections. This can be very useful when producing a smaller document for focused proofreading use.
[Top]

2 Include Figures

Include Figures Typically leave enabled. This switch allows the inclusion of figures and graphics in the build process. In time it will also allow adding UML models and other images to data concepts. Today it is mostly the terms entries that use figures. If a figure file can not be found, the file name and path that was searched will be stated in the final document
[Top]

3 OID in Titles

OID in Titles Add the OID value, if one is present, into the title for the entry.

[Top]

4 Suppress Watermark

Supress Watermark Suppress the watermark found in the Misc Text for this database when checked. This may or may not have the effect of removing the watermark. If the template document has a watermark, then that will be left untouched. When unchecked, the watermark text is taken from the Misc Text table and is used to replace the current watermark in the template document.

[Top]

5 Add Use Text

Add Use Text When checked, the description (or use) text is rendered at the start of the data concept.

[Top]

6 Add ASN

Add ASN When checked, the ASN fields (ASN Name, Data Type, Valid Value Rule, and Message Body) are all combined into proper ASN and rendered out into a mono-spaced font.

[Top]

7 ADD XML

ADD XML When checked, the XML fields (XML Tag, XML-Schema) are all combined into proper XML and rendered out into a mono-spaced font.

[Top]

8 Add Formula

Add Formula When checked, any content in the formula field is rendered out (if present). This is one of the fields that is most often empty, so unless there is content in the specific record being rendered, you will not see anything.

[Top]

9 Add Representation Class Data

Add Representation Class Data When checked, any content in the representation class term field is rendered out (if present). This is one of the fields that is most often empty, so unless there is content in the specific record being rendered, you will not see anything.

[Top]

10 Add Alternative Names

Add Alernative Names When checked, any content in the alternative name field is rendered out (if present). This is one of the fields that is most often empty, so unless there is content in the specific record being rendered, you will not see anything.

[Top]

11 Add Registry ID Values

Add Registry ID Values When checked, any content in various registry value fields are rendered out (if present), including the ID value. This is one of the fields that is most often empty, so unless there is content in the specific record being rendered, you will not see anything.

[Top]

12 Add Harmonization Notes

Add Hamonization Notes When checked, any content in the harmonization notes field is rendered out (if present). This is one of the fields that is most often empty, so unless there is content in the specific record being rendered, you will not see anything. This field is used by data stewards to coordinate comments on each others work.

[Top]

13 Include Source Document Data

Include Source Document Data When checked, any content in the source field is rendered out (if present). This is used to print the full and complete name of the standard when needed.

[Top]

14 Set tables for linking

Set tables for linking This button brings up the Links.. Dialog which is used the same as the Links Table in the Mini-Edit tool. The tables selected will be used in the Used In linking calculations. The only difference is that in the 1st Word tool only the standard table names are presented to be selected (standards are all built using well known table names, hence user defined names are not used).

[Top]

15 Control Link Reporting

Control Link Reporting This section controls how the links found in the Links... table are processed in building the document. First, if links are to be provided in the document, the Include Cross Links switch should be enabled. The underlying switches control aspects of the style and what links are reported.

If the switch Link Msgs is enabled, a summary of all top level messages that use the current data concept will be printed. If the switch Recursive is also enabled, every message data concept will also be tested for use by other messages and all found will be listed.

If the switch Add ASN/XML Names is enabled, the proper names of the ASN and XML entry for the data concept will be listed after the descriptive names. If not enabled, only the descriptive name of the entry that uses the current data concept will be listed

If the switch Terse Style Code Text is enabled, and the text of the ASN or XML name is changed into a hyper link, then the full name of the data concept is replaced with the phrase ASN or XML to produce a shorter and more readable listing. This can be more pleasing than listing the descriptive name, followed by the full ASN name, followed by the full XML name when in fact these names are the same string.

If the switch Unused Entries Cause Warning is enabled, any data concept that DOES NOT have cross links AND are not message record types or Dialog record types, produces a warning to examine it further. Such records are questionable in a standard, where every data concept is expected to be used by something or else the question arises why is it there? This switch is typically used as a debug test by stewards.

If the switch Append Final Text Line is enabled, a rather generic line is appended to each listing mentioning a cautionary warning that the data concept may in fact be used by other standards and efforts not reflected here.

[Top]

16 Control hyperlinks

Control hyperlinks This section controls how the bookmarks created during the preceding document build process are processed to create hyperlinks for the document. A variety of hyperlinks can be built up with these bookmarks, depending on what is checked. Note that the bookmarks are placed into the document event if no links are ever created. In theory, this would allow another program to post-process the document if the need arose. The overall hyper linking process is controlled by the Process Hyper Links switch. If this switch is off, no linking will occur, if on linking will occur and the underlying switches control the formatting and what will be linked.

If the switch Record Entries is enabled, linking will occur to places that mention the record by name, linking to the beginning of that record entry. Typically, this will be the list of used-in places. But any place with the right string and text style could be linked.

If the switch ASN.1 Entries is enabled, linking will occur to places that mention the records ASN by name, linking to the beginning of that record entry. Typically, this will only be in other well formed code segments. But any place with the right string and text style could be linked.

If the switch In Text is enabled, linking will occur to places that mention the records ASN by name, linking to the beginning of that record entry. If this option is set, any place with the right string and style could be linked.

If the switch Anywhere is enabled, linking will occur to places that mention the records ASN by name, linking to the beginning of that record entry. If this option is set, any place with the right string and normal text style could be linked.

If the switch XML Entries is enabled, linking will occur to places that mention the records XML type by name, linking to the beginning of that record entry. Typically, this will only be in other well formed code segments. But any place with the right string and text style could be linked.

If the switch In Text is enabled, linking will occur to places that mention the records XML by name, linking to the beginning of that record entry. If this option is set, any place with the right string and style could be linked.

If the switch Anywhere is enabled, linking will occur to places that mention the records XML by name, linking to the beginning of that record entry. If this option is set, any place with the right string and normal text style could be linked.

If the switch Acronyms is enabled, linking will occur to textual places that mention the acronym entry by name, linking to the beginning of that acronym entry and displaying its meaning in the tool tip for that link. If this option is set, any place with the right string and style could be linked.

If the switch Terms is enabled, linking will occur to textual places that mention the terms name, linking to the beginning of that term entry and displaying a short portion of its meaning in the tool tip for that link. If this option is set, any place with the right string and style could be linked.

If the switch Suppress Tool Tip Text is enabled, then a short summary of the descriptive text entry is not loaded into the tool tip for that link.

[Top]

17 Add Remarks

Add Remarks When checked, the Remarks text is rendered for the data concept. If the item Insert Remarks after Use Text is enabled, the remarks follows the description text area. Otherwise, it follows after the Used-In section of text.

[Top]

18 Processing Statistics

Processing Statistics The processing statistics display a number of counters regarding how complex the document is becoming. These include how many database records were used to produce the document, the document page count, how many document style changes were needed, and how many bookmarks and links were created.

[Top]


File not found Dialog

File not found Dialog

File not found Dialogue

During the pre-flight testing the program seeks for any file your script will be using in the run. If these files can not be found, you are alerted to that fact during the pre-flight testing.

Messages similar to the above are displayed. Provide the file (or browse to the file and select it) and try again.


Tables to link to Dialog

Tables to link to Dialog

Tables to link to Dialogue

Works the same as the Link Table set in the Mini-Edit tool. See that page for details.

<-LAST TOP


Multi_Linker

Glossary Item Box

Getting Started: Getting Started

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

Support Annexes: Support Annexes

1st Word Tool Guide: 1st Word Users Guide

See Also MEdit Send comments on this topic.

Multi_Linker

Multi_Linker

The Multi-Linker is a simple utility tool used to add hyperlinks from one document into another. It is used to build up complex multi-document sets where the hyperlinks span between each document. The standards developing organizations use it to create multiple document families. Deployments can use it to link back to a standard from their own deployment documents. Hence a local deployment (or another standard) can refer to a specific page or entry in one of the national standards in its own work.

In order to use this tool you need two things. First, have a link set file produced when the document you want to link to is created (typically produced as a by-product of running 1st Word). The link set file contains a complete listing of every possible place in the subject document that you might link to (called bookmarks in Microsoft terminology, this tool creates the hyperlink that in turn points to a bookmark).

These are XML files named XX_linkSet.xml - where XX is the name of the document you produced with 1st Word. Second, have a bit of foresight. In order to use relative bookmarks in the Microsoft system you must know the final name of the document you will be linking to, hence you need to think this out ahead of time. If you change the name of a document in a set of linked documents, the linking which points to that document will no longer work. This is a Microsoft design issue.

Over time it is expected that publishing and cross-linking pages of the standards will be achieved with HTML web technologies and shared pages published to a common place, rather then embedded bookmarks and hyperlinks in MS Word.

The structure of the Multi_Linker

Main Window
File Selection
Controls and Options

NEXT->

See Also

Getting Started: Getting Started

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

Support Annexes: Support Annexes

1st Word Tool Guide: 1st Word Users Guide


Main Window

Main Window

The Multi-Linker is a simple utility tool used to add hyperlinks from one document into another. It is used to build up complex multi-document sets where the hyperlinks span between each document. The standards developing organizations use it to create multiple document families. Deployments can use it to link back to a standard from their own deployment documents. In this way, a local deployment can refer to a specific page or entry in one of the national standards in its own work.

In order to use this tool you need two things. First, have a link set file produced when the document you want to link to is created. The link set file contains a complete listing of every possible place in the subject document that you might link to (called bookmarks in Microsoft terminology, this tool creates the hyperlink that in turn points to a bookmark). These are XML files named XX_linkSet.xml - where XX is the name of the document you produced. See the annex for a short example. Second, have a bit of foresight. In order to use relative bookmarks in the Microsoft system you must know the final name of the document you will be linking to, hence you need to think this out ahead of time. If you change the name of a document in a set of linked documents, the linking to that document will no longer work. This is a Microsoft design Over time it is expected that publishing and cross-linking pages of the standards will be achieved with HTML web technologies rather then embedded bookmarks and hyperlinks in Microsoft Word.

1 File Controls

File Controls These controls select which document will receive the links, what it will be called when completed, and to where the links go (the target file and its links map). For additional information, see <link>.
[Top]

2 Multi-File Controls

Multi-File Controls These controls are not used at this time. They are (eventually) intended to be able to bind together multiple related files in one operation (today each file you wish to link to must be run individually).
[Top]

3 Action Log Window

Action Log Window This window displays the actions taking place as linking occurs. It is effectively a detailed status summary.
[Top]

4 Status Summary

Status Summary This text label displays the overall status of the program.
[Top]

5 Settings and Controls

Settings and Controls Various control options, similar to those found in 1st Word are here, as well as the button to start the process. Further information on their use can be found here.
[Top]


File Selection

File Selection

These controls select which document will receive the links, what it will be called when completed, and to where the links go (the target file and its link map). In all cases, a Browse button is provided which will display the normal Windows file open Dialog to allow the user to select the file.

1 File to Process

File to Process The MS Word document which will have links added to it. Often a document the deployment user has created, which follows the normal 1st Word style sheet conventions so that linking will occur in the proper places. It is also possible for stewards to link a standards document in this way. In the case of guidance documents (users guides, example use fragments, code samples, etc.) that are not produced by 1st Word, this can be quite useful.

If the document is a standard with its own internal links (bookmarks) and was NOT linked when produced by 1st Word the Link-to-Self button can be used to generate internal links with this tool after the fact. Again, the normal style settings will be followed to determine where linking should occur.

[Top]

2 File, New Name

File, New Name The name of the final document is placed here. Note that you need to think about what the document will be called if any other document will in turn link to it. You can not change the name of an MS Word document once other documents link to it without losing those links.
The name will be filled in automatically when you select the document which will have the links added to it, using the word “new” at the end of the document name

If the file exist and the Overwrite check box is checked, the old file will be overwritten.
[Top]

3 Link Map File

Link Map File The link set to be used, an XML document which contains a listing of all the links in the target file that may have hyperlinks pointing to them. You can edit this list if the need arises in any XML editor. Once the file is selected, the name of the target files (the original MS Word document to which these links refer) will be filled in from the XML data.

The format of this XML file is very simple, here is an example of such a file should you wish to learn about its format and parse it directly yourself: http://www.itsware.net/miniedit/help/Example_linkSet.xml

[Top]

4 Target File (file to link to)

Target File (file to link to) The target file (the file to which the link points). If you have selected the link set file, then it will be filled in for you. Otherwise, select the MS Word document where the links will resolve to.
[Top]


Controls and Options

Controls and Options

Controls and Options

  1. The controls and options section of the tool determines WHAT will be linked (and what will not be linked).
    It follows the same general layout of the 1st Word tool.

    In order for a link to be made, three conditions must all be met:

    1. The bookmark must exist in the target document, and be reflected in the link set data.

    2. The document to be linked must have the matching phrase and it must occur in text of
    the proper style (as well as not be a sub string, or a different namespace, etc.).

    3. The type of link (ASN, XML, Acronyms or Terms) must be enabled in the option of this tool.

    If a link does not occur where you expect it to, it is a result of one of these three things.

1 Verbose Control

Verbose Control The verbose button, when checked, adds additional debugging information to a document to aid in determining why a link is not occurring as expected. This typically produces a document so full of debugging clutter as to be of no value to the end user.
[Top]

2 Terse Control

Terse Control The terse button controls how the text of listed entries in the used-in (linking) section is rendered.

In some document styles (SAE ATIS for example) it is customary to replace the full length name of the ASN or XML entry (which is often the same as the descriptive name that just preceded it in a listing of all the used by locations) with a short term of ASN or XML and then move the full name of the entry to a tool tip for that link. The Terse style code text option allows this behavior to occur.

This produces shorter and more readable standards when in Word or on-line, but can be confusing to others if the hyperlinks are subsequently removed (in which case named entries seem to have ASN, XML following them for no apparent reason, this being the location where previously a hyperlink was placed).
[Top]

3 HyperLinks Control

HyperLinks Control The following Hyperlink buttons allow further detailed control of what will be linked.

Record Entries [Default ON]
If checked, then links between records (typically the name of the record in the Used-In text) will be linked

ASN.1 Entries in ASN [Default ON]
If Link is checked, then proper occurrences of the ASN string name between sections of ASN.1 (in the code style) will be linked. If Anywhere is checked, then any matching ASN phrase (regardless of enclosing style) will be linked. The anywhere case defaults to OFF.

XML Entries in XML [Default ON]
If Link is checked, then proper occurrences of the XML string name between sections of XML (in the code style) will be linked. If Anywhere is checked, then any matching XML phrase (regardless of enclosing style) will be linked. The anywhere case defaults to OFF.

Acronyms [Default ON]
If checked, then any matching string in the normal text area will be linked back to the Acronyms entry and the acronym will be displayed as a tool tip.

Terms [Default ON]
If checked, then any matching string in the normal text area will be linked back to the Terms entry.

[Top]

4 Processing Statistics

Processsing Statistics Processing statistics are displayed in the same way as in the 1st Word document as the work progresses. The terminology is slightly different because the links are loaded from the link map rather then built up as the process proceeds, but otherwise it is the same.
[Top]

5 Command Buttons

Command Buttons The Link to Selected Documents button is the go button for the tool.

The View Final Result button will launch the final word file to view it when done.

The Quit button will exit the program.
[Top]

<-LAST TOP


Support Annexes

Glossary Item Box

Getting Started: Getting Started

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker

See Also MEdit Send comments on this topic.

Support Annexes

Support Annexes

This section provides additional information that advanced users and data stewards may need to manage their data entries and better control the output of the tool.

The structure of the Support Annexes

ASN Keyword List
XML Tempate Types
Example Reports
Misc. Text Keywords

NEXT->

See Also

Getting Started: Getting Started

Installation Issues: Installation Issues

Mini-Edit Tool Guide: Mini Edit Tool Guide

Processing Rules: Processing Rules Reference

Registry Parser: Registry Parser

1st Word Tool Guide: 1st Word Users Guide

Multi-Linker: Multi_Linker


ASN Keyword List

ASN Keyword List

ASN Keyword List

A variety of keywords are used in the comment section of the ASN found in each record to control the formatting of the XML translation process. This section documents the existing keywords and their proper use. It should be noted that these keywords are somewhat unique to the ITS industry, and are not widely support by others.

General remarks:
All keywords are made up of the following simple pattern:

[white space] -- [keyword] [white space] [end of line]

The double dash of ASN starts the comment area, and it ends with a CR-LF. Note that all keywords fit inside the standard comment areas of an ASN production. They do not share that comment line with any other comments. All keywords are a single token (no white space) and compound thoughts are denoted by complex keywords run together to form a single word.

The keyword applies to the ASN statement or production which immediately precedes it in most cases.

ASN.1 Keywords List

Additional control over the ASM to XML translation is provided by placing keywords in the comment areas of the ASN. The presence of these words controls the XML pattern that is selected in the translation and thereby allows a greater control on how the resulting XML looks. Most of these controls deal with dropping extra tags from the XML that are perceived as unneeded. The resulting template pattern can be found in the table XML_Templates in the MEdit_Settings.mdb file or in the help files here.

Contents

The LOCAL_CONTENT keyword 1
The UNTAGGED keyword 2
The CHOICE_SET keyword 3
The ATTRIB keyword 4

The LOCAL_CONTENT keyword

This term is used whenever an extension in the local schema for that FADD is needed. It is analogous to the ... found in ASN and often appears near it at the end of the ASN production. It can be used both in complex sets such as sequences, and in simple sets such as enumerations or bit-strings. Note the line <xs:restriction base="local:ExamplEnum" /> in the below.
Typical use

ExamplEnum ::= ENUMERATED {

     itemOne       (0),

     itemTwo       (1),

     ... -- # LOCAL_CONTENT

     }

     -- values to 127 reserved for std use

     -- values 128 to 255 reserved for local use

Resulting XML:

<xs:simpleType name="ExamplEnum" >

<xs:annotation>

<xs:appinfo>

itemOne (0)

itemTwo (1)

</xs:appinfo>

<xs:documentation>

values to 127 reserved for std use

values 128 to 255 reserved for local use

</xs:documentation>

</xs:annotation>

<xs:union>

<xs:simpleType>

<xs:restriction base="xs:unsignedInt">

<xs:minInclusive value="0"/>

<xs:maxInclusive value="1"/>

</xs:restriction>

</xs:simpleType>

<xs:simpleType>

<xs:restriction base="xs:string">

<xs:enumeration value="itemOne"/>

<xs:enumeration value="itemTwo"/>

</xs:restriction>

</xs:simpleType >

<xs:simpleType>

<xs:restriction base="local:ExamplEnum" />

</xs:simpleType>

</xs:union>

</xs:simpleType>

The local keyword does not always result in a different template pattern, sometimes it simply inserts the local stub as an element in a sequence. In the primitive types, such as enumerated or bit string, it results in a pattern with the name _LOCAL.

The UNTAGGED keyword

This term is used whenever the outer structures of an ASN production should be suppressed in the resulting XML structures. This occurs with multi-deep nested productions and this keyword can apply to SEQUENCE statements in the middle of the production. It can not apply to the outmost or inner most structure.

Note the lines

<xs:element name="myInnerSruct" >
<xs:complexType>

are not found in the XML below, the keyword has suppressed them and flattened the XML production. This can be useful when you are import a data frame from another place and wish to use it without tags.

Typical use

MyStruc ::=  SEQUENCE {

   itemOne       Cat,

   itemTwo       Dog,

   myInnerSruct  SEQUENCE {

      item1      Frog,

      item2      Pig

      } -- # UNTAGGED

   }

Resulting XML:

<xs:complexType name="MyStruc" >

      <xs:sequence>

         <xs:element name="itemOne" type="Cat" />

         <xs:element name="itemTwo" type="Dog" />

         <xs:sequence>

            <xs:element name="item1" type="Frog" />

            <xs:element name="item2" type="Pig" />

         </xs:sequence>

      </xs:sequence>

</xs:complexType>

Keywords which have untagged in their name typically result in a pattern with NOTAG in the template name. Note that patterns with range restrictions (i.e. Size(1..10)) typically have two such patterns, one with the range restriction and one without, as well as the variants without the UNTAGGED use.

The CHOICE_SET keyword

This term can also be used with the SEQUENCE statement in a slightly different form. The normal interpretation of CHOICE in ASN is to select only one item, while XML allows more then one item (a set of choices). Hence the semantic meaning between sequence and choice becomes a bit blurred under these conditions. Use of this keyword causes the sequence statement to be rendered as a multi element choice.

The format of the keyword is slightly different from the others, because the very last item represents the numerical value for the choice, as in:

-- # CHOICE _SET=1 or UNTAGGED_CHOICE_SET=1
-- # CHOICE_SET=2 or UNTAGGED_CHOICE_SET=2
-- # CHOICE_SET=3 or UNTAGGED_CHOICE_SET=3 etc...

Here is an example showing its use both with and without the UNTAGGED keyword as well.
Typical use

TCIP-TestD ::=  SEQUENCE{

   which       SEQUENCE {

      locationsA   LRMS.PointLocation   OPTIONAL,

      featuresA    CPTGenericIden       OPTIONAL

      } -- # UNTAGGED_CHOICE_SET=1

   which2       SEQUENCE {

      locationsB   LRMS.PointLocation   OPTIONAL,

      featuresB    CPTGenericIden       OPTIONAL

      } -- # CHOICE_SET=1

   }

   (WITH COMPONENTS {...locationsA PRESENT}|

    WITH COMPONENTS {...featuresA PRESENT})

Resulting XML:

<xs:complexType name="TCIP-TestD" >

      <xs:sequence>

         <xs:complexType>

            <xs:choice minOccurs="1">

               <xs:element name="locationsA" type="lrms:PointLocation"  minOccurs="0"/>

               <xs:element name="featuresA" type="CPTGenericIden"  minOccurs="0"/>

            </xs:choice>

         </xs:complexType>

         <xs:element name="which2" >

            <xs:complexType>

               <xs:choice minOccurs="1">

                 <xs:element name="locationsB" type="lrms:PointLocation"  minOccurs="0"/>

                 <xs:element name="featuresB" type="CPTGenericIden"  minOccurs="0"/>

               </xs:choice>

            </xs:complexType>

         </xs:element>

      </xs:sequence>

</xs:complexType>

The ATTRIB keyword

This term is used whenever a simple element in the ASN is to be rendered as an attribute in the resulting XML. Keep in mind that attributes are generally not used in ITS and that the order in which they appear in usage is non-deterministic. The element chosen must meet all the rules for XML attribute use (i.e. of simple type, etc.). Typically these elements are listed at the end of the ASN production.
Typical use

MyStruc ::=  SEQUENCE {

   itemOne       Cat,

   itemTwo       Dog,

   itemThree     Frog,          -- # ATTRIB

   itemFour      Pig OPTIONAL,  -- # ATTRIB

   }

Resulting XML:

<xs:complexType name="MyStruc" >

      <xs:sequence>

         <xs:element name="itemOne" type="Cat" />

         <xs:element name="itemTwo" type="Dog" />

         <xs:attribute name="itemThree" type="Frog"  use="required"/>

         <xs:attribute name="itemFour" type="Pig" />

      </xs:sequence>

</xs:complexType>


XML Template Types

XML Template Types

XML Tempate Types

A variety of standardized templates are used in the process of converting ASN to its XML equivalent. This section documents the existing templates and their proper use. It should be noted that for the complex templates (such as a sequence) that other templates will be found inside them and the process builds up the final XML production in steps. In general each leaf that is pared out of the ASN produces one similar entry in the final XML. Indenting each part, as well as rendering various restrictions and trimming away unused section of the template, is handled by the Mini-Edit tool.

The current XML templates a user has can always be found in the table XML_Templates of the MEdit_Settings.mdb file.

tag

text

base_binary

<xs:simpleType name="binary">

   <xs:restriction base="xs:string">

      <xs:pattern value="[01]*"/>

   </xs:restriction>

</xs:simpleType>

base_boundedSring

<xs:simpleType name="BoundedString" $OCCURS$>

   <xs:restriction base="xs:string">

      <xs:maxLength value="255"/>

      <xs:minLength value="1"/>

   </xs:restriction>

</xs:simpleType>

base_numString

<xs:simpleType name="NumericString" $OCCURS$>

   <xs:restriction base="xs:string">

      <xs:pattern value="\d*"/>

   </xs:restriction>

</xs:simpleType>

base_octet

<xs:simpletype name="OctetStringOptions">

   <xs:union memberTypes="xs:hexBinary xs:base64Binary"/>

</xs:simpleType>

<xs:complexType name="OctetString">

   <xs:simpleContent>

      <xs:extension base="OctetStringOptions">

         <xs:attribute name="EncodingType" use="required">

            <xs:simpleType>

               <xs:restriction base="xs:NMTOKEN">

                  <xs:enumeration value="hexBinary"/>

                  <xs:enumeration value="base64Binary"/>

               </xs:restriction>

            </xs:simpleType>

         </xs:attribute>

      </xs:extension>

   </xs:simpleContent>

</xs:simpletype>

base_undefined

<xs:simpletype name="UndefinedElement"/>

begin

<?xml version="1.0" encoding="UTF-8"?>

<xs:schema xmlns:xs="http://www.w3.org/2001/XMLSchema">

BIT STRING

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="binary">

         <xs:minLength value="$MIN_LENGTH$"/>

         <xs:maxLength value="$MAX_LENGTH$"/>

         <xs:length value="$ONLY_LENGTH$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

BIT STRING COMPLEX

<xs:$TYPE$ name="$NAME$-item" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:union>

         <xs:simpleType>

            <xs:restriction base="xs:int">

               <xs:minInclusive value="$MIN_VALUE$"/>

               <xs:maxInclusive value="$MAX_VALUE$"/>

            </xs:restriction>

         </xs:simpleType>

         <xs:simpleType>

            <xs:restriction base="xs:string">

               <xs:enumeration value="$ENUM_STRING_VALUE$"/>

            </xs:restriction>

         </xs:simpleType >

      </xs:union>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

<xs:simpleType name="$NAME$">

   <xs:list itemType="$NAME$-item"/>

</xs:simpleType>

BIT_STRING_COMPLEX_LOCAL

<xs:$TYPE$ name="$NAME$-item" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:union>

         <xs:simpleType>

            <xs:restriction base="xs:int">

               <xs:minInclusive value="$MIN_VALUE$"/>

               <xs:maxInclusive value="$MAX_VALUE$"/>

            </xs:restriction>

         </xs:simpleType>

         <xs:simpleType>

            <xs:restriction base="xs:string">

               <xs:enumeration value="$ENUM_STRING_VALUE$"/>

            </xs:restriction>

         </xs:simpleType >

         <xs:simpleType>

            <xs:restriction base="local:$COMPLEX_NAME$" />

         </xs:simpleType>

      </xs:union>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

<xs:simpleType name="$NAME$">

   <xs:list itemType="$NAME$-item"/>

</xs:simpleType>

BIT_STRING_LOCAL

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:union>

         <xs:simpleType>

            <xs:restriction base="binary">

               <xs:minLength value="$MIN_LENGTH$"/>

               <xs:maxLength value="$MAX_LENGTH$"/>

               <xs:length value="$ONLY_LENGTH$"/>

            </xs:restriction>

         </xs:simpleType>

         <xs:simpleType>

            <xs:restriction base="local:$COMPLEX_NAME$" />

         </xs:simpleType>

      </xs:union>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

BOOLEAN

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:boolean"/>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

bottom

<!--  -->

<!-- The final few items are global types used by other entires -->

<!--  -->

<xs:simpleType name="binary">

   <xs:restriction base="xs:string">

      <xs:pattern value="[01]*"/>

   </xs:restriction>

</xs:simpleType>

<xs:simpleType name="OctetStringOptions">

   <xs:union memberTypes="xs:hexBinary xs:base64Binary"/>

</xs:simpleType>

<xs:complexType name="OctetString">

   <xs:simpleContent>

      <xs:extension base="OctetStringOptions">

         <xs:attribute name="EncodingType" use="required">

            <xs:simpleType>

               <xs:restriction base="xs:NMTOKEN">

                  <xs:enumeration value="hexBinary"/>

                  <xs:enumeration value="base64Binary"/>

               </xs:restriction>

            </xs:simpleType>

         </xs:attribute>

      </xs:extension>

   </xs:simpleContent>

</xs:complexType>

<xs:simpleType name="NumericString">

   <xs:restriction base="xs:string">

      <xs:pattern value="\d*"/>

   </xs:restriction>

</xs:simpleType>

bottomFirst

<!--  -->

<!-- These items are added the schema file by the export routines -->

<!-- The below entries are provided to "patch" to common items  -->

<!-- which ideally will be properly defined in other namesspaces  -->

<!--  -->

<xs:complexType name="xxx"/>  <!-- add others as needed -->

CHOICE

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:choice>

         $INSERT_HERE$

      </xs:choice>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

CHOICE-NOTAG

<xs:choice $OCCURS$>

   $INSERT_HERE$

</xs:choice>

<!-- $ASN_COMMENTS$ -->

complex_type

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:sequence minOccurs="0" maxOccurs="unbounded">

         <xs:element name="$SUB_NAME$" type="xs:$SUB_TYPE$"/>

      </xs:sequence>

   </xs:$SUBTYPE$>

</xs:$TYPE$>  <!-- is this used anymore? -->

customImports

$CUSTOM_IMPORTS$

customNamespaces

<xs:schema targetNamespace="http://www.$NAMESPACE$-$MAIN_RELEASE_TYPE$-$MAIN_REVISION_STRING$"

   xmlns="http://www.$NAMESPACE$-$MAIN_RELEASE_TYPE$-$MAIN_REVISION_STRING$"

   xmlns:xs="http://www.w3.org/2001/XMLSchema"

   $CUSTOM_NAMESPACES$

   elementFormDefault="unqualified"

   attributeFormDefault="unqualified"

   version="DRAFT">

<!-- add for each space you define: xmlns:$NAME$="http://www.$NAME$-$RELEASE_TYPE$-$REVISION_STRING$ -->

customWSDLNamespaces

<xs:schema targetNamespace="http://www.$NAMESPACE$-$MAIN_RELEASE_TYPE$-$MAIN_REVISION_STRING$"

   xmlns="http://www.$NAMESPACE$-$MAIN_RELEASE_TYPE$-$MAIN_REVISION_STRING$"

   xmlns:xs="http://www.w3.org/2001/XMLSchema"

   xmlns:c2c="http://www.c2c-adopted-01-00-00"

   xmlns:ftp="http://schemas.ntcip.org/wsdl/ftp/"

   xmlns:http="http://schemas.xmlsoap.org/wsdl/http/"

   xmlns:mime="http://schemas.xmlsoap.org/wsdl/mime/"

   xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/">

   $CUSTOM_NAMESPACES$

   elementFormDefault="unqualified"

   attributeFormDefault="unqualified"

   version="DRAFT">

<!-- add for each space you define: xmlns:$NAME$="http://www.$NAME$-$RELEASE_TYPE$-$REVISION_STRING$ -->

defined_type

<xs:$TYPE$ name="$NAME$" type="$DEF_TYPE$" $OCCURS$>

end

</xs:schema>

ENUMERATED

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:union>

         <xs:simpleType>

            <xs:restriction base="xs:unsignedInt">

               <xs:minInclusive value="$MIN_VALUE$"/>

               <xs:maxInclusive value="$MAX_VALUE$"/>

            </xs:restriction>

         </xs:simpleType>

         <xs:simpleType>

            <xs:restriction base="xs:string">

               <xs:enumeration value="$ENUM_STRING_VALUE$"/>

            </xs:restriction>

         </xs:simpleType >

      </xs:union>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

ENUMERATED_ITIS

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:union>

          <xs:simpleType>

            <xs:restriction base="xs:unsignedInt">

               <xs:minInclusive value="$MIN_VALUE$"/>

               <xs:maxInclusive value="$MAX_VALUE$"/>

            </xs:restriction>

         </xs:simpleType>

         <xs:simpleType>

            <xs:restriction base="xs:string">

               <xs:enumeration value="$ENUM_STRING_VALUE$" id="_$ENUM_ID_VALUE$"/>

            </xs:restriction>

         </xs:simpleType >

         <xs:simpleType>

            <xs:restriction base="xs:string">

               <xs:pattern value="\[.+\].*"/>

            </xs:restriction>

         </xs:simpleType>

         <xs:simpleType>

            <xs:restriction base="local:$COMPLEX_NAME$" />

         </xs:simpleType>

      </xs:union>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

ENUMERATED_ITIS-test

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:union>

         <xs:simpleType>

            <xs:restriction base="xs:unsignedInt">

               <xs:minInclusive value="$MIN_VALUE$"/>

               <xs:maxInclusive value="$MAX_VALUE$"/>

            </xs:restriction>

         </xs:simpleType>

         <xs:simpleType>

            <xs:restriction base="xs:string">

               <xs:enumeration value="$ENUM_STRING_VALUE$" id="_$ENUM_ID_VALUE$"/>

            </xs:restriction>

         </xs:simpleType >

         <xs:simpleType>

            <xs:restriction base="xs:string">

               <xs:pattern value="\[.+\].*"/>

            </xs:restriction>

         </xs:simpleType>

         <xs:simpleType>

            <xs:restriction base="local:$COMPLEX_NAME$" />

         </xs:simpleType>

      </xs:union>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

ENUMERATED_LOCAL

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:union>

         <xs:simpleType>

            <xs:restriction base="xs:unsignedInt">

               <xs:minInclusive value="$MIN_VALUE$"/>

               <xs:maxInclusive value="$MAX_VALUE$"/>

            </xs:restriction>

         </xs:simpleType>

         <xs:simpleType>

            <xs:restriction base="xs:string">

               <xs:enumeration value="$ENUM_STRING_VALUE$"/>

            </xs:restriction>

         </xs:simpleType >

         <xs:simpleType>

            <xs:restriction base="local:$COMPLEX_NAME$" />

         </xs:simpleType>

      </xs:union>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

error_bottom

</errors>

error_top

<?xml version="1.0" encoding="UTF-8"?>

<!--Begin export of errors and warnings found -->

<errors>

external

<xs:$TYPE$ name="wxyz" type="wxyz:SpecialType"/>

<!--Does not seem right???  From 4.23 -->

   <xs:annotation>

      <xs:appinfo>

         $APP_INFO$

      </xs:appinfo>

      <xs:documentation>

         $ASN_COMMENTS$

      </xs:documentation>

   </xs:annotation>

</xs:$TYPE$>

IA5String

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:string">

         <xs:minLength value="$MIN_LENGTH$"/>

         <xs:maxLength value="$MAX_LENGTH$"/>

         <xs:length value="$ONLY_LENGTH$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

importADUS

<xs:import namespace="http://www.adus-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="adus.xsd"/>

importATIS

<xs:import namespace="http://www.atis-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="atis.xsd"/>

importC2C

<xs:import namespace="http://www.c2c-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="c2c.xsd"/>

importDSRC

<xs:import namespace="http://www.dsrc-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="dsrc.xsd"/>

importHPMS

<xs:import namespace="http://www.hpms-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="hpms.xsd"/>

importIM

<xs:import namespace="http://www.im-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="im.xsd"/>

importITIS

<xs:import namespace="http://www.itis-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="itis.xsd"/>

importJXDD

<xs:import namespace="http://www.jxdd-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="jxdd.xsd"/>

importLocal

<xs:import namespace="http://www.$OWNER$-local-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="$OWNER$-local.xsd"/>

importLRMS

<xs:import namespace="http://www.lrms-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="lrms.xsd"/>

importNTCIP

<xs:import namespace="http://www.ntcip-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="ntcip.xsd"/>

importRSPA

<xs:import namespace="http://www.rspa-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="rspa.xsd"/>

imports

<!--  HAND EDIT THE ABOVE SECTION TO REMOVE ANY NAMESPACEs YOU DO NOT NEED -->

<!--  HAND EDIT THE ABOVE SECTION TO REMOVE ANY NAMESPACEs YOU DO NOT NEED -->

<!--  HAND EDIT THE ABOVE SECTION TO REMOVE ANY NAMESPACEs YOU DO NOT NEED -->

<!--  HAND EDIT THE ABOVE SECTION TO REMOVE ANY NAMESPACEs YOU DO NOT NEED -->

<!-- The two sections should match (remove items from both as needed) -->

<!--  HAND EDIT THIS SECTION TO REMOVE ANY NAMESPACEs YOU DO NOT NEED -->

<!--  HAND EDIT THIS SECTION TO REMOVE ANY NAMESPACEs YOU DO NOT NEED -->

<!--  HAND EDIT THIS SECTION TO REMOVE ANY NAMESPACEs YOU DO NOT NEED -->

<!--  HAND EDIT THIS SECTION TO REMOVE ANY NAMESPACEs YOU DO NOT NEED -->

<!--  Where do you get the file with this namespace, of the form:

      <xs:import namespace="AboveURI" schemaLocation="$PATH$/$NAME$.xsd" />

      which must match the namespace you defined above as well -->

<xs:import namespace="http://www.lrms-0-0-0" schemaLocation="$PATH$/lrms.xsd"/>

<xs:import namespace="http://www.itis-0-0-0" schemaLocation="$PATH$/itis.xsd"/>

<xs:import namespace="http://www.tcip-0-0-0" schemaLocation="$PATH$/tcip.xsd"/>

<xs:import namespace="http://www.tmdd-0-0-0" schemaLocation="$PATH$/tmdd.xsd"/>

<xs:import namespace="http://www.atis-0-0-0" schemaLocation="$PATH$/atis.xsd"/>

<xs:import namespace="http://www.adus-0-0-0" schemaLocation="$PATH$/adus.xsd"/>

<xs:import namespace="http://www.hpms-0-0-0" schemaLocation="$PATH$/hpms.xsd"/>

<xs:import namespace="http://www.dsrc-0-0-0" schemaLocation="$PATH$/dsrc.xsd"/>

<xs:import namespace="http://www.im-0-0-0" schemaLocation="$PATH$/im.xsd"/>

<xs:import namespace="http://www.ntcip-0-0-0" schemaLocation="$PATH$/ntcip.xsd"/>

importTCIP

<xs:import namespace="http://www.tcip-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="tcip.xsd"/>

importTMDD

<xs:import namespace="http://www.tmdd-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="tmdd.xsd"/>

importUNITS

<xs:import namespace="http://www.units-$RELEASE_TYPE$-$REVISION_STRING$" schemaLocation="units.xsd"/>

Incomplete

<!-- WARNING  The XML is not complete and needs further refinement -->

INTEGER_ALL

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:int">

         <xs:minInclusive value="$MIN_VALUE$"/>

         <xs:maxInclusive value="$MAX_VALUE$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

INTEGER_BYTE

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:byte">

         <xs:minInclusive value="$MIN_VALUE$"/>

         <xs:maxInclusive value="$MAX_VALUE$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

INTEGER_SHORT

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:short">

         <xs:minInclusive value="$MIN_VALUE$"/>

         <xs:maxInclusive value="$MAX_VALUE$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

INTEGER_UNSIGNED_BYTE

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:unsignedByte">

         <xs:minInclusive value="$MIN_VALUE$"/>

         <xs:maxInclusive value="$MAX_VALUE$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

INTEGER_UNSIGNED_INT

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:unsignedInt">

         <xs:minInclusive value="$MIN_VALUE$"/>

         <xs:maxInclusive value="$MAX_VALUE$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

INTEGER_UNSIGNED_SHORT

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:unsignedShort">

         <xs:minInclusive value="$MIN_VALUE$"/>

         <xs:maxInclusive value="$MAX_VALUE$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

ITISandTEXT

<!--  This template is not yet ready to use -->

<!--  Still developing the logic for this one -->

<!-- it will be a struc with the text tags and the enum

     for the allowed subset of ITIS to be used -->

ITIScodes

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:union>

         <xs:simpleType>

            <xs:restriction base="xs:unsignedInt">

               <xs:minInclusive value="$MIN_VALUE$"/>

               <xs:maxInclusive value="$MAX_VALUE$"/>

            </xs:restriction>

         </xs:simpleType>

         <xs:simpleType>

            <xs:restriction base="xs:string">

               <!-- the following subset of the ITIS codes shall be used -->

               <xs:enumeration value="$ENUM_STRING_VALUE$"/>

            </xs:restriction>

         </xs:simpleType >

      </xs:union>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

Local_ENUMERATED

<xs:simpleType name="$NAME$">

   <xs:restriction base="xs:string">

      <xs:enumeration value="insert-local-values-here"/>

   </xs:restriction>

</xs:simpleType>

Local_SEQUENCE

<xs:complexType name="$NAME$">

   <xs:sequence>

      <xs:element name="yourName"  minOccurs="0">

         <xs:simpleType>

            <xs:restriction base="xs:string">

               <xs:length value="10"/>

            </xs:restriction>

         </xs:simpleType>

      </xs:element>

      <!-- Insert instance name and Type of each elements here,

           and any restrictions that are needed. -->

   </xs:sequence>

</xs:complexType>

namespaces

<xs:schema targetNamespace="http://www.Edit-$NAMESPACE$-$MAIN_RELEASE_TYPE$"

   xmlns="http://www.Edit-$NAMESPACE$-$MAIN_REVISION_STRING$"

   xmlns:xs="http://www.w3.org/2001/XMLSchema"

   xmlns:lrms="http://www.lrms-0-0-0"

   xmlns:itis="http://www.itis-0-0-0"

   xmlns:tcip="http://www.tcip-0-0-0"

   xmlns:tmdd="http://www.tmdd-0-0-0"

   xmlns:atis="http://www.atis-0-0-0"

   xmlns:adus="http://www.adus-0-0-0"

   xmlns:hpms="http://www.hpms-0-0-0"

   xmlns:dsrc="http://www.dsrc-0-0-0"

   xmlns:ntcip="http://www.ntcip-0-0-0"

   xmlns:im="http://www.im-0-0-0"

   elementFormDefault="unqualified"

   attributeFormDefault="unqualified"

   version="DRAFT">

<!-- add for each space you define: xmlns:$NAME$="http://www.$NAME$-$RELEASE_TYPE$-$REVISION_STRING$ -->

No_errors

<Summary>

<Results>   No Errrors or Warnings were found.

</Results>

</Summary>

None

<!--  No pattern available for this item    -->

<!--  Suggest you manually edit this entry  -->

nsADUS

xmlns:adus="http://www.adus-$RELEASE_TYPE$-$REVISION_STRING$"

nsATIS

xmlns:atis="http://www.atis-$RELEASE_TYPE$-$REVISION_STRING$"

nsC2C

xmlns:dsrc="http://www.dc2c-$RELEASE_TYPE$-$REVISION_STRING$"

nsDSRC

xmlns:dsrc="http://www.dsrc-$RELEASE_TYPE$-$REVISION_STRING$"

nsHPMS

xmlns:hpms="http://www.hpms-$RELEASE_TYPE$-$REVISION_STRING$"

nsIM

xmlns:im="http://www.im-$RELEASE_TYPE$-$REVISION_STRING$"

nsITIS

xmlns:itis="http://www.itis-$RELEASE_TYPE$-$REVISION_STRING$"

nsJXDD

xmlns:jxdd="http://www.jxdd-$RELEASE_TYPE$-$REVISION_STRING$"

nsLocal

xmlns:local="http://www.$OWNER$-local-$RELEASE_TYPE$-$REVISION_STRING$"

nsLRMS

xmlns:lrms="http://www.lrms-$RELEASE_TYPE$-$REVISION_STRING$"

nsNTCIP

xmlns:ntcip="http://www.ntcip-$RELEASE_TYPE$-$REVISION_STRING$"

nsRSPA

xmlns:units="http://www.rspa-$RELEASE_TYPE$-$REVISION_STRING$"

nsTCIP

xmlns:tcip="http://www.tcip-$RELEASE_TYPE$-$REVISION_STRING$"

nsTMDD

xmlns:tmdd="http://www.tmdd-$RELEASE_TYPE$-$REVISION_STRING$"

nsUNITS

xmlns:units="http://www.units-$RELEASE_TYPE$-$REVISION_STRING$"

NULL

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

NumericString

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:string">

         <xs:pattern value="\d*"/>

         <xs:minLength value="$MIN_LENGTH$"/>

         <xs:maxLength value="$MAX_LENGTH$"/>

         <xs:length value="$ONLY_LENGTH$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

OBJECT-IDENTIFIER

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:string"/>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

OCTET_STRING

<xs:$TYPE$ name="$NAME$" type="UndefinedElement"  $OCCURS$/>

OCTET_STRING_RANGED

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:simpleContent>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:extension base="$NAME$-string" >

         <xs:attribute name="EncodingType" use="required">

           <xs:simpleType>

              <xs:restriction base="xs:NMTOKEN">

                 <xs:enumeration value="$ENCODING$"/>

              </xs:restriction>

           </xs:simpleType>

         </xs:attribute>

      </xs:extension>

   </xs:simpleContent>

</xs:$TYPE$>

<xs:simpleType name="$NAME$-string">

   <xs:restriction base="xs:$ENCODING$">

      <xs:minLength value="$MIN_LENGTH$"/>

      <xs:maxLength value="$MAX_LENGTH$"/>

      <xs:length value="$ONLY_LENGTH$"/>

   </xs:restriction>

</xs:simpleType >

OCTET_STRING_RANGEDx

<xs:$TYPE$ name="$NAME$" EncodingType="$ENCODING$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="OctetString" >

         <xs:minLength value="$MIN_LENGTH$"/>

         <xs:maxLength value="$MAX_LENGTH$"/>

         <xs:length value="$ONLY_LENGTH$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

path

http://www.itsware.net/xml

PrintableString

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:string">

         <xs:pattern value="[0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!@#$%^&*()_+|,./<>?;':"[]{}]*"/>

         <xs:minLength value="$MIN_LENGTH$"/>

         <xs:maxLength value="$MAX_LENGTH$"/>

         <xs:length value="$ONLY_LENGTH$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

REAL

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

   <xs:annotation>

      <xs:documentation>

          $ASN_COMMENTS$

      </xs:documentation>

   </xs:annotation>

   <xs:restriction base="xs:float">

      <xs:minInclusive value="$MIN_VALUE$"/>

      <xs:maxInclusive value="$MAX_VALUE$"/>

   </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

<!-- Warning, above may need hand editing -->

<!-- observe that min-max restrictions have -->

<!-- not been added to this template yet -->

scrap_bottom

</scrap>

</xs:schema>

scrap_top

<?xml version="1.0" encoding="UTF-8"?>

<xs:schema targetNamespace="http://www.SCRAP-0-0-0"

   xmlns="http://www.SCRAP-0-0-0"

   xmlns:xs="http://www.w3.org/2001/XMLSchema"

   xmlns:lrms="http://www.lrms-0-0-0"

   xmlns:itis="http://www.itis-0-0-0"

   xmlns:tcip="http://www.tcip-0-0-0"

   xmlns:tmdd="http://www.tmdd-0-0-0"

   xmlns:atis="http://www.atis-0-0-0"

   xmlns:adus="http://www.adus-0-0-0"

   xmlns:hpms="http://www.hpms-0-0-0"

   xmlns:dsrc="http://www.dsrc-0-0-0"

   xmlns:ntcip="http://www.ntcip-0-0-0"

   xmlns:im="http://www.im-0-0-0"

   elementFormDefault="qualified"

   attributeFormDefault="unqualified"

   version="SCRAP_DRAFT">

<!--Begin export -->

<scrap>

SEQUENCE

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:sequence>

         $INSERT_HERE$

      </xs:sequence>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

SEQUENCE-NOTAG

<xs:sequence>

   $INSERT_HERE$

</xs:sequence>

SEQUENCE-OF

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:sequence minOccurs="0" maxOccurs="unbounded">

        $INSERT_HERE$

      </xs:sequence>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

SEQUENCE-OF-NOTAG

<xs:element name="$NAME$"  type="$INSERT_HERE$" minOccurs="$MIN_LENGTH$" maxOccurs="unbounded" />

<!-- $ASN_COMMENTS$ -->

SEQUENCE-OF-NOTAG-COMPLEX

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:sequence minOccurs="$MIN_LENGTH$" maxOccurs="$MAX_LENGTH$">

         $INSERT_HERE$

      </xs:sequence>

   </xs:$SUBTYPE$>

</xs:$TYPE$>  <!-- not sure about above template -->

SEQUENCE-OF-RANGED

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:sequence minOccurs="$MIN_LENGTH$" maxOccurs="$MAX_LENGTH$">

         $INSERT_HERE$

      </xs:sequence>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

SEQUENCE-OF-RANGED-NOTAG

<xs:element name="$NAME$"  type="$INSERT_HERE$" minOccurs="$MIN_LENGTH$" maxOccurs="$MAX_LENGTH$" />

<!-- $ASN_COMMENTS$ -->

SEQUENCE-TO-CHOICE

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:choice minOccurs="$MIN_VALUE$">

        $INSERT_HERE$

      </xs:choice>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

SEQUENCE-TO-CHOICE-NOTAG

<xs:choice minOccurs="$MIN_VALUE$">

   $INSERT_HERE$

</xs:choice>

<!-- $ASN_COMMENTS$ -->

SET

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:sequence>

         $INSERT_HERE$

      </xs:sequence>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

top

<?xml version="1.0" encoding="UTF-8"?>

top_Level

<xs:$TYPE$ name="$NAME$"  type="$NAME$">

topAnnotate

<xs:annotation>

   <xs:documentation>

      $TEXT$

   </xs:documentation>

</xs:annotation>

TypeDef

<xs:$TYPE$ name="$NAME$" type="$DEF_TYPE$" $OCCURS$>

</xs:$TYPE$>

TypeDef_ATTRIB

<xs:$TYPE$ name="$NAME$" type="$DEF_TYPE$" $OCCURS$>

</xs:$TYPE$>

TypeDef_COMPLEX

<xs:complexType name="$NAME$" $OCCURS$>

    <xs:complexContent>

      <xs:annotation>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:extension base ="$DEF_TYPE$"/>

    </xs:complexContent>

</xs:complexType>

TypeDef_RANGED

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base ="$DEF_TYPE$">

         <xs:minInclusive value="$MIN_VALUE$"/>

         <xs:maxInclusive value="$MAX_VALUE$"/>

         <xs:minLength value="$MIN_LENGTH$"/>

         <xs:maxLength value="$MAX_LENGTH$"/>

         <xs:length value="$ONLY_LENGTH$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>

UTF8String

<xs:$TYPE$ name="$NAME$" $OCCURS$>

   <xs:$SUBTYPE$>

      <xs:annotation>

         <xs:appinfo>

            $APP_INFO$

         </xs:appinfo>

         <xs:documentation>

            $ASN_COMMENTS$

         </xs:documentation>

      </xs:annotation>

      <xs:restriction base="xs:string">

         <xs:minLength value="$MIN_LENGTH$"/>

         <xs:maxLength value="$MAX_LENGTH$"/>

         <xs:length value="$ONLY_LENGTH$"/>

      </xs:restriction>

   </xs:$SUBTYPE$>

</xs:$TYPE$>


Example Reports

Example Reports

This section shows a simple example of the bulk report format created by running the tool on the two data concepts used as examples in this guide.

This type of document is normally created by running a report from the Mini-Edit tool using the Reports button from the main screen. This will use a file called Bulk_Template.doc and some basic MS Word automation to render the entire contents of the currently selected table into a report. Like the 1st Word tool, it is import that MS Word not be engaged in editing any other document when this is created, as the tool needs to completely take over MS Word for the period it is running.

The link below will load a Microsoft Word document to your machine from the web.
You should have Microsoft Word installed in order to view it.

Typical Bulk Report style document showing two data concepts.

Use your browser's back button when done viewing this page.

The bulk report format is provided in Mini-Edit for those users (non stewards) do do not have access to the 1st Word tool so that they can make reports (with less features) somewhat like the richly formatted documents that SDOs produce.


Misc. Text Keywords

Misc. Text Keywords

Misc. Text Keywords

A variety of standardized MiscText keyword entries are created by the tool, typically for use in document rendering with 1st Word. This section provides a reference for the basic keywords and their suggested typical use in publishing a document.

Keep in mind that the precise string for the keyword may vary if you are publishing a document with multiple Volumes involved. For example, the common keyword DocumentTitle becomes the keyword DocumentTitle_01 for volume one in such cases.

watermark

Default value:

Document Watermark

Style:

Normal

Use:

The side-turned background watermark text

link

Default value:

www.ITSware.net/-None

Style:

Normal

Use:

Used in the document header section to provide a URL location where the most current edition of the document can always be found. Set this to your committee home page if you do not offer this service.

Prepared

Default value:

Prepared by Someone credit to go here

Style:

Normal

Use:

Used to state who prepared the document. Most standards say something like: ABC company prepared this document for the XYZ committee under the direction of the (some oversight committee) of the SDO.

Header

Default value:

Put your header text here

Style:

Normal

Use:

The header to be used in the document goes here.

Footer

Default value:

Put your footer text here

Style:

Normal

Use:

The footer to be used in the document goes here.

DefaultFADD

Default value:

UNKNOWN

Style:

Normal

Use:

The FADD to which these tables belong is listed here from among the std FADD names. This value is used in naming the XML export files and also in formatting the title to data concepts in 1st Word (items not matching this FADD are treated as external entries).

RevLastSet

Default value:

0-0-0

Style:

Normal

Use:

The revision string of the current edition of the standard, 00-00-00 is the value used when no value has yet been provided.

RevMajor

Default value:

0

Style:

Normal

Use:

The major revision of the standard, established by the SDO.

RevMinor

Default value:

0

Style:

Normal

Use:

The minor revision of the standard, established by the SDO.

RevIncrement

Default value:

0

Style:

Normal

Use:

The incremental revision of the standard, established by the SDO. Typically, this is an ever increasing value.

UserSite

Default value:

www.YourSite.xxx/

Style:

Normal

Use:

The user deployment service point, used for service endpoints in the WSDL mappings.

UserFolder

Default value:

ITSschemas/

Style:

Normal

Use:

Where on the users machine (under the current application) the schema sets will be placed.

Docsfolder

Default value:

docs/

Style:

Normal

Use:

Where on the users machine (under the current application and current user folder) the documentation sets of web page records will be placed.

ProductionSchemas

Default value:

http://www.ITSware.net/XML/readme.htm

Style:

Normal

Use:

Where to obtain authoritative production releases of the schemas for this FADD.

Subject to change if we ever re-establish a working registry again.

Copyright

Default value:

Put your Copyright text here

Style:

Normal

Use:

Used to hold the copyright assignment notice used with this standard.

DocumentTitle

Default value:

Document Title goes here

Style:

title (note case)

Use:

Used to hold the formal title of this standard.

Step_XX_Text

Default value:

Any intro text dealing with step X goes here.

Style:

Normal

Use:

Used by each step to provide some text after the title for that step.

Step_XX_Title

Default value:

The section title of step X goes here

Style:

Heading 1 (Other Heading X values may be used as well)

Use:

Used by each step to provide a title to the section it is creating.

<-LAST TOP


Empty Index Entry

Empty Index Entry

The index entry you selected has no target topics associated with it.

If you have chosen a parent entry, please select a child entry.


Topic Not Found

Topic Not Found

The link you just clicked was not able to connect to the target page.

Some possible reasons and remedies are as follows:

Reason | Remedy
Destination topic is not part of the area you specified in the Filtered by field. | Either select another filter or select (no filter).
The URL of the destination topic is incorrect or has changed. | Use the index or the search function instead.
Problems with the help installation. | Rerun Setup for the product this help is related to and select the 'Repair' option.

Additional help is available for filters, search, and the index.

Click Back to return to the page you were on.

The target parameters are:

Keyword:
Index Moniker:
URL:


Glossary

A | B | C | D | E | F | G | H | I | J | K | L | M | N | O | P | Q | R | S | T | U | V | W | X | Y | Z

A

Acronyms
Acronyms are kept in the Acronyms table and typically used to produce a table of terms found in the standard. These terms may be hyper linked throughout the resulting final standard as well

ASN
Abstract Syntax Notation One (often also abbreviated as ASN.1) This is the language used to expresses the structures of the data concepts in conformance with IEEE 1488/89, ISO 14817, and International conventions which the US is a party.

C

CHM
The help files are stored as *.chm when used by the tools as on-line help. CHM is a compressed form of HTML.

Complex Data Concepts
Complex elements which are in turn made up of a combination of complex elements and simple elements.

D

Data Concept
A generic term, referring to a record in the tables regardless of the record type that it is or what content it contains.

Data Dictionary
A collection of data concepts (both simple and complex) organized into some useful collection, often along functional lines. See also FADD. Most ITS message set standards are in fact data dictionaries supporting a specific area of use.

Data Element
A record type with a simple data concept.

Data Elements
One of the current standard named tables. Typically used to hold simple data element entries.

Data Frame
A record type with a complex data concept.

Data Frames
One of the current standard named tables. Typically used to hold complex data entries.

Data Stewards
A person charged and authorized by the SDO and its committee to maintains the database for that FADD or standard. This person, in the context of using Mini-Edit, has some additional rights and responsibilities over other users of the data. One of these is locking the individual records so that other users can receive an authoritative copy of the record for their own use. Typically Data Stewards are paid contractors in the employment of the committee.

Data Users
Persons using Mini-Edit who are not Data Stewards are data users.

Deleted_Records
One of the current standard named tables. Typically used to hold all types of data concepts which have been deleted from other tables. An “undo” table if you prefer.

DEs
An outdated standard table name. It contained simple data element entries. Now replaced by the standard table: Data Elements.

Dialog
A record type with a complex data concept, typically one or more messages

Dialogs
One of the current standard named tables. Typically used to hold sequences of message which form an operation of some type.

E

ExternalDEs
One of the current standard named tables. Typically used to hold all types of data concepts borrowed from other standards efforts.

F

FADD
Functional Area Data Dictionary. All message set standards map to a FADD of some sort. FADD categories are also used to organize the modules (ASN) and namespaces (XML) of ITS.

I

IEEE 1488/89
A set of data dictionary standards, literally two standards about how a data dictionary should be organized and built. The ITS message sets and Mini-Edit follow the rules established in this document for various field names and value content rules.

ISO 14817
A set of rules for data dictionary standards, largely derived from the work of IEEE 1488/89 and the practical experiences gained in US registry work and amended with international input.. The ITS message sets and Mini-Edit are beginning to follow the some of the rules established in this document for various field names and value content rules, and in doing this we are leaving behind the prior baselines established by IEEE 1488/89. Additional 14817 conformance is likely to be achieved with new features in Mini-Edit.

L

Links
Links in the context of this guide are places in the actual codes (ASN or XML) where one data concept is used by another. In data registries, this is called a relationship. In UML modeling the phrase "is used by" is found. So in these tools: if entryA is used by entryB, there would be a link shown from entryA to entryB which the tool dynamically detects and reports IF the ASN is well formed and IF the table that entryB resides in is one of those that will be checked for links.

Local Deployment
A user of the national ITS standards.

Local Entries
One of the current standard named tables. Typically used to hold all types of data concepts which can be used locally as an expansion point or as local customization to the standard. Typically you will not find this type of records in national standards and if you do it will be a generic local stub.

Local Stubs
Local Stubs are ASN and XML extensions to the national standard placed into the standards to expressly provide each local deployment with a controlled location to extend the content present in a message, data frame, or data element. The keyword local and the ASN expansion (three periods) are ued to control this. See the Annex for additional information on use.

Locked Record
A record is locked when a data stewards locks its (by pressing the lock button). This calculates several CRC values for the records field contents. If the computed CRC of these contents does not match, then that part of the record is deemed to be unlocked and has been changed in some way since the point when it was locked. This provide a primitive but effective way for deployment users to determine if the records they are using have been changes since the SDO issued them.

M

MEdit_Settings.mdb
The file which contains all the control word lists, templates, and patterns used by the tool. This file is expected to be found in the same directory as the Mini-Edit application and will have a time stamp latter then the application.

Message

A record type with a complex data concept. Often a message can be used in a stand-alone fashion and exchanged with others (where a data frame can not).

Messages
One of the current standard named tables. Typically used to hold complete data frame which can be used as stand alone messages.

Misc Text
A Table found in all *.ITS files (and most older *.MDB files as well) which contains sets of strings and keywords used to build up the document. Much of the “boilerplate” of the document such as is title, names of section and standard preambles phrases are kept here. These value can be editing with the Quick Edit Text Table Dialog .

MiscText
The Misc_Text table is a catch-all for various bits of text use in the production fo the standard. It contains things like the document title and section titles and boiler plates as well as some meta-data such as the revision and FADD values for the standard.

Module
A module is the ASN term for an XML namespace. In ITS this is a set of well known names used to group the message sets into functional areas.

MSGs
An outdated standard table name. It contained both messages and data frame entries. Now replaced by two standard tables: Messages and Data Frames.

N

Namespace
A namespace is the XML term for an ASN module. In ITS this is a set of well known names used to group the message sets into functional areas.

P

Profile
The act of taking a national standard and further constraining it and interpreting it for use in a local deployment. Often the national standard does not specify a single way an objective is to be done, leaving it up to the local deployment to decide the practice and conventions to be followed. Other times, enumerated lists of items are either too large or too small to encompass local needs and must be amended. Still other times, the full range of elements in a structures may need to be restricted or constrained in additional ways to meet local needs. All of these acts are profiling a standard for local use. This may result in local schemas being developed, or it may result in local assumption for the schemas provided with the national standards.

R

Record Type
One of the basic type of records which a table may hold (this includes the Data Element type, the Data Frame type, the Messages Type and the Dialog type).

Release Number
Release Numbering in the Mini Edit tools follows a three-part numbering system. The first two digits (for example the 2.1 in 2.1.410) relate to the major and minor release values. The last number is the build number. This number always increases. So build 410 is followed by build 411 and so on.

S

SDO
Standards Developing Organizations. The organizations working with FHWA-JPO to develop the standards of the ITS programs, including: ASTM, APTA, ASSHTO, IEEE, ITE, NEMA, and SAE.

Simple Data Concepts
Atomic elements such as integers, enumerations, and strings, which are not made up of other types.

T

Tables
The database file which is loaded into Mini-Edit consists of several tables that hold the actual data. Many of these tables have pre-defined names such as "Data Elements" to describe their typical contents, while others can be named by the users. Most operations in Mini-Edit take place on the current record, in the current table, in the current file.

Terms
Terms are kept in the Terms table and typically used to produce a table of terms and their definitions found in the standard. These entries may be hyper linked throughout the resulting final standard as well.

TOC
Table of Contents

U

USER_Settings.mdb
The file used to contain user specific items such as the users name and privileges for each FADD. This is a fairly recent file and is expected to grow in term of content over time. This file must be present. Some of the data in this file can be edited with the Quick-Edit Text Table window.

W

WSDL
Web Services Description Language, A type of XSD schema used to specify the web endpoints for Dialog s (operations) and the messages they contain. Typically this information is kept in the Dialog s table of a file. MiniEdit exports this information from the records to build a WSDL file with the operations and root URL the users selects.

X

XML
eXtensible Markup Language The XML which appears in data concept here is typically an XML schemas (rather then an XML instance) and is used to reflect the restriction information of the ASN in its analogous XML form.


a
about
after
against
all
along
also
although
am
among
an
and
are
as
at
be
became
because
been
being
between
but
by
can
caution
come
could
details
did
do
does
doing
done
during
each
early
far
finally
for
found
from
had
has
have
he
her
here
his
how
however
I
if
in
include
including
information
into
is
it
its
late
later
made
many
may
me
med
might
more
most
near
no
non
none
nor
not
note
of
off
on
only
or
other
over
saw
see
seen
several
she
since
so
some
such
than
that
the
their
them
then
there
these
they
this
those
through
tip
to
too
under
until
up
us
use
very
warning
was
we
were
when
where
which
while
who
with
you